Intro:
	call ClrBackBuffers
	ld a,$07
	ld (TileMapData),a
	bcall(_LoadTileMap)
	call TileMap
	call Update
	
	ld b,3
	@:
		push bc
			call _Intro_mirror_or
			call _Intro_mirror_andcpl
		pop bc
		djnz {-1@}
	call _Intro_mirror_or
	
	ld hl,PlotSScreen
	call MakeBufferBlack
	ld hl,AppBackUpScreen
	call MakeBufferBlack
	
	ld hl,introSaveUs
	ld b,0
	ld c,20
	bcall(_Text)
	ld b,6
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	
	call ClrBackBuffers
	ld a,$36
	ld (TileMapData),a
	bcall(_LoadTileMap)
	call TileMap
	call Update
	ld hl,introReubenDream
	ld a,1
	call Speech
	
	
	ld b,2*8 ; laf entering
	ld h,4*8
	ld a,11*8
	@:
		push bc
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				call Update
			pop hl
			pop af
			
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				
				ld a,2
				call Sleep
				
			pop hl
			pop af
			
			dec a ; we move left
		pop bc
		djnz {-1@}
	ld b,8
	@:
		push bc
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				call Update
			pop hl
			pop af
			
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				
				ld a,2
				call Sleep
				
			pop hl
			pop af
			
			dec a ; we move left
			inc h ; and down
		pop bc
		djnz {-1@}
	ld b,5*8
	@:
		push bc
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				call Update
			pop hl
			pop af
			
			ld ix,sprites+($19*16)
			ld b,8
			
			push af
			push hl
				call GraySpriteXOR
				
				
				ld a,2
				call Sleep
				
			pop hl
			pop af
			
			dec a ; we move left
		pop bc
		djnz {-1@}
	ld hl,introLafAtReubenHouse
	ld a,1
	call Speech
	
	call ClrBackBuffers
	ld a,$4A
	ld (TileMapData),a
	bcall(_LoadTileMap)
	call TileMap
	
	ld a,3*8
	ld h,4*8
	ld b,8
	ld ix,ReubenSprites
	call GraySpriteXOR
	call Update
	
	ld hl,introLafAtRaft
	ld a,1
	call Speech
	
	call ClrBackBuffers
	ld hl,TileMapData+2
	ld de,TileMapData+3
	ld (hl),$10
	ld bc,95
	ldir
	call TileMap
	call Update
	
	ld b,2
	@:
		push bc
			ld b,$7F - $40
			@:
				push bc
					ld a,$7F - $40
					sub b
					ld b,$40
					add a,b
					out ($10),a
					call _Battle_Pause_Short
				pop bc
				djnz {-1@}
		pop bc
		djnz {-2@}
	ld a,$40
	out ($10),a
	
	ld hl,PlotSScreen
	call MakeBufferBlack
	ld hl,AppBackUpScreen
	call MakeBufferBlack
	
	ld hl,introPresents
	ld a,2
	ld b,0
	ld c,2*8
	bcall(_Text)
	
	ld b,6
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	ret
_Intro_mirror_thingy:
	.db %00011000,%00111100,%01111110,%11111111
_Intro_mirror_or:
	ld b,4
	@:
		ld c,b
		ld ix,PlotSScreen+5
		ld iy,AppBackUpScreen+5
		push bc
			ld a,4
			sub b
			ld b,a
			ld a,4*8
			sub b
			ld b,a
			@:
				ld a,4
				sub c
				ld h,0
				ld l,a
				ld de,_Intro_mirror_thingy
				add hl,de
				ld a,(ix)
				or (hl)
				ld (ix),a
				ld a,(iy)
				or (hl)
				ld (iy),a
				
				
				ld de,12
				add ix,de
				add iy,de
				djnz {-1@}
			call _Battle_Pause_Med_Long
		pop bc
		djnz {-2@}
	ret
_Intro_mirror_andcpl:
	ld b,4
	@:
		ld c,b
		ld ix,PlotSScreen+5
		ld iy,AppBackUpScreen+5
		push bc
			ld a,4
			sub b
			ld b,a
			ld a,4*8
			sub b
			ld b,a
			@:
				ld a,4
				sub c
				ld h,0
				ld l,a
				ld de,_Intro_mirror_thingy
				add hl,de
				ld a,(hl)
				cpl
				ld l,a
				ld a,(ix)
				and l
				ld (ix),a
				ld a,(iy)
				and l
				ld (iy),a
				
				
				ld de,12
				add ix,de
				add iy,de
				djnz {-1@}
			call _Battle_Pause_Med_Long
		pop bc
		djnz {-2@}
	ret

Outro:
	call ClrBackBuffers
	ld a,$05
	ld (TileMapData),a
	
	xor a
	ld (moveDirection),a
	
	bcall(_LoadTileMap)
	call TileMap
	call Update
	ld d,5*8
	ld e,5*8
	ld b,16
	@:
		push bc
			ld b,d
			ld c,e
			push de
				ld de,$FFFC
					@:
						push de
							call Earthquake_no_time
						pop de
						inc de
						xor a
						or d
						or e
						jr nz,{-1@}
			pop de
			inc e
		pop bc
		djnz {-2@}
	ld b,16
	@:
		push bc
			ld b,d
			ld c,e
			push de
				ld de,$FFFF
					@:
						push de
							call Earthquake_no_time
						pop de
						inc de
						xor a
						or d
						or e
						jr nz,{-1@}
			pop de
			dec e
		pop bc
		djnz {-2@}
	
	ld a,$40
	out ($10),a
	
	ld b,8
	@:
		push bc
			ld b,d
			ld c,e
			push de
				call _Move_Draw_Character
				ld b,0
				nop
				djnz $-1
			pop de
			inc e
		pop bc
		djnz {-1@}
	
	ld b,d
	ld c,e
	
	call _Move_Draw_Character_only_back
	push bc
		ld b,16
		@:
			push bc
				call _Outro_erase_mirror
				call _Battle_Pause_Short
				call Update
				call _Battle_Pause_Short
			pop bc
			djnz {-1@}
		call _Outro_erase_mirror
		call _Outro_erase_mirror_back
		ld ix,PlotSScreen+(63*12)+11
		ld iy,AppBackUpScreen+(63*12)+11
		ld b,64
		@:
			push bc
				ld b,12
				xor a
				@:
					ld (ix),a
					ld (iy),a
					dec ix
					dec iy
					djnz {-1@}
				call _Battle_Pause_Med
				call Update
			pop bc
			djnz {-2@}
		ld hl,outroReuben
		ld a,3
		call Speech
	pop bc
	
	call _Move_Draw_Character_only_back
	ld a,2
	ld (moveDirection),a
	call _Move_Draw_Character_only_back
	ld a,5*8 ; draw Laf
	ld h,7*8
	ld b,8
	ld ix,sprites+($19 * 16)
	call GraySpriteXOR
	call Update
	
	ld hl,outroLaf
	ld a,3
	call Speech
	
	ld d,$7F
	ld ix,SaveSScreen+(63*12)+11
	ld iy,StatVars+(63*12)+11
	ld b,(3*8)+4
	@:
		push bc
			ld a,$FF
			ld b,12
			@:
				ld (ix),a
				ld (iy),a
				dec ix
				dec iy
				djnz {-1@}
			push de
				call Update
			pop de
			ld a,d
			out ($10),a
			dec d
			push de
				call _Battle_Pause_Short
			pop de
		pop bc
		djnz {-2@}
	
	ld b,27
	ld c,53
	ld hl,end
	ld a,2
	bcall(_Text)
	ld b,6
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	
	call ClrAllBuffers
	ld a,$40
	out ($10),a
	
	ld bc,$0000
	ld hl,thanksForPlaying
	xor a
	bcall(_Text)
	ld b,4
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	
Credits:
	
	ld b,0
	ld c,3*8
	ld hl,titleScreen1
	call _Outro_Credit_Screen
	
	ld b,0
	ld c,3*8
	ld hl,titleScreen2
	call _Outro_Credit_Screen
	
	ld b,0
	ld c,(3*8)-4
	ld hl,titleScreen3
	call _Outro_Credit_Screen
	
	ld b,0
	ld c,(3*8)-4
	ld hl,titleScreen4
	call _Outro_Credit_Screen
	
	ld b,0
	ld c,(3*8)-4
	ld hl,titleScreen5
	call _Outro_Credit_Screen
	
	ld b,0
	ld c,(3*8)+4
	ld hl,titleScreen6
	call _Outro_Credit_Screen
	ld b,4
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	ret
_Outro_Credit_Screen:
	push hl
	push bc
		ld hl,PlotSScreen
		call MakeBufferBlack
		ld hl,AppBackUpScreen
		call MakeBufferBlack
	pop bc
	pop hl
	ld a,2
	bcall(_Text)
	ld b,4
	@:
		push bc
			call _Battle_Pause
		pop bc
		djnz {-1@}
	ret
_Outro_erase_mirror:
	ld ix,PlotSScreen+(3*8*12)+5
	ld iy,AppBackUpScreen+(3*8*12)+5
	ld de,12
	xor a
	ld b,16
	@:
		ld (ix),a
		ld (iy),a
		add ix,de
		add iy,de
		djnz {-1@}
	ret
_Outro_erase_mirror_back:
	ld ix,SaveSScreen+(3*8*12)+5
	ld iy,StatVars+(3*8*12)+5
	ld de,12
	xor a
	ld b,16
	@:
		ld (ix),a
		ld (iy),a
		add ix,de
		add iy,de
		djnz {-1@}
	ret
