; input: a - enemy
; returns: a==0: continue, a==1: dead
BattleEngine:
	ld b,a ; times 17 into hl
	ld hl,17
	call Multiply
	
	ld de,Enemies ; add offset
	add hl,de
	
	ld de,enemy
	ld bc,17
	ldir
	
	; Enemy done loading into ram
	xor a                 ; make sure player isn't poisoned by default
	ld (battlePoison),a
	
	ld b,2
	@:
		push bc
			ld hl,PlotSScreen
			call ClrBuffer
			ld hl,AppBackUpScreen
			call ClrBuffer
			call _Battle_Pause_Short
			call Update
			call _Battle_Pause_Short
		pop bc
		djnz {-1@}
	
	ld b,64
	@:
		push bc
			dec b
			ld h,0
			ld l,b
			ld b,12
			call Multiply
			ld d,h
			ld e,l
			ld ix,PlotSScreen
			ld iy,AppBackUpScreen
			
			add ix,de
			add iy,de
			ld b,12
			@:
				push bc
					xor a
					ld (ix),a
					ld (iy),a
					inc ix
					inc iy
				pop bc
				djnz {-1@}
			call _Battle_Pause_Short
		pop bc
		djnz {-2@}
	
	ld a,%10111110 ; listen to key groups
	out (1),a
	
	call _Battle_Draw
	call Update
	
	ld a,(enemy_lvl)
	ld b,a
	ld a,(reuben_lvl)
	sub b
	add a,10
	ld b,a
	call random
	cp 0
	jr nz,_Battle_Loop
	call _Battle_Enemy
	call _Battle_Status
	cp 0
	jr nz,_Battle_Loop_End
_Battle_Loop:
	call Update
	call _Battle_Player
	call _Battle_Status
	cp 0
	jr nz,_Battle_Loop_End
	call Update
	call _Battle_Enemy
	call _Battle_Status
	cp 0
	jr z,_Battle_Loop
_Battle_Loop_End:
	call Update
	call _Battle_Status
	cp 1
	jr z,_Battle_Enemy_Dead
	cp 2
	jr z,_Battle_Player_Dead
	xor a
	ret
_Battle_Player_Dead:
	ld bc,$4214
	xor a
	ld hl,fatal
	bcall(_Text)
	call Wait_Key_Input
	call Wait_Key_Release
	ld a,1
	ret
_Battle_Enemy_Dead:
	ld b,8
	ld h,$7F
	_Battle_Enemy_Dead_Outest_Loop:
		push bc
			ld ix,SaveSScreen+(16*12)
			ld iy,StatVars+(16*12)
			ld de,12-8
			ld b,6*8
			ld a,(enemy_id)
			cp $0F
			jr nz,_Battle_Enemy_Dead_Round_Loop
				ld ix,SaveSScreen
				ld iy,StatVars
				ld b,8*8
			_Battle_Enemy_Dead_Round_Loop:
				push bc
					push hl
						ld b,8
						@:
							push bc
								ld a,(ix)
								and h
								ld (ix),a
								ld a,(iy)
								and h
								ld (iy),a
								inc ix
								inc iy
							pop bc
							djnz {-1@}
						add ix,de
						add iy,de
						
						ld a,(enemy_id)
						cp $0F
						jr nz,{+1@}
							push de
								call Update
							pop de
						@:
					pop hl
					ld a,h
					xor $FF
					srl a
					xor $FF
					ld h,a
					cp $FF
					jr nz,{+1@}
						ld h,$7F
					@:
				pop bc
				djnz _Battle_Enemy_Dead_Round_Loop
			ld a,h
			xor $FF
			srl a
			xor $FF
			ld h,a
			push hl
				call Update
				call _Battle_Pause_Med
			pop hl
		pop bc
		djnz _Battle_Enemy_Dead_Outest_Loop
	
	ld hl,(reuben_gold)
	ld de,(enemy_lvl)
	ld d,0
	add hl,de
	ld de,999
	or a
	sbc hl,de
	jr c,{+1@}
		ld hl,999
	jr {+2@}
	@:
		add hl,de
	@:
	ld (reuben_gold),hl
	
	
	ld a,(reuben_lvl)
	cp 20
	jr nc,_Battle_Reuben_End
	ld hl,(reuben_exp)
	ld de,(enemy_exp)
	add hl,de
	ld (reuben_exp),hl
	
	ld de,(reuben_nextexp)
	sbc hl,de
	jr c,_Battle_Reuben_End
	
	ld (reuben_exp),hl ; now we have the overflow saved!
	
	ld bc,$2B14
	ld hl,lvlup
	xor a
	bcall(_Text)
	call Wait_Key_Input
	call Wait_Key_Release
	
	ld de,39    ; increase hp
	ld hl,(reuben_hp)
	add hl,de
	ld (reuben_hp),hl
	ld hl,(reuben_maxhp)
	add hl,de
	ld (reuben_maxhp),hl
	
	ld b,4      ; increase mp
	ld a,(reuben_mp)
	add a,b
	ld (reuben_mp),a
	ld a,(reuben_maxmp)
	add a,b
	ld (reuben_maxmp),a
	
	ld hl,reuben_lvl ; increase level
	inc (hl)
	
	ld hl,(reuben_nextexp)
	ld b,3
	call Multiply
	srl h
	rr l
	ld (reuben_nextexp),hl
	
_Battle_Reuben_End:
	xor a
	ret
_Battle_Status:
; Returns in a the status of the battle
; 0:continue; 1:enemy dead; 2:player dead; 3:run´
	ld hl,(enemy_hp)
	ld de,$FFFF
	xor a
	sbc hl,de
	jr z,_Battle_Status_Run
	add hl,de
	xor a ; check if hl is empty
	or h
	or l
	jr z,_Battle_Status_Enemy_Dead
	ld hl,(reuben_hp)
	xor a
	or h
	or l
	jr z,_Battle_Status_Reuben_Dead
	xor a
	jr _Battle_Status_Continue
_Battle_Status_Run:
	inc a
_Battle_Status_Reuben_Dead:
	inc a
_Battle_Status_Enemy_Dead:
	inc a
_Battle_Status_Continue:
	ret


_Battle_Player:
	ld d,0
_Battle_Player_Loop:
	ld bc,$3714 ; 55,20
	ld a,(enemy_id)
	cp $0F
	jr nz,{+1@}
		ld bc,$460A ; 70,10
	@:
	ld a,$13 ; draw the arrows
	add a,d    ; for if we are in magic menu
	push de
		push bc
		push af
			call Update
		pop af
		pop bc
		ld e,0
		bcall(_PutBigSpriteXOR)
	pop de
	push de
		call _Battle_Player_Disp_HP_MP
	pop de
	
	call Wait_Key_Input
	call Wait_Key_Release
	
	
	ld b,a
	ld a,d
	cp $00
	jr nz,{+1@}   ; magic has different actions!
	ld a,b
	and %00000001 ; down key
	jr z,_Battle_Player_Item_Menu
	ld a,b
	and %00000010 ; left key
	jp z,_Battle_Player_Attack_Normal
	ld a,b
	and %00000100 ; right key
	jp z,_Battle_Player_Run
	ld a,b
	and %00001000 ; up key
	jr z,_Battle_Player_Enter_Magic_Menu
@:
	ld a,b
	and %10000000 ; EEEEXIT!!!!!
	jr z,_Battle_Player_Exit_Magic_Menu
	ld a,b
	and $0F
	xor $0F
	jr nz,_Battle_Player_Attempt_Magic
	
	
	jr _Battle_Player_Loop
_Battle_Player_Enter_Magic_Menu:
	ld d,1
	jr _Battle_Player_Loop
_Battle_Player_Exit_Magic_Menu:
	ld d,0
	jr _Battle_Player_Loop
_Battle_Player_Attempt_Magic:
	ld a,(reuben_mp)
	sub 5
	jr c,_Battle_Player_Loop ; check if we have enough mp
	ld (reuben_mp),a
	
	ld a,b
	and %00000001 ; down key, fire
	jp z,_Battle_Player_Attack_Fire
	ld a,b
	and %00000010 ; left key, cure
	jp z,_Battle_Player_Magic_Cure
	ld a,b
	and %00000100 ; right key, bolt
	jp z,_Battle_Player_Attack_Bolt
	ld a,b
	and %00001000 ; right key, bolt
	jp z,_Battle_Player_Attack_Ice
	jr _Battle_Player_Loop
_Battle_Player_Item_Menu:
	call Update
	ld d,0 ; we want hp to be displayed
	call _Battle_Player_Disp_HP_MP


	call PickItem
	cp 4
	jp z,_Battle_Player_Loop
	
	ld c,b
	
	ld a,(hl)
	and %11111000     ; empty bottle, won't overgo check as bottle content is in c
	ld (hl),a
	
	ld a,c
	and %00000111 ; bottle is empty
	jr z,_Battle_Player_Item_Menu
	
	cp 1 ; water
	jr nz,{+1@}
	call _Battle_Reuben_Blink
	ld hl,300
	jp _Battle_Player_Inc_HP
@:
	
	cp 2 ; herb
	jr nz,{+1@}
	call _Battle_Reuben_Blink
	ld hl,600
	jp _Battle_Player_Inc_HP
@:
	
	cp 3 ; potion
	jr nz,{+1@}
	call _Battle_Reuben_Blink
	ld hl,999
	jp _Battle_Player_Inc_HP
@:
	
	cp 4 ; gigseng
	jp z,_Battle_Player_Item_Gigseng
	
	cp 5 ; elixir
	jp z,_Battle_Player_Item_Elixir
	
	cp 6 ; fire
	jp z,_Battle_Player_Attack_Fire_Item
	cp 7 ; pure
	jp z,_Battle_Player_Pure_Item
	
	jp _Battle_Player_Loop
_Battle_Player_Run:
	ld a,(enemy_sl5)
	and $01
	jr nz,{+1@} ; you can't run from boss fights!
	ret
@:
	ld b,2
	call random
	cp 1
	jr z,{+1@}
	ret
@:
	ld hl,$ffff
	ld (enemy_hp),hl
	ret
_Battle_Player_Disp_HP_MP:
	ld bc,$3736
	ld a,(enemy_id)
	cp $0F
	jr nz,{+1@}
		ld bc,$3738
	@:
	
	ld a,d
	cp 0
	
	jr nz,{+1@}
	
	ld hl,HPColon
	xor a
	push bc
		bcall(_Text)
	pop bc
	ld b,$49
	ld hl,(reuben_hp)
	xor a
	bcall(_NumText)
	ret
@:
	ld hl,MPColon
	xor a
	push bc
		bcall(_Text)
	pop bc
	ld b,$49
	ld hl,(reuben_mp)
	ld h,0
	xor a
	bcall(_NumText)
	ret
_Battle_Player_Magic_Cure:
	call Update
	call _Battle_Reuben_Jump
	call _Battle_Reuben_Blink
	ld a,(reuben_maxmp)
	ld h,0
	ld l,a
	ld b,5
	call Multiply
_Battle_Player_Inc_HP: ; requires hl
	push hl
		push hl
			call Update
		pop hl
		ld bc,$4614 ; 70,20
		xor a
		bcall(_NumText) ; hl is already set
		ld bc,$4014 ; 64,20
		ld hl,PlusSign
		xor a
		bcall(_Text)
		
		call _Battle_Pause
	pop hl
	call _Battle_Player_Add_Hp
	
	ret
_Battle_Player_Item_Gigseng:
	call Update
	call _Battle_Reuben_Blink
	ld hl,MPPlus50
	ld bc,$3414 ; 52,20
	ld a,(enemy_id)
	cp $0F
	jr nz,{+1@}
		ld bc,$4002
	@:
	xor a
	bcall(_Text)
	call _Battle_Pause
	ld b,50
	call _Battle_Player_Add_Mp
	ret
_Battle_Player_Item_Elixir:
	call Update
	call _Battle_Reuben_Blink
	ld hl,healed
	ld bc,$3614 ; 54,20
	ld a,(enemy_id)
	cp $0F
	jr nz,{+1@}
		ld c,4
	@:
	xor a
	bcall(_Text)
	ld hl,(reuben_maxhp)
	ld (reuben_hp),hl
	ld a,(reuben_maxmp)
	ld (reuben_mp),a
	call _Battle_Pause
	ret
_Battle_Player_Pure_Item:
	call Update
	call _Battle_Reuben_Blink
	ld a,(battlePoison)
	cp 1
	jr nz,{+1@}
		call _Battle_Toggle_Poison_Display
	@:
	xor a
	ld (battlePoison),a
	ld hl,cured
	ld bc,$3A14 ; 58,20
	ld a,(enemy_id)
	cp $0F
	jr nz,{+1@}
		ld c,4
	@:
	xor a
	bcall(_Text)
	call _Battle_Pause
	ret
_Battle_Player_Attack_Normal:
	
	
	ld a,$16
	ld bc,$3A27
	ld e,1
	bcall(_PutBigSpriteXOR)
	call Update
	ld bc,$3A27
	ld a,$16
	ld e,1
	bcall(_PutBigSpriteXOR)

	call _Battle_Pause_Med
	
	ld a,$17
	ld bc,$382C
	ld e,1
	bcall(_PutBigSpriteXOR)
	call Update
	ld a,$17
	ld bc,$382C
	ld e,1
	bcall(_PutBigSpriteXOR)

	call _Battle_Pause_Med
	
	ld a,$18
	ld bc,$3C2D
	ld e,1
	bcall(_PutBigSpriteXOR)
	call Update
	ld a,$18
	ld bc,$3C2D
	ld e,1
	bcall(_PutBigSpriteXOR)

	call _Battle_Pause_Med
	
	call Update
	
	
	
	ld bc,$0F27
	ld e,0
	ld a,$15
	bcall(_PutBigSpriteXOR)
	ld bc,$171A
	ld e,0
	ld a,$15
	bcall(_PutBigSpriteXOR)
	ld b,0
	call _Battle_Player_Calc_Damage
	push hl
		ld a,$15
		ld b,5
	pop hl
	push hl
		ld bc,$3410
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld c,1
		@:
		xor a
		bcall(_NumText)
		
		;call _Battle_Shake_Screen
		
		call _Battle_Pause
	pop hl
	
	call _Battle_Player_Subtract_Damage
	ret
_Battle_Player_Attack_Fire:
	call Update
	call _Battle_Reuben_Jump
	ld b,$07
	call _Battle_Fire_Animation
	ld b,1
	call _Battle_Player_Calc_Damage
	push hl
		ld bc,$3410
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld c,1
		@:
		xor a
		bcall(_NumText)
		
		call _Battle_Pause
		
	pop hl
	
	call _Battle_Player_Subtract_Damage
	ret
_Battle_Player_Attack_Ice:
	call Update
	call _Battle_Reuben_Jump
	call _Battle_Ice_Animation
	ld b,2
	call _Battle_Player_Calc_Damage
	push hl
		ld bc,$3410
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld c,1
		@:
		xor a
		bcall(_NumText)
		
		call _Battle_Pause
	
	pop hl
	
	call _Battle_Player_Subtract_Damage
	ret
_Battle_Player_Attack_Bolt:
	call Update
	call _Battle_Reuben_Jump
	ld b,$13
	call _Battle_Bolt_Animation
	ld b,3
	call _Battle_Player_Calc_Damage
	push hl
		ld bc,$3410
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld c,1
		@:
		xor a
		bcall(_NumText)
		
		call _Battle_Pause
	
	pop hl
	
	call _Battle_Player_Subtract_Damage
	ret
_Battle_Player_Attack_Fire_Item:
	call Update
	
	ld b,$07
	call _Battle_Fire_Animation
	
	ld b,4
	call _Battle_Player_Calc_Damage
	:add hl,hl
	push hl
		ld bc,$3410
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld c,1
		@:
		xor a
		bcall(_NumText)
		
		call _Battle_Pause
		
	pop hl
	
	call _Battle_Player_Subtract_Damage
	ret
_Battle_Player_Subtract_Damage:
	ld d,h ; subtract damage from enemy
	ld e,l
	ld hl,(enemy_hp)
	xor a ; make sure carry is 0
	sbc hl,de
	jr nc,{+1@}
	ld hl,0
@:
	ld (enemy_hp),hl
	ret
_Battle_Player_Add_Hp:
	ld d,h ; subtract damage from enemy
	ld e,l
	ld hl,(reuben_hp)
	or a ; make sure carry is 0
	add hl,de
	ld d,h
	ld e,l
	ld hl,(reuben_maxhp)
	or a
	sbc hl,de
	jr nc,{+1@}   ; carry means just load the max hp into current hp
		ld hl,(reuben_maxhp)
		ld (reuben_hp),hl
		ret
	@:
	
	ex de,hl
	ld (reuben_hp),hl
	ret
_Battle_Player_Add_Mp: ; b is amount to add
	ld a,(reuben_mp)
	add a,b
	jr nc,{+1@}
		ld a,(reuben_maxmp)
	@:
	ld b,a
	ld a,(reuben_maxmp)
	cp b
	jr nc,{+1@}
		ld a,(reuben_maxmp)
		ld b,a
	@:
	ld a,b
	ld (reuben_mp),a
	ret
_Battle_Player_Calc_Damage:
; calculates damage into hl
;INPUT: b=type (see variables.txt)
;enemy_lv*20/3->R
;((R/2)+(15+(rand^(5*reuben_lvl))+(2*(reuben_lvl^^2))*10)/R)->Q
	push bc
		ld hl,(enemy_lvl) ; enemy_lvl times 20 into hl
		ld h,0 ; little endian trick thingy
		
		ld d,h
		ld e,l
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,de
		add hl,de
		add hl,hl
		
		ld bc,3
		call Devide ; hl / 3 in de (out R in the upper forumla thingy)
		push de
			ld hl,(reuben_lvl) ; now we do the 2*(reuben_lvl^^2) chunk
			ld h,0
			ld b,l
			call Multiply
			add hl,hl ; *2
			
			ld a,(reuben_lvl) ; rand^(5*reuben_lvl) + 16
			ld b,a
			add a,a ; times 5
			add a,a
			add a,b
			ld b,a
			call random ; randomize
			
			add a,16 ; plus 16
			
			ld d,0 ; add them togeather!
			ld e,a
			add hl,de
			
			ld d,h ; times 10
			ld e,l
			add hl,hl
			add hl,hl
			add hl,de
			add hl,hl
			
			
		pop de
		push de
			srl d ; R/2
			rr e
			
			add hl,de
			
			
		pop de
		ld b,d ; devide by r
		ld c,e
		call Devide
	pop bc
	
	; calculte weakness and immunity
	ld h,d
	ld l,e
	
	ld a,b
	cp 4
	jr nz,{+1@} ; no fire item used, skip the *2
	add hl,hl
	ld b,1
@:
	push hl
		
		ld hl,enemy_sl1 ; load slot and add offset, value resulting in b
		ld d,0
		ld e,b
		add hl,de
		ld a,(hl)
		and $0F ; we only want the defense!
		ld b,a
	
	pop hl
	call Multiply ; multiply by weakness indicator
	ret




_Battle_Enemy:
	ld hl,enemy_sl1 ; get attack slot
	ld b,5
	call random
	ld d,0
	ld e,a
	add hl,de
	ld c,0 ; normal attack mode, no stun
	ld a,(hl)
	and $F0
	cp $00
	jr z,_Battle_Enemy_Normal_Attack
	cp $10
	jr z,_Battle_Enemy_Fire_Attack
	cp $20
	jp z,_Battle_Enemy_Bolt_Attack
	cp $30
	jp z,_Battle_Enemy_Poison_Attack
	cp $40
	jp z,_Battle_Enemy_Stun_Attack
	jr _Battle_Enemy_Normal_Attack ; if we don't know what to do then do a normal attack
_Battle_Enemy_End:
	ld a,(battlePoison)
	cp 0
	jr nz,{+1@}
	ret
@:                        ; poison!
	call Update
	ld hl,(enemy_lvl)
	ld h,0
	add hl,hl
	push hl
		call _Battle_Enemy_Subtract_Damage
	pop hl
	ld bc,$4414 ; 78,26
	xor a
	bcall(_NumText)
	
	call _Battle_Pause
	ret
_Battle_Enemy_Normal_Attack:
	push bc
		ld bc,$4327
		ld e,0
		ld a,$15
		bcall(_PutBigSpriteXOR)
		ld bc,$4B1A
		ld e,0
		ld a,$15
		bcall(_PutBigSpriteXOR)
		
		
		call _Battle_Enemy_Calc_Damage
		push hl
			call _Battle_Enemy_Subtract_Damage
		pop hl
		
		ld bc,$3C14             ; display damage
		xor a
		bcall(_NumText)
		
		call _Battle_Shake_Screen
		
		call _Battle_Pause
	pop bc
	ld a,c
	cp 0
	jr z,_Battle_Enemy_End
	push bc
	call Update
	pop bc
	ret
_Battle_Enemy_Fire_Attack:
	push bc
		ld b,$3C
		call _Battle_Fire_Animation
		call _Battle_Enemy_Calc_Damage
		add hl,hl
		push hl
			call _Battle_Enemy_Subtract_Damage
		pop hl
		
		ld bc,$3C14             ; display damage
		xor a
		bcall(_NumText)
		call _Battle_Pause
	pop bc
	ld a,c
	cp 0
	jr z,_Battle_Enemy_End
	push bc
	call Update
	pop bc
	ret
_Battle_Enemy_Bolt_Attack:
	push bc
		ld b,$4B
		call _Battle_Bolt_Animation
		
		call _Battle_Enemy_Calc_Damage
		add hl,hl
		add hl,hl
		push hl
			call _Battle_Enemy_Subtract_Damage
		pop hl
		
		ld bc,$3914             ; display damage
		ld a,(enemy_id)
		cp $0F
		jr nz,{+1@}
			ld bc,$3001
		@:
		xor a
		bcall(_NumText)
		call _Battle_Pause
	pop bc
	ld a,c
	cp 0
	jp z,_Battle_Enemy_End
	push bc
	call Update
	pop bc
	ret
_Battle_Enemy_Poison_Attack:
	push bc
		ld a,(battlePoison)
		cp 0
		jr nz,{+1@}
			call _Battle_Toggle_Poison_Display
		@:
		ld a,1
		ld (battlePoison),a
	pop bc
	ld a,c
	cp 0
	jp z,_Battle_Enemy_End
	push bc
		call Update
	pop bc
	ret
_Battle_Enemy_Stun_Attack:
	ld hl,SaveSScreen + (35*12) + 8
	ld de,12-3
	ld b,16
	@:
		ld a,(hl)
		or $10
		ld (hl),a
		inc hl
		inc hl
		inc hl
		ld a,(hl)
		or $80
		ld (hl),a
		add hl,de
		djnz {-1@}
	call Update
	
	ld b,2
	_Battle_Enemy_Stun_Loop:
	push bc
		ld hl,enemy_sl1 ; get attack slot
		ld b,5
		call random
		ld d,0
		ld e,a
		add hl,de
		ld c,1 ; stun attack mode
		ld a,(hl)
		and $F0
		cp $00
		jr nz,{+1@}
		push af
		call _Battle_Enemy_Normal_Attack
		pop af
	@:
		cp $10
		jr nz,{+1@}
		push af
		call _Battle_Enemy_Fire_Attack
		pop af
	@:
		cp $20
		jr nz,{+1@}
		push af
		call _Battle_Enemy_Bolt_Attack
		pop af
	@:
		cp $30
		jr nz,{+1@}
		push af
		call _Battle_Enemy_Poison_Attack
		pop af
	@:
		cp $40
		jr nz,{+1@}
		push af
		call _Battle_Enemy_Normal_Attack ; we don't stun twice!
		pop af
	@:
		call Update
	pop bc
	djnz _Battle_Enemy_Stun_Loop
	
	ld hl,SaveSScreen + (35*12) + 8
	ld de,12-3
	ld b,16
	@:
		ld a,(hl)
		and $EF
		ld (hl),a
		inc hl
		inc hl
		inc hl
		ld a,(hl)
		and $7F
		ld (hl),a
		add hl,de
		djnz {-1@}
	call Update
	
	jp _Battle_Enemy_End

_Battle_Enemy_Subtract_Damage:
	
	ld d,h ; subtract damage from enemy
	ld e,l
	ld hl,(reuben_hp)
	xor a ; make sure carry is 0
	sbc hl,de
	jr nc,{+1@}
	ld hl,0
@:
	ld (reuben_hp),hl
	ret
_Battle_Enemy_Calc_Damage:
; calculates damage into hl
;reuben_lv*20/3->R
;((R/2)+(15+(rand^(5*enemy_lvl))+(2*(enemy_lvl^^2))*10)/R)->Q
	ld hl,(reuben_lvl) ; enemy_lvl times 20 into hl
	ld h,0 ; little endian trick thingy
	
	ld d,h
	ld e,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	add hl,de
	add hl,hl
	
	ld bc,3
	call Devide ; hl / 3 in de (out R in the upper forumla thingy)
	push de
		ld hl,(enemy_lvl) ; now we do the 2*(enemy_lvl^^2) chunk
		ld h,0
		ld b,l
		call Multiply
		add hl,hl ; *2
		
		ld a,(enemy_lvl) ; rand^(5*enemy_lvl) + 16
		ld b,a
		add a,a ; times 5
		add a,a
		add a,b
		ld b,a
		call random ; randomize
		
		add a,16 ; plus 16
		
		ld d,0 ; add them togeather!
		ld e,a
		add hl,de
		
		ld d,h ; times 10
		ld e,l
		add hl,hl
		add hl,hl
		add hl,de
		add hl,hl
		
		
	pop de
	push de
		srl d ; R/2
		rr e
		
		add hl,de
		
		
	pop de
	ld b,d ; devide by r
	ld c,e
	call Devide
	
	ld h,d
	ld l,e
	ret




_Battle_Fire_Animation; ; b is x offset
	ld c,b
	ld b,5
	@:
		push bc
			ld b,c
			ld c,22
			ld e,0
			ld a,$19
			bcall(_PutBigSpriteXOR)
			call _Battle_Pause_Short
			call Update
			call _Battle_Pause_Short
			
			
		pop bc
		djnz {-1@}
	ret
_Battle_Ice_Animation: ; only used by player
	ld b,8
	@:
		push bc
			ld c,b
			ld b,8
			@:
				push bc
					ld a,8
					sub c
					ld c,a
					add a,a
					add a,c
					add a,a
					add a,16
					ld h,a
					
					ld a,8
					sub b
					add a,a
					add a,a
					add a,a
					
					ld b,6
					ld de,PlotSScreen
					ld ix,IceSprite
					push af
					push hl
						call PutSpriteXOR
					pop hl
					pop af
					ld b,6
					ld de,AppBackUpScreen
					ld ix,IceSprite
					call PutSpriteXOR
					
				pop bc
				djnz {-1@}
			call _Battle_Pause_Short
		pop bc
		djnz {-2@}
	ld b,10
	@:
		push bc
			call XORScreen
			call _Battle_Pause_Short
		pop bc
		djnz {-1@}
	call Update
	ret
_Battle_Bolt_Animation: ; b is x offset
	ld c,b
	ld b,5
	@:
		push bc
			ld a,5
			sub b
			add a,a
			add a,a
			add a,a
			ld h,a
			ld a,c
			ld ix,LightningSprite
			ld b,8
			push af
			push hl
			push bc
				ld de,PlotSScreen
				call PutSpriteXOR
			pop bc
			pop hl
			pop af
			ld ix,LightningSprite
			ld de,AppBackUpScreen
			call PutSpriteXOR
			
			call XORScreen
			call _Battle_Pause_Short
			call XORScreen
			call _Battle_Pause_Short
		pop bc
		djnz {-1@}
	ld b,10
	@:
		push bc
			call XORScreen
			call _Battle_Pause_Short
		pop bc
		djnz {-1@}
	ret
_Battle_Reuben_Jump:
	ld bc,$4623 ; 70,35
	@:
		ld a,$12
		ld e,0
		dec c
		push bc
			bcall(_PutBigSpriteXOR)
			call _Battle_Pause_Short
		pop bc
		ld a,c
		cp $23-8
		jr nz,{-1@}
	push bc
		ld a,$12
		ld e,0
		bcall(_PutBigSpriteXOR)
	pop bc
	@:
		ld a,$12
		ld e,0
		inc c
		push bc
			bcall(_PutBigSpriteXOR)
			call _Battle_Pause_Short
		pop bc
		ld a,c
		cp $23
		jr nz,{-1@}
	call Update
	ret
_Battle_Reuben_Blink:
	call Update
	ld b,10
	@:
	push bc
		call _Battle_Rem_Reuben
		call _Battle_Pause_Short
		call Update
		call _Battle_Pause_Short
	pop bc
	djnz {-1@}
	ret
_Battle_Rem_Reuben:
	ld hl,PlotSScreen + (35*12)+8
	ld ix,AppBackUpScreen + (35*12)+8
	ld de,12-3
	ld b,16
	@:
		push bc
		ld b,3
		@:
			ld (hl),0
			ld (ix),0
			inc hl
			inc ix
			djnz {-1@}
		pop bc
		add hl,de
		add ix,de
		djnz {-2@}
	ret
_Battle_Shake_Screen:
	ld b,$77
	@:
		ld c,$7F
		@:
			ld a,c
			out ($10),a
			
			call _Battle_Pause_Short
			
			dec c
			ld a,c
			cp b
			jr nz,{-1@}
		
		inc b
		inc b
		
		ld a,$40
		out ($10),a
		
		call _Battle_Pause_Med_Long
		ld a,b
		cp $7F
		jr nz,{-2@}
	ret
_Battle_Pause_Short:
	ld a,1
	call Sleep
	ret
_Battle_Pause_Med_Long:
	ld a,10
	call Sleep
	ret
_Battle_Pause_Med:
	ld a,5
	call Sleep
	ret

_Battle_Pause:
; Destroys: none
	push de
	push af
	ld a,$30
	call Sleep
	pop af
	pop de
	ret

_Battle_Pause_Loop:
@:
	inc de
	xor a
	or d
	or e
	jr nz,{-1@}
	ret

_Battle_Draw:
	call ClrBackBuffers
	call _Battle_Draw_Tiles
	
	ld a,(enemy_xpos)
	ld b,a
	ld a,(enemy_ypos)
	ld c,a
	ld a,(enemy_id)
	ld e,1
	bcall(_PutBigSpriteXOR)
	
	; draw reuben
	ld a,$12
	ld bc,$4623 ; 70,35
	ld e,1
	bcall(_PutBigSpriteXOR)
	ret
_Battle_Draw_Tiles:
	push hl
	push de
	push bc
	push ix
	
	ld b,2
_Battle_Draw_Row:
	push bc
		ld c,b
		ld b,12
		_Battle_Draw_Col:
			push bc
			ld hl,enemy_tile1
			ld a,a
			ld a,a
			ld a,a
			ld a,a
			ld a,a
			ld a,a
			ld a,a
			ld a,a
			ld a,b
			and $01
			jr nz,{+1@}
			inc hl
		@:
			
			ld a,c
			and $01
			jr nz,{+1@}
			inc hl
			inc hl
		@:
			ld a,(hl)
			
			
			push hl
			ld h,0 ; a into hl
			ld l,a
			add hl,hl ; hl * 16
			add hl,hl
			add hl,hl
			add hl,hl
			
			
			
			ld de,sprites
			add hl,de
			
			push hl ; ld ix,hl
			pop ix
			
			push de
			
			ld a,c ;y pos
			dec a
			add a,a
			add a,a
			add a,a
			ld h,a
			
			ld a,b ;x pos
			dec a
			add a,a
			add a,a
			add a,a
			
			ld b,8
			
			
			call GraySpriteXOR
			
			
			pop de
			
			
			pop hl
			pop bc
			djnz _Battle_Draw_Col
	pop bc
	djnz _Battle_Draw_Row
	
	call Update
	pop ix
	pop bc
	pop de
	pop hl
	ret


_Battle_Toggle_Poison_Display:
	ld a,$4B
	ld h,$1D
	ld b,7
	ld ix,Poison_Sprite
	ld de,SaveSScreen
	call PutSpriteXOR
	ld a,$4B
	ld h,$1D
	ld b,7
	ld ix,Poison_Sprite
	ld de,StatVars
	call PutSpriteXOR
	
	call Update
	ret
Poison_Sprite:
	.db $60,$90,$92,$65,$05,$05,$02
Hand_Sprite:
	.db $7C,$82,$8C,$90,$60
LightningSprite:
	.db $18,$18,$20,$40,$80,$F8,$18,$18
IceSprite:
	.db $00,$1E,$E0,$00,$07,$78
Enemies: ; 14 bytes each
	.db $00 ; id
	.db 1 ; lvl
	.dw 43 ; hp
	.dw 1 ; exp
	.db $01,$30,$01,$01,$01 ; slots and immunity
	.db $39,$39,$42,$43 ; background tiles
	.db 12,32 ; position
	
	.db $01
	.db 2
	.dw 57
	.dw 2
	.db $01,$02,$01,$01,$01
	.db $39,$39,$42,$43
	.db 8,24
	
	.db $02
	.db 3
	.dw 57
	.dw 3
	.db $01,$02,$00,$01,$01
	.db $74,$75,$76,$77
	.db 19,27
	
	.db $03
	.db 4
	.dw 64
	.dw 4
	.db $01,$00,$01,$11,$01
	.db $74,$75,$76,$77
	.db 8,24
	
	.db $04
	.db 5
	.dw 66
	.dw 6
	.db $01,$01,$01,$01,$01
	.db $2A,$2A,$2A,$2A
	.db 16,33
	
	.db $05
	.db 6
	.dw 53
	.dw 5
	.db $11,$10,$10,$10,$11
	.db $2A,$2A,$2A,$2A
	.db 12,29
	
	.db $06
	.db 8
	.dw 450
	.dw 50
	.db $01,$10,$00,$11,$00
	.db $2A,$2A,$2A,$2A
	.db 1,16
	
	.db $07
	.db 9
	.dw 125
	.dw 60
	.db $21,$42,$41,$40,$41
	.db $8F,$8F,$10,$10
	.db 15,29
	
	.db $08
	.db 10
	.dw 72
	.dw 31
	.db $11,$00,$00,$33,$01
	.db $8F,$8F,$10,$10
	.db 16,32
	
	.db $09
	.db 11
	.dw 500
	.dw 259
	.db $01,$01,$21,$21,$40
	.db $8F,$8F,$10,$10
	.db 8,28
	
	.db $0A
	.db 12
	.dw 71
	.dw 38
	.db $11,$11,$10,$11,$11
	.db $8F,$8F,$10,$10
	.db 8,24
	
	.db $0B
	.db 15
	.dw 162
	.dw 185
	.db $11,$00,$11,$12,$01
	.db $78,$79,$7A,$7B
	.db 16,32
	
	.db $0C
	.db 16
	.dw 400
	.dw 1500
	.db $01,$12,$20,$11,$00
	.db $74,$75,$76,$77
	.db 4,16
	
	.db $0D
	.db 17
	.dw 150
	.dw 168
	.db $31,$41,$40,$32,$01
	.db $78,$79,$7A,$7B
	.db 16,32
	
	.db $0E
	.db 19
	.dw 205
	.dw 386
	.db $01,$21,$04,$01,$01
	.db $78,$79,$7A,$7B
	.db 1,16
	
	.db $0F
	.db 20
	.dw 999
	.dw 0
	.db $01,$01,$21,$22,$30
	.db $00,$00,$00,$00
	.db 0,0
	
	.db $10
	.db 7
	.dw 55
	.dw 20
	.db $01,$30,$01,$01,$01
	.db $39,$39,$42,$43
	.db 12,32
	
	.db $11
	.db 8
	.dw 65
	.dw 20
	.db $01,$02,$01,$01,$01
	.db $39,$39,$42,$43
	.db 8,24
