PutBigSpriteXOR:
;sprite XOR
;a - sprite number
;b - xpos
;c - ypos
;e - back? 1 - yes ; 0 - no
	ld d,b
	push de
		push af ; calculate offset into hl based on positions
		push de
			ld h,0      ; load ypos into hl and multiply by 12
			ld l,c
			ld d,0
			ld e,l
			add hl,hl
			add hl,de
			add hl,hl
			add hl,hl
			
			ld a,b    ; load xpos into de and devide by 8
			srl b
			srl b
			srl b
			ld e,b    ; d is already 0 from before
			add hl,de
			push hl ; ld hl,iy
			pop iy
		pop de
		pop af
		
		push hl ; load data offset stuff into ix
			    ; and character width into b
			    ; and character height into c
			ld de,EnemySprites
			ld h,0
			ld l,a
			add hl,hl ; a sprite is 2 bytes large in the header
			add hl,de ; we have our full offset now
			
			ld e,(hl) ; ld de,(hl)
			inc hl
			ld d,(hl)
			
			ld a,(de) ; width, deviding by 8 ceiling the number
			srl a
			jr nc,{+1@}
			inc a
		@:
			srl a
			jr nc,{+1@}
			inc a
		@:
			srl a
			jr nc,{+1@}
			inc a
		@:
			ld b,a    ; load it into the var
			inc de
			ld a,(de) ; load height
			ld c,a
			inc de    ; ok the sprites starts here
			push de   ; ld ix,de
			pop ix
			
		pop hl
	pop de
	push de
		ld a,e
		ld de,AppBackUpScreen
		cp 0
		jr z,{+1@}
			ld de,StatVars ; add the screen to the offset
		@:
		add hl,de
	pop de
	
	ld a,d          ; make sure the sprite shifting is only between 0 and 8
	and %00000111
	ld d,a
	
	push bc
	push de
		call _PutBigSpriteXOR_Drawing
	
		push iy ; ld iy,hl
		pop hl
	pop de
	push de
		ld a,e
		ld de,PlotSScreen
		cp 0
		jr z,{+1@}
			ld de,SaveSScreen
		@:
		add hl,de
	pop de
	pop bc
	
	call _PutBigSpriteXOR_Drawing
	
	ret
_PutBigSpriteXOR_Drawing:
	ld a,12   ; byte offset into e
	sub b
	ld e,a
	
	ld a,d
	and 7 ; is the sprite alligned to the 8*8 grid?
	jr nz,_PutBigSpriteXOR_not_aligned
	ld d,0
_PutBigSpriteXOR_aligned:
	push bc ; do a row
	@:
		ld a,(ix) ; fetch byte
		xor (hl)
		ld (hl),a
		inc hl
		inc ix
		djnz {-1@}
	pop bc
	add hl,de ; next row!
	dec c
	jr nz,_PutBigSpriteXOR_aligned
	ret
_PutBigSpriteXOR_not_aligned:
	push bc ; do a row
	@:
		push bc
			ld a,(ix) ; fetch byte
			ld b,d ; left half
			call _PutBigSpriteXOR_ShiftR
			xor (hl)
			ld (hl),a
			
			inc hl
			
			ld a,8 ; right half
			sub d
			ld b,a
			ld a,(ix)
			call _PutBigSpriteXOR_ShiftL
			xor (hl)
			ld (hl),a
			
			inc ix ; we don't inc hl as the next byte comes from the other side
		pop bc
		djnz {-1@}
		
		ld b,d
		ld d,0
		add hl,de ; next row!
		ld d,b
	pop bc
	
	dec c
	jr nz,_PutBigSpriteXOR_not_aligned
	ret
_PutBigSpriteXOR_ShiftR:
	srl a
	djnz _PutBigSpriteXOR_ShiftR
	ret
_PutBigSpriteXOR_ShiftL:
	sla a
	djnz _PutBigSpriteXOR_ShiftL
	ret


EnemySprites:
	.dw EnemySprites_00_Size
	.dw EnemySprites_01_Size
	.dw EnemySprites_02_Size
	.dw EnemySprites_03_Size
	.dw EnemySprites_04_Size
	.dw EnemySprites_05_Size
	.dw EnemySprites_06_Size
	.dw EnemySprites_07_Size
	.dw EnemySprites_08_Size
	.dw EnemySprites_09_Size
	.dw EnemySprites_0A_Size
	.dw EnemySprites_0B_Size
	.dw EnemySprites_0C_Size
	.dw EnemySprites_0D_Size
	.dw EnemySprites_0E_Size
	.dw EnemySprites_0F_Size
	.dw EnemySprites_10_Size
	.dw EnemySprites_11_Size
	.dw LargeSprites_12_Size ; Reuben
	.dw LargeSprites_13_Size ; "normal" arrows
	.dw LargeSprites_14_Size ; "magic" arrows
	.dw LargeSprites_15_Size ; sword "swish"
	.dw LargeSprites_16_Size ; sword sprite 1
	.dw LargeSprites_17_Size ; sword sprite 2
	.dw LargeSprites_18_Size ; sword sprite 3
	.dw LargeSprites_19_Size ; fire sprite
EnemySprites_00_Size:
	.db 24,16
EnemySprites_00_Layer_0:
	.db %00000000,%01000001,%10000000
	.db %00000000,%10100010,%01000000
	.db %00000001,%00010010,%01000010
	.db %00000000,%10100001,%10000101
	.db %00000010,%01011110,%00001001
	.db %00000101,%01111111,%00010101
	.db %00000010,%10111111,%10101010
	.db %00000111,%00110101,%11010000
	.db %00111110,%01101010,%11110000
	.db %01110111,%11110101,%11111100
	.db %11100011,%11111111,%11110110
	.db %11111111,%11111111,%11100011
	.db %01111111,%11111111,%10111101
	.db %00011111,%11111111,%00011111
	.db %00000001,%11111111,%11111110
	.db %00000000,%00011111,%11111100
EnemySprites_00_Layer_1:
	.db %00000000,%01000001,%10000000
	.db %00000000,%11100011,%11000000
	.db %00000001,%11110011,%11000010
	.db %00000000,%11100001,%10000111
	.db %00000010,%01011110,%00001111
	.db %00000111,%01100001,%00010111
	.db %00000010,%11000000,%10111010
	.db %00000111,%11000000,%01010000
	.db %00111001,%10001010,%00110000
	.db %01001000,%00000000,%00001100
	.db %10011100,%00100000,%10001010
	.db %10000000,%00011111,%00011101
	.db %01100000,%00000000,%01000011
	.db %00011110,%00000000,%11100001
	.db %00000001,%11100000,%00000010
	.db %00000000,%00011111,%11111100
EnemySprites_01_Size:
	.db 32,32
EnemySprites_01_Layer_0:
	.db %01110000,%00000000,%00000000,%00011110
	.db %10001100,%00000000,%00000000,%00100101
	.db %10001010,%00000000,%00000000,%01001001
	.db %01001001,%00000000,%00000000,%10001010
	.db %00101000,%10001110,%00000001,%00110101
	.db %01011000,%11010001,%00000010,%11110001
	.db %01000110,%10101110,%10000101,%00011010
	.db %00100101,%10010001,%01001010,%11101010
	.db %00100010,%01001000,%10110101,%00010100
	.db %00010010,%00100100,%01100111,%10011000
	.db %00001101,%00111111,%10111110,%11100000
	.db %00000011,%01011111,%00101010,%01000000
	.db %00000000,%11111111,%00110110,%01000000
	.db %00000000,%11111011,%00010100,%01000000
	.db %00000011,%11111011,%10010100,%10000000
	.db %00000111,%10010011,%11111111,%00000000
	.db %00000111,%11010001,%01001000,%10000000
	.db %00011111,%11101000,%10000011,%11000000
	.db %00111110,%11111111,%11111111,%11100000
	.db %00111101,%01111000,%11111111,%11110000
	.db %00111111,%10111111,%11111111,%11110000
	.db %00111111,%11110000,%11111111,%10111000
	.db %00011111,%01001111,%00111111,%11111000
	.db %00001110,%00100011,%11001111,%11011100
	.db %00000111,%01000000,%11101111,%10001000
	.db %00000111,%01000000,%00101110,%00000000
	.db %00000111,%01000111,%00100111,%00000000
	.db %00000011,%11000111,%11100111,%00000000
	.db %00000011,%10101010,%01000111,%00000000
	.db %00000011,%10010010,%00110010,%00000000
	.db %00000001,%00001101,%00001000,%00000000
	.db %00000000,%00000010,%11110000,%00000000
EnemySprites_01_Layer_1:
	.db %01110000,%00000000,%00000000,%00011110
	.db %10001100,%00000000,%00000000,%00100101
	.db %10001010,%00000000,%00000000,%01001001
	.db %01001001,%00000000,%00000000,%10001010
	.db %00101000,%10001110,%00000001,%00110101
	.db %01011000,%11011111,%00000010,%11110001
	.db %01000110,%10101111,%10000101,%11111010
	.db %00100101,%10010001,%11001011,%11111010
	.db %00100010,%01001000,%11110111,%00010100
	.db %00010010,%00100100,%01100111,%10011000
	.db %00001101,%00111111,%10111110,%11100000
	.db %00000011,%01010001,%00111110,%01000000
	.db %00000000,%11111001,%00111110,%01000000
	.db %00000000,%10001101,%00011100,%01000000
	.db %00000011,%01111100,%10011100,%10000000
	.db %00000100,%10011100,%01110111,%00000000
	.db %00000100,%11011110,%11111111,%10000000
	.db %00011101,%10101111,%11111111,%01000000
	.db %00100010,%11010111,%11111111,%00100000
	.db %00101101,%01111111,%11100001,%10010000
	.db %00101111,%10101111,%11111110,%11010000
	.db %00101000,%11111111,%11100110,%10101000
	.db %00011011,%01111111,%11111011,%01101000
	.db %00001010,%00111100,%01001011,%01010100
	.db %00000101,%01111111,%00101011,%10001000
	.db %00000101,%01111111,%11101010,%00000000
	.db %00000101,%01111000,%11100101,%00000000
	.db %00000010,%11111111,%10100101,%00000000
	.db %00000010,%10111110,%01000101,%00000000
	.db %00000010,%10011110,%00110010,%00000000
	.db %00000001,%00001111,%00001000,%00000000
	.db %00000000,%00000010,%11110000,%00000000
EnemySprites_02_Size:
	.db 10,26
EnemySprites_02_Layer_0:
	.db %01000000,%10000000
	.db %10110011,%01000000
	.db %10101101,%01000000
	.db %10001100,%01000000
	.db %01111111,%10000000
	.db %01111111,%10000000
	.db %11101101,%11000000
	.db %01101101,%10000000
	.db %01111101,%10000000
	.db %11101111,%11000000
	.db %11010110,%11000000
	.db %11101101,%11000000
	.db %11111111,%11000000
	.db %11101110,%11000000
	.db %11000100,%11000000
	.db %10001100,%11000000
	.db %10001110,%11000000
	.db %11001100,%11000000
	.db %11111011,%11000000
	.db %01111111,%10000000
	.db %01111111,%10000000
	.db %01111111,%10000000
	.db %01111111,%10000000
	.db %00111111,%00000000
	.db %00111111,%00000000
	.db %00010010,%00000000
EnemySprites_02_Layer_1:
	.db %01000000,%10000000
	.db %10110011,%01000000
	.db %10101101,%01000000
	.db %10001100,%01000000
	.db %01111111,%10000000
	.db %01111111,%10000000
	.db %11101101,%11000000
	.db %01100001,%10000000
	.db %01101111,%10000000
	.db %11111111,%11000000
	.db %11101101,%11000000
	.db %10010011,%11000000
	.db %10000011,%11000000
	.db %10010001,%11000000
	.db %11111111,%11000000
	.db %10010011,%11000000
	.db %10000001,%11000000
	.db %11000011,%11000000
	.db %11100101,%11000000
	.db %01111101,%10000000
	.db %01100001,%10000000
	.db %01101101,%10000000
	.db %01110011,%10000000
	.db %00111111,%00000000
	.db %00111111,%00000000
	.db %00010010,%00000000
EnemySprites_03_Size:
	.db 32,32
EnemySprites_03_Layer_0:
	.db %00000000,%00001111,%11111100,%00000000
	.db %00000000,%00010101,%11101011,%00000000
	.db %00000000,%00100111,%10110000,%11000000
	.db %00000000,%01100100,%10010011,%00110000
	.db %00000000,%11110100,%10100100,%00001000
	.db %00000001,%11110010,%10101000,%10010100
	.db %00000001,%11111010,%11101001,%01011010
	.db %00000011,%11101101,%00010000,%00001010
	.db %00000011,%11100010,%00001000,%10000001
	.db %00000011,%11000010,%00001000,%10000001
	.db %00000011,%11000010,%00000100,%11000001
	.db %00000011,%11000100,%00000100,%10100001
	.db %00000011,%11000100,%00000010,%10001010
	.db %00000010,%11000100,%00000010,%00011010
	.db %00000001,%00001000,%00000001,%01111100
	.db %00000001,%11110100,%00000000,%10010000
	.db %00000001,%00000100,%00000000,%01100000
	.db %00000001,%00001100,%00000000,%00000000
	.db %00000000,%11110010,%01111111,%00000000
	.db %00000000,%10000010,%10101010,%11000000
	.db %00000000,%10000101,%01011100,%10110000
	.db %00000000,%01111001,%01110101,%00001000
	.db %00111000,%01000001,%11010101,%01110100
	.db %01010101,%10100010,%10101010,%10011100
	.db %10101010,%11111100,%01011111,%01101010
	.db %10101011,%11010000,%10110000,%10011010
	.db %10101001,%01010001,%00101111,%01011010
	.db %01000101,%01001010,%00101010,%01011010
	.db %00110101,%00110100,%01001001,%00100100
	.db %00001111,%11000010,%10001001,%00100100
	.db %00000000,%00000001,%10010001,%00101000
	.db %00000000,%00000000,%01111111,%11110000
EnemySprites_03_Layer_1:
	.db %00000000,%00001111,%11111100,%00000000
	.db %00000000,%00011110,%00011111,%00000000
	.db %00000000,%00111100,%11001111,%11000000
	.db %00000000,%01111111,%11111111,%11110000
	.db %00000000,%10011111,%11111111,%11111000
	.db %00000001,%00011111,%11111111,%11101100
	.db %00000001,%00001111,%11111111,%11100110
	.db %00000010,%00010111,%00011111,%11110110
	.db %00000010,%00011110,%00001111,%11111111
	.db %00000010,%00111110,%00001111,%11111111
	.db %00000010,%00111110,%00000111,%01111111
	.db %00000010,%00111100,%00000111,%11111111
	.db %00000010,%00111100,%00000011,%01101110
	.db %00000011,%00111100,%00000011,%11111010
	.db %00000001,%11111000,%00000001,%10101100
	.db %00000001,%11111100,%00000000,%11110000
	.db %00000001,%11111100,%00000000,%01100000
	.db %00000001,%11111100,%00000000,%00000000
	.db %00000000,%11111110,%01111111,%00000000
	.db %00000000,%11111110,%11111111,%11000000
	.db %00000000,%11111111,%11100111,%11110000
	.db %00000000,%01111111,%10011111,%11111000
	.db %00111000,%01111111,%01111111,%11101100
	.db %01111101,%11111111,%11111111,%11100100
	.db %11111111,%10111111,%11111111,%11110110
	.db %11111100,%01111111,%11110000,%11110110
	.db %11111111,%11111111,%11111111,%11100110
	.db %01111111,%11111111,%11111111,%11101110
	.db %00111111,%11110111,%11111111,%11111100
	.db %00001111,%11000011,%11111111,%11111100
	.db %00000000,%00000001,%11111111,%11111000
	.db %00000000,%00000000,%01111111,%11110000
EnemySprites_04_Size:
	.db 16,15
EnemySprites_04_Layer_0:
	.db %00000111,%11110000
	.db %00001111,%11111101
	.db %00011111,%11111111
	.db %00111111,%10111111
	.db %01011111,%11111111
	.db %01101111,%01111111
	.db %10010011,%00111110
	.db %10001110,%10110010
	.db %11010011,%11100110
	.db %10111111,%00111100
	.db %10111111,%10111000
	.db %11111111,%11101000
	.db %11111101,%11110000
	.db %11100111,%11001000
	.db %01111111,%11111000
EnemySprites_04_Layer_1:
	.db %00000111,%11110000
	.db %00001000,%00001101
	.db %00010110,%01101011
	.db %00111000,%00110001
	.db %01010001,%10000001
	.db %01101111,%01000001
	.db %11110011,%00101110
	.db %11111111,%10110010
	.db %11110001,%11100010
	.db %10100010,%00101100
	.db %10100000,%00111000
	.db %11110010,%00111000
	.db %10011111,%11110000
	.db %10000110,%00001000
	.db %01111111,%11111000
EnemySprites_05_Size:
	.db 24,23
EnemySprites_05_Layer_0:
	.db %00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000
	.db %00000000,%00000000,%00001000
	.db %00000000,%00000111,%01000000
	.db %00000000,%01001010,%00001100
	.db %00100011,%01000000,%01000100
	.db %01010001,%00100001,%00000100
	.db %00100010,%00000000,%10100000
	.db %00000111,%00000100,%01000000
	.db %00000010,%00100000,%01100000
	.db %00000000,%11000100,%11000100
	.db %00100100,%00000000,%10000010
	.db %01000000,%00100010,%11000000
	.db %00010001,%00000000,%00000000
	.db %00000000,%00011010,%01000000
	.db %00000100,%00000100,%00100000
	.db %00000000,%00001000,%00000000
	.db %00000000,%00000000,%00000000
	.db %00000000,%01000110,%00000000
	.db %00000000,%10110110,%00000000
	.db %00000000,%01101100,%00000000
	.db %00000000,%00001100,%00000000
	.db %00000000,%00000000,%00000000
EnemySprites_05_Layer_1:
	.db %00100000,%00000000,%00011100
	.db %01010001,%10110000,%01100010
	.db %10001010,%01001111,%10000001
	.db %01010001,%10001000,%10000001
	.db %00110010,%10010000,%01000001
	.db %01010100,%10100000,%00110001
	.db %10001010,%10001000,%00111001
	.db %01010001,%00110100,%00011001
	.db %00110000,%01000010,%00011010
	.db %00001101,%10000001,%00011010
	.db %00100111,%00100010,%00101001
	.db %01011011,%01010101,%01100101
	.db %10111011,%11000000,%00010010
	.db %01100000,%10111111,%00010000
	.db %00011011,%11000001,%00100000
	.db %00001011,%00100010,%10010000
	.db %00000101,%10010101,%01100000
	.db %00000010,%00100010,%10000000
	.db %00000010,%00100000,%11000000
	.db %00000001,%00000001,%00100000
	.db %00000001,%00000010,%11000000
	.db %00000000,%10010010,%00000000
	.db %00000000,%01101100,%00000000
EnemySprites_06_Size:
	.db 47,48
EnemySprites_06_Layer_0:
	.db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00001000,%10000000,%00000000
	.db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000
	.db %00000000,%00000000,%00000000,%00011001,%11000000,%00000000
	.db %00000000,%00000000,%00000000,%10111111,%11010000,%00000000
	.db %00000000,%00000000,%00000110,%00011111,%11100000,%00000000
	.db %00000000,%00000000,%00001011,%11001111,%11110000,%00000000
	.db %00000000,%00000000,%01100000,%00011101,%11110000,%00000000
	.db %00000000,%00001000,%01100000,%00110000,%11110000,%00000000
	.db %00000010,%00011001,%11111111,%11110100,%00000000,%00000000
	.db %00001000,%11111001,%01011011,%11000100,%00010000,%00000000
	.db %00001011,%11111111,%11000001,%10000010,%00000000,%00000000
	.db %00000011,%01111110,%01000111,%00001001,%10010000,%00000000
	.db %00001110,%10111111,%10000101,%00011000,%11110000,%01110000
	.db %00000011,%00001111,%10000100,%10010001,%01110011,%11100000
	.db %00001000,%01100000,%01001001,%00100001,%11111011,%01110000
	.db %00001110,%11111000,%11111011,%11111100,%11100111,%00000000
	.db %00010111,%10111000,%10111000,%11110100,%00101111,%10010000
	.db %00010100,%01110011,%00100000,%11111000,%01110000,%11010100
	.db %00101000,%01100011,%10100111,%10101000,%00011010,%11101100
	.db %00001000,%01101110,%01000111,%11000000,%10000011,%01000000
	.db %00111110,%10001100,%01000000,%01111111,%00000100,%11100000
	.db %01011111,%01111111,%11000001,%11111111,%00000000,%00100000
	.db %11001111,%00111001,%00000001,%11111111,%01000000,%00000000
	.db %11001111,%10010111,%00011111,%11111001,%11010000,%00000000
	.db %11100111,%11010001,%11111111,%11100111,%11110000,%00000000
	.db %00100111,%11001000,%10001110,%00000110,%01111101,%00000000
	.db %00100011,%11001100,%11110000,%00011100,%00001111,%10000000
	.db %00100011,%11100110,%11110111,%11001000,%00000111,%11000000
	.db %00110001,%11000101,%11100011,%10111100,%00000001,%10000000
	.db %00000001,%10000011,%11101111,%11111111,%00000000,%11100000
	.db %00010001,%11001111,%11001100,%01101111,%11000000,%11000000
	.db %00000010,%01101101,%11001000,%00101111,%11110000,%01000000
	.db %00001010,%01001110,%01011000,%00011000,%11111100,%01100000
	.db %00001010,%10010011,%10010000,%00000110,%01111111,%10000000
	.db %00000011,%01011010,%00110000,%00000001,%10111111,%00000000
	.db %00000110,%01101101,%10100000,%00000000,%11100000,%10000000
	.db %00000010,%00100100,%01100000,%00000001,%11001111,%11100000
	.db %00000001,%10101001,%01100000,%00000000,%10110011,%11010000
	.db %00000010,%00011000,%11100000,%00000010,%01000100,%00110100
	.db %00001111,%01111110,%01100000,%00000001,%11111110,%01100100
	.db %00000100,%10100000,%01000000,%00000000,%11001111,%00001100
	.db %00000100,%01100000,%11000000,%00000000,%00001110,%00100000
	.db %00000000,%00000011,%01100000,%00000000,%00000011,%11000000
	.db %00000011,%11100000,%10100000,%00000000,%00000000,%00000000
	.db %00000011,%10000000,%01000000,%00000000,%00000000,%00000000
	.db %00000011,%00111111,%11000000,%00000000,%00000000,%00000000
	.db %00000011,%11111111,%10000000,%00000000,%00000000,%00000000
EnemySprites_06_Layer_1:
	.db %00000000,%00000000,%00000000,%00000111,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00010000,%01000000,%00000000
	.db %00000000,%00000000,%00000000,%00100000,%00100000,%00000000
	.db %00000000,%00000000,%00000000,%11000000,%00010000,%00000000
	.db %00000000,%00000000,%00000001,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00001111,%11100000,%00001000,%00000000
	.db %00000000,%00000111,%11110000,%00110000,%00001000,%00000000
	.db %00000000,%00001000,%11000000,%00001010,%00001000,%00000000
	.db %00000001,%11110000,%10000000,%00001111,%00001000,%00000000
	.db %00000100,%00000000,%10000000,%00001111,%11111000,%00000000
	.db %00001000,%00000000,%10000100,%00001111,%11110000,%00000000
	.db %00000000,%00000000,%10000111,%00001101,%11111000,%00000000
	.db %00010000,%10000001,%11111111,%11111110,%01100100,%01110000
	.db %00010001,%11000001,%01100111,%10010110,%00100011,%10001000
	.db %00011111,%11110001,%00111101,%11100110,%00100000,%00001000
	.db %00011111,%11111111,%10011100,%11001110,%00100100,%11110000
	.db %00010001,%10000111,%11111100,%11111111,%00111000,%11110000
	.db %00000001,%00000111,%11111111,%11111111,%11111000,%11001000
	.db %00000011,%00001100,%11011000,%01001111,%11111001,%11100000
	.db %00000111,%00011100,%01011000,%01011111,%11110001,%11110000
	.db %00100111,%10011100,%00111000,%01111111,%10001001,%10111100
	.db %01000001,%11111100,%00111111,%11111111,%10000101,%10010000
	.db %10000000,%11111000,%00111111,%11111111,%00000000,%11010000
	.db %10000000,%11111110,%11111111,%11111110,%11100000,%01100000
	.db %10000000,%01111111,%11111111,%11111110,%00111000,%00000000
	.db %10000000,%00111011,%11111111,%11111000,%00001110,%00000000
	.db %11000000,%00111000,%01111111,%11111000,%00000011,%00000000
	.db %01000000,%00111000,%00001111,%11100000,%00000000,%10000000
	.db %01000000,%00011100,%00001000,%00110000,%00000000,%01000000
	.db %01000000,%00111110,%00011100,%01100000,%00000000,%01000000
	.db %00100000,%01111110,%00011100,%01100000,%00000000,%00100000
	.db %00100000,%01000111,%00111111,%11110000,%00000000,%00100000
	.db %00110001,%11000111,%00111100,%00110000,%00000000,%00100000
	.db %00010100,%01000101,%10111000,%00011111,%00000000,%00100000
	.db %00010100,%01101100,%11110000,%00000111,%10000000,%01000000
	.db %00001100,%10111101,%11110000,%00000001,%11000000,%10000000
	.db %00000100,%11111110,%01100000,%00000001,%11111111,%11000000
	.db %00001100,%11111100,%11100000,%00000010,%00111111,%11110000
	.db %00001011,%00011100,%11100000,%00000011,%00001111,%11101000
	.db %00010001,%00000111,%11100000,%00000000,%10111111,%11000100
	.db %00010011,%10000011,%11100000,%00000010,%00000000,%00000100
	.db %00001010,%01111111,%11100000,%00000001,%11110000,%00000100
	.db %00000100,%00011111,%11110000,%00000000,%00001111,%11001000
	.db %00001000,%00000000,%11110000,%00000000,%00000011,%11110000
	.db %00001000,%00000000,%01100000,%00000000,%00000000,%00000000
	.db %00001000,%01111111,%11000000,%00000000,%00000000,%00000000
	.db %00000100,%11111111,%11000000,%00000000,%00000000,%00000000
	.db %00000011,%11111111,%10000000,%00000000,%00000000,%00000000
EnemySprites_07_Size:
	.db 18,23
EnemySprites_07_Layer_0:
	.db %00000001,%11100000,%00000000
	.db %00000110,%00011000,%00000000
	.db %00001010,%10000100,%00000000
	.db %00010110,%00000010,%00000000
	.db %00010100,%00000010,%00000000
	.db %00100000,%00000001,%00000000
	.db %00110000,%00000001,%00000000
	.db %01000000,%00000010,%10000000
	.db %01000001,%00100001,%10000000
	.db %10000000,%00000001,%01000000
	.db %10000010,%00010000,%01000000
	.db %10000001,%11100000,%01000000
	.db %01000000,%00000000,%10000000
	.db %00111111,%11111111,%00000000
	.db %01111111,%11111111,%10000000
	.db %11111111,%11111111,%11000000
	.db %01111111,%11111111,%10000000
	.db %11111111,%11111111,%10000000
	.db %01111111,%11111101,%11000000
	.db %00111011,%11111000,%10000000
	.db %00010011,%11110000,%00000000
	.db %00000001,%11100000,%00000000
	.db %00000000,%10000000,%00000000
EnemySprites_07_Layer_1:
	.db %00000001,%11100000,%00000000
	.db %00000111,%11111000,%00000000
	.db %00001101,%01111100,%00000000
	.db %00011001,%11111110,%00000000
	.db %00011011,%11111110,%00000000
	.db %00111111,%11111111,%00000000
	.db %00101111,%11111111,%00000000
	.db %01111110,%11011101,%10000000
	.db %01111101,%00101110,%10000000
	.db %11111110,%11011110,%11000000
	.db %11111111,%11111111,%11000000
	.db %11111111,%11111111,%11000000
	.db %01111111,%11111111,%10000000
	.db %00111010,%10101011,%00000000
	.db %01010101,%01010100,%10000000
	.db %10101101,%01010101,%01000000
	.db %01101010,%10101010,%10000000
	.db %10011010,%10101010,%10000000
	.db %01110110,%11101101,%01000000
	.db %00101010,%10101000,%10000000
	.db %00010010,%11010000,%00000000
	.db %00000001,%01100000,%00000000
	.db %00000000,%10000000,%00000000
EnemySprites_08_Size:
	.db 16,16
EnemySprites_08_Layer_0:
	.db %00100010,%10001000
	.db %01110011,%10011100
	.db %01011110,%11110100
	.db %01001100,%01100100
	.db %10100000,%00001110
	.db %11100000,%00001111
	.db %10100000,%00000101
	.db %10000111,%11100010
	.db %01001111,%11110100
	.db %10011011,%11011110
	.db %10011001,%10011001
	.db %01111111,%11111110
	.db %01111101,%11011110
	.db %10111000,%10011001
	.db %00011101,%10100110
	.db %00001010,%01000000
EnemySprites_08_Layer_1:
	.db %00100010,%10001000
	.db %01010011,%10010100
	.db %01101101,%01101100
	.db %01110111,%11011100
	.db %10111111,%11111010
	.db %11111111,%11111101
	.db %11011111,%11111011
	.db %11111111,%11111110
	.db %01111100,%00111100
	.db %11111010,%01011010
	.db %11111001,%10011111
	.db %01100110,%01100110
	.db %01101111,%01110110
	.db %10101111,%11111111
	.db %00010111,%11100110
	.db %00001010,%01000000
EnemySprites_09_Size:
	.db 32,24
EnemySprites_09_Layer_0:
	.db %00000001,%11100011,%11000111,%10000000
	.db %00000000,%11111111,%11111111,%00000000
	.db %00000000,%01111111,%11111110,%00000000
	.db %00000000,%01111111,%11111110,%00000000
	.db %00000001,%11111111,%11111111,%10000000
	.db %00000111,%11111111,%11111111,%11100000
	.db %00001111,%11111111,%11111111,%11110000
	.db %00001111,%11101111,%11110111,%11110000
	.db %00111110,%01111111,%11111110,%01111100
	.db %01111110,%00111111,%11111100,%01111110
	.db %11111111,%11010111,%11101011,%11111111
	.db %11111111,%00001001,%10010000,%11111111
	.db %01111110,%00011101,%10111000,%01111110
	.db %00100110,%00101110,%01110100,%01100100
	.db %00000010,%00111111,%11111100,%01000000
	.db %00000001,%00011111,%11111000,%10000000
	.db %00000011,%11000111,%11100011,%11000000
	.db %00000011,%11111111,%11111111,%11000000
	.db %00000001,%11111111,%11111111,%10000000
	.db %00000011,%11101111,%11110111,%11000000
	.db %00000111,%11100111,%11100111,%11100000
	.db %00000111,%11110111,%11101111,%11100000
	.db %00001111,%11100011,%11000111,%11110000
	.db %00000111,%10000000,%00000001,%11100000
EnemySprites_09_Layer_1:
	.db %00000001,%01100011,%11000110,%10000000
	.db %00000000,%10011100,%00111001,%00000000
	.db %00000000,%01000111,%11100010,%00000000
	.db %00000000,%01000000,%00000010,%00000000
	.db %00000001,%11100000,%00000111,%10000000
	.db %00000110,%00100100,%00100100,%01100000
	.db %00001001,%01000011,%11000010,%10010000
	.db %00001101,%11010000,%00001011,%10110000
	.db %00110010,%01000000,%00000010,%01001100
	.db %01000010,%00101000,%00010100,%01000010
	.db %10000101,%11010100,%00101011,%10100001
	.db %10111101,%00001001,%10010000,%10111101
	.db %01011010,%00010100,%00101000,%01011010
	.db %00100110,%00101010,%01010100,%01100100
	.db %00000010,%00110001,%10001100,%01000000
	.db %00000001,%00011000,%00011000,%10000000
	.db %00000010,%11000111,%11100011,%01000000
	.db %00000010,%01111000,%00011110,%01000000
	.db %00000001,%01010111,%11101010,%10000000
	.db %00000011,%10101000,%00010101,%11000000
	.db %00000100,%00100111,%11100100,%00100000
	.db %00000110,%00010100,%00101000,%01100000
	.db %00001000,%01100011,%11000110,%00010000
	.db %00000111,%10000000,%00000001,%11100000
EnemySprites_0A_Size:
	.db 32,32
EnemySprites_0A_Layer_0:
	.db %00000000,%00010000,%11111000,%00010000
	.db %00000000,%00101111,%00000111,%00101000
	.db %00000000,%00100000,%00000000,%11011000
	.db %00000000,%00010000,%00000001,%00111000
	.db %00000000,%00010100,%00000001,%11111000
	.db %00000000,%00001000,%00000000,%11110110
	.db %00000000,%00001011,%00000011,%11101001
	.db %00000000,%00101010,%10000100,%00010110
	.db %00000000,%01011011,%01101011,%11100010
	.db %00000000,%01011011,%10010101,%11111101
	.db %00000011,%10011101,%11110101,%11110010
	.db %00000101,%10010101,%11110110,%01011000
	.db %00011111,%00010110,%11101111,%11001000
	.db %00111110,%00100011,%00001100,%00000100
	.db %01111010,%01100011,%11111010,%01100100
	.db %00111100,%11111001,%01111011,%10110100
	.db %01000101,%00111111,%00011100,%11111000
	.db %10010100,%10001110,%00001011,%00010000
	.db %11010111,%00010010,%00001001,%11100000
	.db %11101110,%00011001,%11110011,%00100000
	.db %01011110,%01111100,%00011110,%01101110
	.db %00101101,%10011111,%11111110,%11110001
	.db %00000011,%00011111,%10011110,%11111101
	.db %00000101,%11100111,%10011011,%11110001
	.db %00001011,%11111111,%11111111,%11111101
	.db %00001000,%10011111,%11111111,%11011011
	.db %00010001,%11111111,%00111110,%10001110
	.db %00010101,%11111101,%00001110,%10000000
	.db %00100110,%11111010,%00111101,%00000000
	.db %00100100,%01101100,%01001110,%00000000
	.db %00100010,%00110000,%00100001,%00000000
	.db %00011100,%00000000,%00011110,%00000000
EnemySprites_0A_Layer_1:
	.db %00000000,%00010000,%11111000,%00010000
	.db %00000000,%00111111,%11111111,%00101000
	.db %00000000,%00111111,%11111111,%11001000
	.db %00000000,%00011111,%11111111,%00001000
	.db %00000000,%00011111,%11111111,%00001000
	.db %00000000,%00001111,%11111111,%10010110
	.db %00000000,%00001111,%11111111,%11101111
	.db %00000000,%00101110,%11111100,%00011110
	.db %00000000,%01011110,%01111011,%11111110
	.db %00000000,%01011110,%00010111,%10011111
	.db %00000011,%10011111,%00010111,%11010010
	.db %00000110,%10011111,%00010111,%11001000
	.db %00011111,%00011110,%11101001,%11001000
	.db %00100010,%00111110,%00001000,%00000100
	.db %01001110,%01011111,%10010010,%01000100
	.db %00111100,%11000111,%11110011,%10100100
	.db %01000111,%00110001,%11111100,%11111000
	.db %10010111,%10001111,%11111110,%00010000
	.db %10010111,%00011111,%11111111,%11100000
	.db %10101010,%00011111,%11111111,%11100000
	.db %01010010,%01101111,%11111111,%10101110
	.db %00101101,%11110011,%11110111,%01010001
	.db %00000010,%11111000,%11101111,%01101101
	.db %00000101,%00011111,%11111111,%00010001
	.db %00001111,%11100011,%11111001,%10101101
	.db %00001111,%10011100,%11000111,%01010001
	.db %00011111,%01100001,%00110000,%10001110
	.db %00011111,%00100001,%00001000,%10000000
	.db %00111110,%10000010,%00110001,%00000000
	.db %00111100,%01001100,%01111110,%00000000
	.db %00111110,%00110000,%00111111,%00000000
	.db %00011100,%00000000,%00011110,%00000000
EnemySprites_0B_Size:
	.db 16,16
EnemySprites_0B_Layer_0:
	.db %00000011,%11000000
	.db %00000100,%00100000
	.db %00001000,%00100000
	.db %00010011,%00010000
	.db %00101100,%00010000
	.db %00011000,%00010000
	.db %00001000,%00010000
	.db %00111000,%00011100
	.db %01111100,%00111110
	.db %01111111,%11111110
	.db %11111111,%11111111
	.db %11111111,%11111111
	.db %11111111,%11111111
	.db %11111111,%11111111
	.db %11111111,%11111110
	.db %01101111,%11111000
EnemySprites_0B_Layer_1:
	.db %00000011,%11000000
	.db %00000111,%10100000
	.db %00001110,%11100000
	.db %00011011,%11110000
	.db %00101111,%10110000
	.db %00011111,%11110000
	.db %00001111,%01110000
	.db %00111101,%11111100
	.db %01001111,%11110010
	.db %01000011,%11000010
	.db %10000000,%00000001
	.db %10000000,%00000001
	.db %10000000,%00000001
	.db %10000000,%00000101
	.db %10010000,%00000110
	.db %01101111,%11111000
EnemySprites_0C_Size:
	.db 40,48
EnemySprites_0C_Layer_0:
	.db %00000000,%00000000,%00000000,%01000110,%10000000
	.db %00000000,%00100000,%01000000,%11111101,%11000000
	.db %00000000,%01010000,%11101001,%11111110,%10111000
	.db %00000000,%01010000,%11111101,%11111111,%11000100
	.db %00000000,%01010000,%11111101,%11111010,%00011000
	.db %00000000,%01010001,%11111111,%10110110,%00000100
	.db %00000000,%01010011,%01111111,%11010000,%10011000
	.db %00000000,%01010011,%11001111,%11011001,%00100000
	.db %00000000,%01010010,%10111111,%11001111,%00100000
	.db %00000000,%01010010,%01111111,%11010110,%01000000
	.db %00000000,%01010001,%00111111,%11010001,%11001000
	.db %00000000,%10011111,%11000111,%11010001,%00111110
	.db %00000000,%10011111,%00111111,%01001100,%10111111
	.db %00000000,%10011100,%01111111,%11001100,%11111110
	.db %00000000,%10011111,%11001100,%11000111,%11001000
	.db %00000000,%01011001,%10001100,%11000101,%11111000
	.db %00000000,%01111001,%10111111,%11000001,%11101100
	.db %00000000,%10110110,%11000100,%11100000,%11111000
	.db %00000000,%01100110,%00011111,%10100010,%11100000
	.db %00000000,%10111111,%01100101,%10100010,%01110000
	.db %00000000,%01011111,%11110111,%10010000,%01110000
	.db %00000000,%01111111,%10001111,%11001000,%00111000
	.db %00000000,%10010100,%11111100,%01001100,%00111000
	.db %00000001,%10010101,%10110010,%01001110,%00111000
	.db %01000000,%11110011,%01111111,%10000011,%11111100
	.db %00000000,%01101101,%10001001,%11000001,%11111000
	.db %10000000,%01001100,%00111111,%01100101,%11000000
	.db %00100000,%01111110,%11001011,%01000100,%11100000
	.db %00000000,%00111111,%11101111,%00100000,%10100000
	.db %10000000,%01111111,%00111111,%10010000,%00000000
	.db %00000000,%00101001,%11111010,%10000000,%10000000
	.db %00000101,%00101011,%01100100,%10010000,%00000000
	.db %11000000,%10101101,%00000100,%10000010,%11000000
	.db %00001000,%00101010,%10000000,%00000000,%00000000
	.db %00000010,%10101000,%10100000,%00000000,%00000000
	.db %00000000,%00100101,%00001000,%10001000,%00000000
	.db %00000000,%01001000,%00100000,%00100000,%10000000
	.db %00001000,%00100101,%00100000,%00000000,%00000000
	.db %00001010,%01000100,%00000000,%00000000,%00001000
	.db %10000100,%00100000,%10001001,%00000000,%01000000
	.db %00000000,%10000000,%00000000,%00000000,%00000000
	.db %00000000,%10010100,%00100000,%00000000,%00000000
	.db %10000000,%00010001,%00011000,%01000010,%00000000
	.db %00000000,%00000000,%01000000,%01010010,%00000000
	.db %00000000,%00000100,%01100000,%01000000,%00000000
	.db %00100000,%00010011,%00000001,%10001000,%00000000
	.db %00101000,%00010000,%00000000,%01001000,%00000000
	.db %00000000,%00000000,%00100000,%01100000,%00000000
EnemySprites_0C_Layer_1:
	.db %00000000,%00000000,%00000000,%01000110,%10000000
	.db %00000000,%00100000,%01000000,%10111001,%01000000
	.db %00000000,%01010000,%10101001,%01100110,%10111000
	.db %00000000,%01010000,%10110101,%01101111,%11111100
	.db %00000000,%01010000,%10110101,%11111011,%11111000
	.db %00000000,%01010001,%01010110,%11011111,%11111100
	.db %00000000,%01010010,%11111010,%11101111,%01111000
	.db %00000000,%01010010,%11001010,%01100110,%11100000
	.db %00000000,%01010011,%11111101,%11111001,%11100000
	.db %00000000,%01010011,%11000110,%01111111,%11000000
	.db %00000000,%01010001,%11111001,%01111111,%11001000
	.db %00000000,%10011111,%10111111,%11111111,%11110110
	.db %00000000,%10010000,%11111100,%11111011,%11001001
	.db %00000000,%10011011,%11111111,%11111011,%11110110
	.db %00000000,%10010111,%10111011,%11111100,%11111000
	.db %00000000,%01010111,%01111011,%11111110,%11111000
	.db %00000000,%01111111,%01111111,%01111110,%01110100
	.db %00000000,%11011111,%11111111,%11111111,%01011000
	.db %00000000,%01111111,%11111111,%11111111,%00100000
	.db %00000000,%11011001,%11111111,%11111111,%10010000
	.db %00000000,%01110000,%10001111,%11111111,%10010000
	.db %00000000,%01111011,%11111100,%01111111,%11001000
	.db %00000000,%10011111,%11110011,%11111011,%11001000
	.db %00000001,%10011111,%01001101,%11110101,%11001000
	.db %00000000,%11111110,%11111111,%11111100,%11000100
	.db %00000001,%10111111,%11111111,%11111110,%11111000
	.db %00000000,%11111111,%11111111,%11011110,%01000000
	.db %00000001,%10110011,%11111111,%11111111,%00100000
	.db %00000000,%11100001,%00011111,%11111111,%00000000
	.db %00011110,%11111111,%11011000,%11111011,%10000000
	.db %00101111,%11101111,%11100101,%11110110,%00000000
	.db %00010011,%11101110,%10011011,%11101011,%00000000
	.db %00010111,%11101110,%11111011,%11111000,%00000000
	.db %00000111,%11101111,%01111111,%11101111,%10000000
	.db %00001001,%11101111,%11111111,%11110100,%00000000
	.db %00110111,%11111111,%11111111,%01110110,%00000000
	.db %00101011,%11101111,%11111111,%11010100,%00000000
	.db %00110111,%11111111,%11111111,%11111110,%00000000
	.db %00010001,%11101111,%11111111,%11101100,%00000000
	.db %00010011,%11111111,%11110110,%11101110,%00000000
	.db %00011111,%01111111,%11111111,%11101100,%00000000
	.db %00011101,%01111011,%11111111,%10110000,%00000000
	.db %00000111,%11111110,%11100111,%00000000,%00000000
	.db %00000101,%10011101,%10111111,%00000000,%00000000
	.db %00000101,%01111011,%10011010,%00000000,%00000000
	.db %00000001,%11101100,%11101000,%00000000,%00000000
	.db %00000011,%10101011,%10001100,%00000000,%00000000
	.db %00000000,%10110010,%10001000,%00000000,%00000000
EnemySprites_0D_Size:
	.db 16,16
EnemySprites_0D_Layer_0:
	.db %00000010,%01010001
	.db %00000111,%11110101
	.db %00001111,%11010101
	.db %00010011,%10110101
	.db %00010001,%01001110
	.db %00110000,%00101000
	.db %01010000,%10011000
	.db %10001000,%01101100
	.db %11100100,%01000010
	.db %10010010,%00011100
	.db %11001010,%00001000
	.db %10110100,%00011000
	.db %10100000,%00011000
	.db %10100001,%00001000
	.db %01010000,%10001000
	.db %00001111,%11111100
EnemySprites_0D_Layer_1:
	.db %00000010,%01010000
	.db %00000101,%10110000
	.db %00001100,%01110000
	.db %00011110,%11110000
	.db %00011111,%11001000
	.db %00111111,%11101010
	.db %01011111,%11111010
	.db %10001111,%11111110
	.db %10000111,%11111110
	.db %10000011,%11111110
	.db %10001011,%11111010
	.db %10011111,%11111010
	.db %10111111,%11111010
	.db %10111111,%11111010
	.db %01011111,%11111010
	.db %00001111,%11111110
EnemySprites_0E_Size:
	.db 47,48
EnemySprites_0E_Layer_0:
	.db %00000000,%00000000,%00000000,%00000111,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00010111,%01000000,%00000000
	.db %00000000,%00000000,%00000000,%00111111,%10100000,%00000000
	.db %00000000,%00000000,%00000000,%11100110,%00110000,%00000000
	.db %00000000,%00000000,%00000001,%01000000,%00100000,%00000000
	.db %00000000,%00000000,%00001111,%11100000,%00011000,%00000000
	.db %00000000,%00000111,%11110100,%00110000,%00001000,%00000000
	.db %00000000,%00001111,%11011111,%11101010,%00001000,%00000000
	.db %00000001,%11110111,%10011111,%11001111,%00001000,%00000000
	.db %00000101,%11100110,%10000000,%00001111,%11111000,%00000000
	.db %00001111,%00000110,%10100100,%00111111,%11110000,%00000000
	.db %00000100,%00000000,%10111111,%01111101,%11111000,%00000000
	.db %00011100,%10000001,%11111111,%11111110,%01101100,%01110000
	.db %00010001,%11000001,%01100111,%10010111,%00101111,%10001000
	.db %00011111,%11110001,%01111111,%11101110,%10101100,%00011000
	.db %00011111,%11111111,%10111110,%11011110,%00100100,%11110000
	.db %00010001,%10000111,%11111100,%11111111,%00111000,%11110000
	.db %00001001,%01000111,%11111111,%11111111,%11111000,%11101000
	.db %00001011,%10001100,%11011111,%01001111,%11111111,%11101010
	.db %00010111,%10011100,%01011000,%01011111,%11110101,%11110010
	.db %00110111,%10011101,%10111000,%01111111,%10001101,%10111100
	.db %01000001,%11111111,%10111111,%11111111,%10000101,%10010000
	.db %10100000,%11111000,%00111111,%11111111,%00000000,%11010000
	.db %10110000,%11111110,%11111111,%11111110,%11100000,%01100000
	.db %10110000,%01111111,%11111111,%11111110,%00111000,%00000000
	.db %10011000,%00111111,%11111111,%11111000,%00001110,%00000000
	.db %11011000,%00111111,%01111111,%11111001,%10000011,%00000000
	.db %01011100,%00111011,%00001111,%11100011,%11110000,%10000000
	.db %01011100,%00011101,%00001000,%00110111,%11111000,%01000000
	.db %01001110,%00111110,%00011100,%01100011,%11111110,%01000000
	.db %00111110,%01111110,%00011100,%01100000,%11111111,%00100000
	.db %00101110,%01110111,%00111111,%11110000,%00111111,%00100000
	.db %00111101,%11010111,%00111100,%00110000,%00001111,%10100000
	.db %00010101,%11110101,%10111000,%00011111,%00000011,%10100000
	.db %00010101,%01101100,%11110000,%00000111,%10000000,%01000000
	.db %00001100,%10111101,%11110000,%00000001,%11000000,%10000000
	.db %00000101,%11111110,%01100000,%00000001,%11111111,%11000000
	.db %00001101,%11111111,%11100000,%00000010,%00111111,%11110000
	.db %00001111,%01011110,%11100000,%00000011,%01001111,%11101000
	.db %00011101,%11100111,%11100000,%00000001,%10111111,%11001100
	.db %00010011,%10000011,%11100000,%00000010,%00000001,%10011100
	.db %00001011,%01111111,%11100000,%00000001,%11110000,%11110100
	.db %00000111,%10011111,%11110000,%00000000,%00001111,%11011000
	.db %00001111,%11111100,%11110000,%00000000,%00000011,%11110000
	.db %00001100,%00011111,%01100000,%00000000,%00000000,%00000000
	.db %00001100,%01111111,%11000000,%00000000,%00000000,%00000000
	.db %00000100,%11111111,%11000000,%00000000,%00000000,%00000000
	.db %00000011,%11111111,%10000000,%00000000,%00000000,%00000000
EnemySprites_0E_Layer_1:
	.db %00000000,%00000000,%00000000,%00000111,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00011000,%11000000,%00000000
	.db %00000000,%00000000,%00000000,%00100000,%01100000,%00000000
	.db %00000000,%00000000,%00000000,%11011001,%11010000,%00000000
	.db %00000000,%00000000,%00000001,%10111111,%11010000,%00000000
	.db %00000000,%00000000,%00001111,%11111111,%11101000,%00000000
	.db %00000000,%00000111,%11111011,%11111111,%11111000,%00000000
	.db %00000000,%00001000,%11100000,%00011111,%11111000,%00000000
	.db %00000001,%11111000,%11100000,%00111111,%11111000,%00000000
	.db %00000110,%00011001,%11111111,%11111111,%11111000,%00000000
	.db %00001000,%11111001,%11011111,%11001111,%11110000,%00000000
	.db %00001011,%11111111,%11000111,%10001111,%11111000,%00000000
	.db %00010011,%11111111,%11111111,%11111111,%11110100,%01110000
	.db %00011111,%11111111,%11100111,%10011110,%11110011,%11111000
	.db %00011111,%11111111,%10111101,%11110111,%01110011,%11101000
	.db %00011111,%11111111,%11011101,%11101111,%11111111,%11110000
	.db %00011111,%11111111,%11111111,%11111111,%11111111,%11110000
	.db %00010111,%10111111,%11111111,%11111111,%11111111,%11011000
	.db %00010111,%01111111,%11111000,%11111111,%11111001,%11110110
	.db %00101111,%01111111,%11111111,%11111111,%11111011,%11111110
	.db %00101111,%11111110,%01111111,%11111111,%10001011,%11111100
	.db %01111111,%11111100,%01111111,%11111111,%10000101,%11110000
	.db %11011111,%11111111,%11111111,%11111111,%00000000,%11110000
	.db %11001111,%11111111,%11111111,%11111111,%11100000,%01100000
	.db %11001111,%11111111,%11111111,%11111111,%11111000,%00000000
	.db %11100111,%11111011,%11111111,%11111111,%11111110,%00000000
	.db %11100111,%11111000,%11111111,%11111110,%01111111,%00000000
	.db %01100011,%11111100,%11111111,%11111100,%00001111,%10000000
	.db %01100011,%11111110,%11111111,%11111000,%00000111,%11000000
	.db %01110001,%11111111,%11111111,%11111100,%00000001,%11000000
	.db %00100001,%11111111,%11111111,%11111111,%00000000,%11100000
	.db %00110001,%11001111,%11111111,%11111111,%11000000,%11100000
	.db %00110011,%11101111,%11111100,%00111111,%11110000,%01100000
	.db %00011110,%01001111,%11111000,%00011111,%11111100,%01100000
	.db %00011110,%11111111,%11110000,%00000111,%11111111,%11000000
	.db %00001111,%11111111,%11110000,%00000001,%11111111,%10000000
	.db %00000110,%11111111,%11100000,%00000001,%11111111,%11000000
	.db %00001110,%11111100,%11100000,%00000011,%11111111,%11110000
	.db %00001011,%10111101,%11100000,%00000011,%10111111,%11111000
	.db %00010011,%00011111,%11100000,%00000010,%11111111,%11110100
	.db %00011111,%11111111,%11100000,%00000011,%11111110,%01100100
	.db %00001110,%11111111,%11100000,%00000001,%11111111,%00001100
	.db %00000100,%01111111,%11110000,%00000000,%00001111,%11101000
	.db %00001000,%00000011,%11110000,%00000000,%00000011,%11110000
	.db %00001011,%11100000,%11100000,%00000000,%00000000,%00000000
	.db %00001011,%11111111,%11000000,%00000000,%00000000,%00000000
	.db %00000111,%11111111,%11000000,%00000000,%00000000,%00000000
	.db %00000011,%11111111,%10000000,%00000000,%00000000,%00000000
EnemySprites_0F_Size:
	.db 64,62
EnemySprites_0F_Layer_0:
	.db %00000000,%00000000,%00000000,%00000111,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00001001,%01111000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00001011,%10001000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00111011,%00011000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01001111,%00111110,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01011111,%01111001,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01111001,%01101101,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01110011,%11111010,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00010111,%11111100,%00000000,%00000000,%00000000
	.db %00000000,%00000011,%10000000,%00010101,%11111011,%11110000,%00000000,%00000000
	.db %00000000,%00001100,%01000011,%10111101,%11111110,%00011000,%00000000,%00000000
	.db %00000000,%00010000,%01001100,%01111101,%11101111,%11110100,%00000000,%00000000
	.db %00000000,%00010110,%00111111,%11111111,%11100011,%11111111,%00000000,%00000000
	.db %00000000,%00101111,%00011111,%11101110,%11110011,%11111110,%10011000,%01100000
	.db %00000000,%01011111,%11001111,%11001111,%11110001,%11111111,%01100100,%01110000
	.db %00000000,%11111111,%11100011,%10001111,%11010001,%10000111,%11110100,%01111000
	.db %00000000,%11111111,%11110011,%10000110,%11100001,%10000011,%11110100,%11011000
	.db %00000001,%11111111,%11111111,%10000111,%11001000,%10000001,%11101111,%11111000
	.db %00000001,%11111001,%11011111,%10010111,%00010000,%10000001,%11111110,%10011000
	.db %00000001,%11001111,%10111101,%10110111,%10010001,%11100001,%01111111,%01001100
	.db %00000110,%01111111,%11111001,%10110111,%10010001,%11111111,%00011110,%10001100
	.db %00001001,%11111111,%11110001,%00000111,%11010100,%11111111,%10001111,%00001100
	.db %00010111,%10001111,%11100001,%10000000,%11100001,%11111111,%11001110,%00001100
	.db %00010110,%01111111,%11000011,%11000000,%00001111,%11111111,%11111010,%00001100
	.db %00101101,%11111111,%11100111,%10010000,%10011101,%11111111,%11110111,%00001100
	.db %00101011,%11111111,%01101111,%11000110,%11110111,%11101111,%11001111,%00000110
	.db %00110111,%11111110,%01110111,%01100010,%11010110,%10101111,%00111111,%00000110
	.db %01001111,%11111110,%11011111,%10110011,%11011101,%10011101,%11111111,%10000110
	.db %01001111,%11101111,%11011111,%11111111,%11111111,%01011011,%11111111,%10000110
	.db %01011111,%11000011,%10011111,%10111011,%11011101,%01011011,%11001111,%10000110
	.db %01011111,%10000011,%10111101,%11001111,%11110010,%11111010,%11110111,%11000110
	.db %10111111,%00000011,%11111101,%10111111,%11001101,%11101011,%11111111,%11000110
	.db %10111110,%00000011,%01111111,%11001111,%00110001,%11101101,%11101111,%11000110
	.db %10111100,%01100110,%10011011,%10000011,%11000000,%11100101,%11000111,%11001111
	.db %11111100,%10011110,%00111001,%11000100,%10010001,%11100111,%11111111,%11001111
	.db %11111001,%01111111,%11101001,%01100010,%10100011,%10110010,%11111111,%11001111
	.db %11111001,%01111100,%10110001,%10100010,%10100111,%01010011,%11111111,%11001111
	.db %11111000,%11111101,%11010010,%11011000,%10000111,%00101001,%01111111,%11011111
	.db %11110000,%01111111,%11100101,%01101100,%00011010,%11011001,%11111111,%11011111
	.db %11110000,%00110011,%10100110,%11110111,%11100101,%00111000,%11111111,%11011111
	.db %11110000,%01100111,%11100111,%11011111,%10011010,%10111100,%01011111,%11111110
	.db %01110000,%11001111,%11111111,%10101011,%11110101,%01001111,%11110111,%11111110
	.db %01110001,%10001111,%01011111,%11010100,%00101010,%10000110,%11101111,%11111110
	.db %01110011,%00011111,%11011110,%00101010,%01010111,%00011110,%11100011,%11001110
	.db %00100110,%00111111,%10111000,%00111000,%10111100,%00111011,%00100000,%00001110
	.db %00101100,%01111100,%11110000,%01110111,%11100011,%11111111,%11100000,%00001110
	.db %00011000,%11111000,%10011100,%11100000,%00000000,%01011101,%10100000,%00000100
	.db %00110001,%11111001,%11110111,%11000000,%00000000,%01101111,%10110000,%00000100
	.db %01100001,%11110001,%00111111,%10000000,%00000000,%01010011,%11101000,%00000000
	.db %11000011,%11110001,%11110011,%00000000,%00000000,%01000010,%10011110,%00000000
	.db %10000111,%11100001,%10111111,%00000000,%00000000,%00111110,%11110011,%10000000
	.db %10000111,%01100001,%10001101,%00000000,%00000000,%00000011,%10011110,%01100000
	.db %10001101,%11000001,%11101101,%00000000,%00000000,%00000001,%11101101,%11010000
	.db %10010011,%11000011,%10011110,%00000000,%00000000,%00000000,%00011110,%00011000
	.db %10001111,%10000011,%10011000,%00000000,%00000000,%00000000,%00000001,%11110000
	.db %10011111,%10000011,%10111000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %11111111,%00000111,%11101000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001111,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001110,%01100000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001100,%11000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001101,%10000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000111,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
EnemySprites_0F_Layer_1:
	.db %00000000,%00000000,%00000000,%00000111,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00001111,%01111000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00001111,%11111000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00111111,%11111000,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01111111,%11111110,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01111111,%11111111,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01111111,%11111111,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%01111111,%11111110,%00000000,%00000000,%00000000
	.db %00000000,%00000000,%00000000,%00011111,%11111100,%00000000,%00000000,%00000000
	.db %00000000,%00000011,%10000000,%00011111,%11111011,%11110000,%00000000,%00000000
	.db %00000000,%00001111,%11000011,%10111111,%11101111,%11111000,%00000000,%00000000
	.db %00000000,%00011111,%11001111,%11111111,%11110011,%11111100,%00000000,%00000000
	.db %00000000,%00011111,%11111111,%11000111,%11111101,%11111111,%00000000,%00000000
	.db %00000000,%00111111,%11111111,%11011111,%11111101,%11111111,%10011000,%01100000
	.db %00000000,%01111111,%11111111,%10111111,%11111110,%11000111,%11111100,%01110000
	.db %00000000,%11111111,%11111111,%11111011,%11111110,%11111011,%11111100,%01101000
	.db %00000000,%11111111,%11111111,%11111100,%00111110,%11111101,%11111100,%11001000
	.db %00000001,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11001000
	.db %00000001,%11111111,%11101101,%11101110,%11111111,%11111111,%01111111,%10101000
	.db %00000001,%11111111,%11110011,%11011110,%01111111,%11111111,%10111111,%00110100
	.db %00000111,%11111111,%10110111,%11011110,%01111111,%11111111,%11111110,%01110100
	.db %00001111,%11111111,%11001111,%01111111,%00111110,%11111111,%11111110,%11110100
	.db %00011111,%11111111,%11011111,%00001111,%11110000,%11111111,%11111101,%11110100
	.db %00011111,%11111110,%10111111,%01000000,%00000010,%10011111,%11111001,%11110100
	.db %00111111,%11111110,%11011111,%01010110,%01101010,%10011111,%11110000,%11110100
	.db %00111111,%11111111,%11111111,%01010110,%01101010,%11101111,%11000000,%11111010
	.db %00111111,%11111111,%10111111,%11010110,%01101011,%11101111,%00000000,%11111010
	.db %01111111,%11111111,%01111110,%11010110,%01101011,%11111100,%00001000,%01111010
	.db %01111111,%11101110,%10111110,%01000110,%01100011,%10111000,%00000100,%01111010
	.db %01111111,%11000010,%11111111,%11110110,%01101111,%10111000,%11000010,%01111010
	.db %01111111,%10000011,%11111110,%01111100,%00111111,%01011000,%00100000,%00111010
	.db %11111111,%00000011,%11111111,%01110111,%11111110,%11101000,%11110001,%00111010
	.db %11111110,%00000011,%11111111,%10111110,%11111111,%11101100,%11111001,%00111010
	.db %11111100,%01100111,%01111011,%11111111,%11111111,%01100100,%01111100,%00110111
	.db %11111100,%10011111,%11101001,%11111111,%11111110,%11100110,%00111100,%00110111
	.db %11111001,%00001001,%11111001,%11011111,%11111101,%11110010,%00000010,%00110111
	.db %11111001,%00001010,%11010001,%11111101,%11011001,%10110011,%00000010,%00110111
	.db %11111000,%10011100,%01110011,%11110111,%01111111,%11111001,%00000010,%00101111
	.db %11110000,%01110010,%10100111,%11111111,%11111111,%10111001,%10000000,%00101111
	.db %11110000,%00100001,%01100111,%10111011,%11111111,%11011000,%11000000,%00101111
	.db %11110000,%01000011,%11100111,%01111101,%01111111,%11101100,%01000000,%00011110
	.db %01110000,%10000111,%00111111,%11110111,%11111111,%11110111,%10110000,%00011110
	.db %01110001,%00001110,%00111000,%11101011,%11111111,%11111110,%01101100,%00111110
	.db %01110010,%00010010,%00110001,%11110101,%11111111,%11111000,%10100011,%11001110
	.db %00100100,%00100111,%01110111,%11111111,%11111111,%11100111,%00100000,%00001110
	.db %00101000,%00001100,%11111111,%11110111,%11100011,%11111100,%01100000,%00001110
	.db %00010000,%00111000,%10001111,%11100000,%00000000,%01111011,%11100000,%00000100
	.db %00100000,%01111001,%11101011,%11000000,%00000000,%01011111,%11110000,%00000100
	.db %01000000,%11110001,%00011111,%10000000,%00000000,%01101110,%11111000,%00000000
	.db %10000001,%11010001,%11001101,%00000000,%00000000,%01111111,%11111110,%00000000
	.db %10000011,%00100001,%11111111,%00000000,%00000000,%00111111,%11111111,%10000000
	.db %10000110,%01100001,%01111111,%00000000,%00000000,%00000011,%11101111,%11100000
	.db %10000000,%11000001,%11111111,%00000000,%00000000,%00000001,%11111111,%10110000
	.db %10000001,%11000011,%11111110,%00000000,%00000000,%00000000,%00011111,%11111000
	.db %10000111,%10000011,%01111000,%00000000,%00000000,%00000000,%00000001,%11110000
	.db %10001111,%10000011,%11111000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %11111111,%00000111,%01111000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001110,%11110000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001101,%11100000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001111,%11000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00001011,%10000000,%00000000,%00000000,%00000000,%00000000,%00000000
	.db %00000000,%00000111,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
EnemySprites_10_Size:
	.db 24,16
EnemySprites_10_Layer_0:
	.db %00000000,%01000001,%10000000
	.db %00000000,%11100011,%11000000
	.db %00000001,%11110011,%11000010
	.db %00000000,%11100001,%10000111
	.db %00000010,%01011110,%00001111
	.db %00000111,%01100001,%00010111
	.db %00000010,%11000000,%10111010
	.db %00000111,%11000000,%01010000
	.db %00111001,%10001010,%00110000
	.db %01001000,%00000000,%00001100
	.db %10011100,%00100000,%10001010
	.db %10000000,%00011111,%00011101
	.db %01100000,%00000000,%01000011
	.db %00011110,%00000000,%11100001
	.db %00000001,%11100000,%00000010
	.db %00000000,%00011111,%11111100
EnemySprites_10_Layer_1:
	.db %00000000,%01000001,%10000000
	.db %00000000,%10100010,%01000000
	.db %00000001,%00010010,%01000010
	.db %00000000,%10100001,%10000101
	.db %00000010,%01011110,%00001001
	.db %00000101,%01111111,%00010101
	.db %00000010,%10111111,%10101010
	.db %00000111,%00110101,%11010000
	.db %00111110,%01101010,%11110000
	.db %01110111,%11110101,%11111100
	.db %11100011,%11111111,%11110110
	.db %11111111,%11111111,%11100011
	.db %01111111,%11111111,%10111101
	.db %00011111,%11111111,%00011111
	.db %00000001,%11111111,%11111110
	.db %00000000,%00011111,%11111100
EnemySprites_11_Size:
	.db 32,32
EnemySprites_11_Layer_0:
	.db %01110000,%00000000,%00000000,%00011110
	.db %11111100,%00000000,%00000000,%00111111
	.db %11111110,%00000000,%00000000,%01111111
	.db %01111111,%00000000,%00000000,%11111110
	.db %00111111,%10001110,%00000001,%11111111
	.db %01111111,%11010001,%00000011,%11111111
	.db %01111111,%11101110,%10000111,%00011110
	.db %00111111,%11110001,%01001110,%11101110
	.db %00111111,%11111000,%10111101,%11111100
	.db %00011111,%11111100,%01111111,%11111000
	.db %00001111,%11111111,%10111110,%11100000
	.db %00000011,%11010001,%00111110,%01000000
	.db %00000000,%11111001,%00111110,%01000000
	.db %00000000,%10001101,%00011100,%01000000
	.db %00000011,%01111100,%10011100,%10000000
	.db %00000100,%10011100,%01110111,%00000000
	.db %00000100,%11011110,%11111111,%10000000
	.db %00011101,%10101111,%11111111,%01000000
	.db %00100010,%11010111,%11111111,%00100000
	.db %00101101,%01111111,%11100001,%10010000
	.db %00101111,%10101111,%11111110,%11010000
	.db %00101000,%11111111,%11100110,%10101000
	.db %00011011,%01111111,%11111011,%01101000
	.db %00001010,%00111100,%01001011,%01010100
	.db %00000101,%01111111,%00101011,%10001000
	.db %00000101,%01111111,%11101010,%00000000
	.db %00000101,%01111000,%11100101,%00000000
	.db %00000010,%11111111,%10100101,%00000000
	.db %00000010,%10111011,%11000101,%00000000
	.db %00000010,%10010011,%11110010,%00000000
	.db %00000001,%00001101,%11111000,%00000000
	.db %00000000,%00000010,%11110000,%00000000
EnemySprites_11_Layer_1:
	.db %01110000,%00000000,%00000000,%00011110
	.db %10001100,%00000000,%00000000,%00100101
	.db %10001010,%00000000,%00000000,%01001001
	.db %01001001,%00000000,%00000000,%10001010
	.db %00101000,%10001110,%00000001,%00110101
	.db %01011000,%11010001,%00000010,%11110001
	.db %01000110,%10101110,%10000101,%00011010
	.db %00100101,%10010001,%01001010,%11101010
	.db %00100010,%01001000,%10110101,%00010100
	.db %00010010,%00100100,%01100111,%10011000
	.db %00001101,%00111111,%11111111,%11100000
	.db %00000011,%01010001,%11101011,%11000000
	.db %00000000,%11111001,%11110111,%11000000
	.db %00000000,%11111001,%11110111,%11000000
	.db %00000011,%11111000,%11110111,%10000000
	.db %00000111,%10010000,%01110111,%00000000
	.db %00000111,%11010000,%01001000,%10000000
	.db %00011111,%11101000,%10000011,%11000000
	.db %00111110,%11111111,%11111111,%11100000
	.db %00111101,%01111000,%11111111,%11110000
	.db %00111111,%10111111,%11111111,%11110000
	.db %00111111,%11110000,%11111111,%10111000
	.db %00011111,%01001111,%00111111,%11111000
	.db %00001110,%00100000,%01001111,%11011100
	.db %00000111,%01000000,%00101111,%10001000
	.db %00000111,%01000000,%00101110,%00000000
	.db %00000111,%01000000,%00100111,%00000000
	.db %00000011,%11000111,%10100111,%00000000
	.db %00000011,%10101110,%01000111,%00000000
	.db %00000011,%10011110,%00110010,%00000000
	.db %00000001,%00001111,%00001000,%00000000
	.db %00000000,%00000010,%11110000,%00000000
LargeSprites_12_Size:
	.db 16,16
LargeSprites_12_Layer_0:
	.db $03,$00
	.db $0C,$F8
	.db $3F,$04
	.db $7F,$82
	.db $FF,$C2
	.db $79,$E1
	.db $30,$79
	.db $1D,$BE
	.db $34,$98
	.db $70,$3E
	.db $F8,$7E
	.db $77,$FE
	.db $90,$9E
	.db $9F,$9F
	.db $7F,$FF
	.db $0F,$9E
LargeSprites_12_Layer_1:
	.db $03,$00
	.db $0F,$F8
	.db $3F,$FC
	.db $40,$FE
	.db $BE,$7E
	.db $59,$BF
	.db $30,$5F
	.db $1D,$A6
	.db $34,$98
	.db $50,$26
	.db $88,$42
	.db $7F,$F2
	.db $9F,$9A
	.db $9F,$99
	.db $70,$79
	.db $0F,$CE
LargeSprites_13_Size:
	.db $18,$13
LargeSprites_13_Layer_0:
	.db $01,$F0,$00
	.db $02,$A8,$00
	.db $03,$58,$00
	.db $03,$58,$00
	.db $02,$A8,$00
	.db $03,$F8,$00
	.db $7D,$B7,$C0
	.db $EF,$1D,$60
	.db $EE,$EF,$E0
	.db $EC,$E6,$A0
	.db $FE,$EF,$E0
	.db $EF,$1D,$60
	.db $7D,$B7,$C0
	.db $03,$F8,$00
	.db $03,$18,$00
	.db $03,$F8,$00
	.db $03,$F8,$00
	.db $03,$F8,$00
	.db $01,$F0,$00
LargeSprites_13Layer_1:
	.db $01,$F0,$00
	.db $02,$A8,$00
	.db $03,$18,$00
	.db $03,$18,$00
	.db $02,$A8,$00
	.db $03,$F8,$00
	.db $7D,$B7,$C0
	.db $EF,$1E,$60
	.db $EE,$EF,$E0
	.db $EC,$E7,$20
	.db $C6,$EF,$E0
	.db $EF,$1E,$60
	.db $7D,$B7,$C0
	.db $03,$F8,$00
	.db $03,$18,$00
	.db $03,$B8,$00
	.db $03,$18,$00
	.db $03,$B8,$00
	.db $01,$F0,$00
LargeSprites_14_Size:
	.db $18,$13
LargeSprites_14_Layer_0:
	.db $01,$F0,$00
	.db $02,$48,$00
	.db $02,$88,$00
	.db $02,$28,$00
	.db $02,$48,$00
	.db $03,$F8,$00
	.db $7D,$B7,$C0
	.db $FF,$1F,$60
	.db $FE,$EE,$60
	.db $FC,$E4,$20
	.db $FE,$EE,$60
	.db $FF,$1E,$E0
	.db $7D,$B7,$C0
	.db $03,$F8,$00
	.db $03,$F8,$00
	.db $03,$78,$00
	.db $03,$F8,$00
	.db $03,$F8,$00
	.db $01,$F0,$00
LargeSprites_14_Layer_1:
	.db $01,$F0,$00
	.db $02,$48,$00
	.db $02,$88,$00
	.db $02,$28,$00
	.db $02,$48,$00
	.db $03,$F8,$00
	.db $7D,$B7,$C0
	.db $EF,$1F,$60
	.db $AA,$EE,$60
	.db $C4,$E4,$20
	.db $AA,$EE,$60
	.db $EF,$1E,$E0
	.db $7D,$B7,$C0
	.db $03,$F8,$00
	.db $03,$78,$00
	.db $02,$A8,$00
	.db $02,$28,$00
	.db $03,$18,$00
	.db $01,$F0,$00
LargeSprites_15_Size:
	.db 7,15
LargeSprites_15_Layer0:
	.db %00000010
	.db %00000010
	.db %00000110
	.db %00000110
	.db %00001100
	.db %00001100
	.db %00111100
	.db %00011000
	.db %00111000
	.db %00110000
	.db %01110000
	.db %01100000
	.db %11100000
	.db %11000000
	.db %10000000
LargeSprites_15_Layer1:
	.db %00000010
	.db %00000010
	.db %00000110
	.db %00000110
	.db %00001100
	.db %00001100
	.db %00111100
	.db %00011000
	.db %00111000
	.db %00110000
	.db %01110000
	.db %01100000
	.db %11100000
	.db %11000000
	.db %10000000
LargeSprites_16_Size:
	.db  $10,$0B
LargeSprites_16_Layer0:
	.db $E0,$00
	.db $F0,$00
	.db $F8,$00
	.db $7C,$00
	.db $3E,$00
	.db $1F,$00
	.db $0F,$C0
	.db $07,$E0
	.db $03,$90
	.db $07,$D0
	.db $02,$E0
LargeSprites_16_Layer1:
	.db $E0,$00
	.db $90,$00
	.db $88,$00
	.db $44,$00
	.db $22,$00
	.db $11,$00
	.db $08,$C0
	.db $05,$E0
	.db $03,$90
	.db $07,$D0
	.db $02,$E0
LargeSprites_17_Size:
	.db $10,$06
LargeSprites_17_Layer0:
	.db $00,$60
	.db $7F,$FC
	.db $80,$64
	.db $80,$6C
	.db $7F,$FC
	.db $00,$70
LargeSprites_17_Layer1:
	.db $00,$60
	.db $7F,$FC
	.db $FF,$E4
	.db $FF,$EC
	.db $7F,$FC
	.db $00,$70
LargeSprites_18_Size:
	.db $10,$0B
LargeSprites_18_Layer0:
	.db $03,$C0
	.db $07,$40
	.db $02,$60
	.db $05,$20
	.db $08,$E0
	.db $11,$40
	.db $22,$00
	.db $44,$00
	.db $88,$00
	.db $90,$00
	.db $E0,$00
LargeSprites_18_Layer1:
	.db $03,$C0
	.db $07,$40
	.db $02,$60
	.db $07,$20
	.db $0F,$E0
	.db $1F,$40
	.db $3E,$00
	.db $7C,$00
	.db $F8,$00
	.db $F0,$00
	.db $E0,$00
LargeSprites_19_Size:
	.db 36,36
LargeSprites_19_Layer0:
	.db %00000000,%00000100,%10010010,%00000000,%00000000
	.db %00000000,%00100000,%00000000,%00000000,%00000000
	.db %00000000,%10001010,%10101010,%10010000,%00000000
	.db %00000000,%00010101,%00010101,%00000000,%00000000
	.db %00000101,%11010100,%01010010,%10100100,%00000000
	.db %00000000,%00110010,%11101100,%10100000,%00000000
	.db %00010010,%01011011,%01010010,%10100010,%00000000
	.db %00001010,%01010101,%10101011,%01011000,%00000000
	.db %00100101,%11101010,%11111101,%01000001,%01000000
	.db %00000110,%00010111,%01010011,%01010100,%00000000
	.db %00101000,%11111011,%10101110,%10100101,%00000000
	.db %01001011,%01010101,%11111011,%01010101,%00000000
	.db %00010010,%11001110,%10011110,%10110001,%01000000
	.db %10110010,%11110011,%11001101,%11010110,%00010000
	.db %01001011,%01011010,%11110110,%11011001,%01000000
	.db %00001010,%11011111,%10111111,%11010101,%00000000
	.db %01010111,%01101101,%00100101,%01101010,%01000000
	.db %10001000,%11111111,%11111110,%11011010,%10000000
	.db %01011011,%10100110,%11011011,%10100100,%00100000
	.db %00000110,%10111011,%10110101,%01101010,%10000000
	.db %10100100,%10110110,%11111101,%10011001,%00100000
	.db %01011011,%01101111,%10111101,%01100100,%00000000
	.db %00001001,%00111011,%01001111,%01110101,%01000000
	.db %01010101,%11010111,%10111101,%11010100,%00000000
	.db %00001001,%01011100,%11101101,%01010011,%00000000
	.db %01000101,%01010111,%01011000,%10110100,%01000000
	.db %00011001,%00101000,%10110110,%00010001,%00000000
	.db %00000100,%01001101,%11010101,%11010000,%00000000
	.db %00000010,%10010100,%01010011,%01001000,%00000000
	.db %00010010,%01101011,%10101010,%10000010,%00000000
	.db %00000000,%10001010,%01010000,%01001000,%00000000
	.db %00000010,%00101010,%10001010,%10010000,%00000000
	.db %00000000,%10000100,%10101000,%00000000,%00000000
	.db %00000000,%00100010,%00000010,%10000000,%00000000
	.db %00000000,%00001000,%10010000,%00000000,%00000000
	.db %00000000,%00000000,%00000010,%00000000,%00000000
LargeSprites_19_Layer1:
	.db %00000000,%00000100,%10010010,%00000000,%00000000
	.db %00000000,%00100000,%00000000,%00000000,%00000000
	.db %00000000,%10001010,%10101010,%10010000,%00000000
	.db %00000000,%00010101,%00010101,%00000000,%00000000
	.db %00000101,%11010100,%01010010,%10100100,%00000000
	.db %00000000,%00110010,%11101100,%10100000,%00000000
	.db %00010010,%01011011,%01010010,%10100010,%00000000
	.db %00001010,%01010101,%10101011,%01011000,%00000000
	.db %00100101,%11101010,%11111101,%01000001,%01000000
	.db %00000110,%00010111,%01010011,%01010100,%00000000
	.db %00101000,%11111011,%10101110,%10100101,%00000000
	.db %01001011,%01010101,%11111011,%01010101,%00000000
	.db %00010010,%11001110,%10011110,%10110001,%01000000
	.db %10110010,%11110011,%11001101,%11010110,%00010000
	.db %01001011,%01011010,%11110110,%11011001,%01000000
	.db %00001010,%11011111,%10111111,%11010101,%00000000
	.db %01010111,%01101101,%00100101,%01101010,%01000000
	.db %10001000,%11111111,%11111110,%11011010,%10000000
	.db %01011011,%10100110,%11011011,%10100100,%00100000
	.db %00000110,%10111011,%10110101,%01101010,%10000000
	.db %10100100,%10110110,%11111101,%10011001,%00100000
	.db %01011011,%01101111,%10111101,%01100100,%00000000
	.db %00001001,%00111011,%01001111,%01110101,%01000000
	.db %01010101,%11010111,%10111101,%11010100,%00000000
	.db %00001001,%01011100,%11101101,%01010011,%00000000
	.db %01000101,%01010111,%01011000,%10110100,%01000000
	.db %00011001,%00101000,%10110110,%00010001,%00000000
	.db %00000100,%01001101,%11010101,%11010000,%00000000
	.db %00000010,%10010100,%01010011,%01001000,%00000000
	.db %00010010,%01101011,%10101010,%10000010,%00000000
	.db %00000000,%10001010,%01010000,%01001000,%00000000
	.db %00000010,%00101010,%10001010,%10010000,%00000000
	.db %00000000,%10000100,%10101000,%00000000,%00000000
	.db %00000000,%00100010,%00000010,%10000000,%00000000
	.db %00000000,%00001000,%10010000,%00000000,%00000000
	.db %00000000,%00000000,%00000010,%00000000,%00000000