


	
DisableInterrupts:

	xor a
	out ($30),a
	
	di
	
	im 1
	ret

RestoreInterrupts:
	ld hl, $8000
	ld de, $8001
	ld (hl), $85
	ld bc, 257
	ldir
	
	
	in a,(2)
	bit 7,a
	jr z,{+1@}
	
	
		ld a,$40
		out ($30),a
		
		ld a,3
		out ($31),a
		
		ld a,(GSCounter)
		out ($32),a
		
		ld a,1
		out ($20),a
		jr {+2@}
	@:
		ld a,(GSCounter)
		ld (interruptCounter),a
		xor a
		out (4),a
	@:
	im 2
	ei
	ret


Interrupt:
	exx
	xor a
	out (3),a ; ack interrupts
	
	in a,(2)
	bit 7,a
	jr nz,{+2@}
		ld hl,interruptCounter
		dec (hl)
		jr z,{+1@}
			ld a,(interruptMask)
			out (3),a
			exx
			ei
			ret
		@:
		ld a,(GSCounter)
		ld (interruptCounter),a
		jr {+2@}
	@:
		ld a,0
		out ($20),a
	@:
	call Disp4Lvl
	
	ld hl,interruptMask
	set 7,(hl)
	ld a,(hl)
	out (3),a ; reenable interrupts
	
	bit 1,a
	jr nz,{+1@}
		ld a,3
		out ($31),a
		ld a,1
		out ($20),a
	@:
	exx
	ei
	
	ret
Disp4Lvl:
	ld    a,%11011011
	or    a
	ld    hl,flags+asm_flag2
	inc   (hl)
	jr    z,__Disp4Lvlskip
	rra
	ld    b,(hl)
	inc   b
	jr    z,__Disp4Lvlskip
	rra
	ld    (hl),-2
__Disp4LvlSkip:
	ex    af,af'
	
	
	ld    hl,frontBuffer2
	ld    de,frontBuffer1
	ld    a,$80
__Disp4LvlEntry:
	out   ($10),a		     ;76+cc into, 71cc loop
	push  af
		ex    (sp),hl		     ;waste
		ex    (sp),hl		     ;waste
		nop			   ;waste
		ld    a,$20
		out   ($10),a		     ;71cc into
		ld    b,12
		__Disp4LvlLoop:
			ex    af,af'
			rra
			ld    c,a
			ex    af,af'
			ld    a,(de)
			xor   (hl)
			and   c
			xor   (hl)
			inc   de
			inc   hl
			out   ($11),a		     ;71cc into, 77cc loop
			djnz  __Disp4LvlLoop
		inc   bc		    ;waste
		ex    af,af'
		rra
		ex    af,af'
	pop   af
	inc   a
	bit   6,a
	jr    z,__Disp4LvlEntry
__Disp4LvlDone:
	
	
	ret
