.export
.binarymode intel

.inclabels "ti8x.lbl"			; Label file containing equates

_JForceCmd		.equ 402Ah
_homeup			.equ 4558h

.deflong bjump(label)			; Jump macro
	call BRT_JUMP0
	.dw label
.enddeflong

.deflong bcall(label)			; Call macro
	rst rBR_CALL
	.dw label
.enddeflong

.defpage 0, 16*1024, $4000		; Page 0 definition
.defpage 1, 16*1024, $4000		; Page 1 definition
.defpage 2, 16*1024, $4000		; Page 2 definition

#define _fillBasePageTable $5011
#define listEditPtrs $96FC

#define smallEditCol $8177
;;;; the following block depends on this
; 218 bytes total, 18 bytes free
#define TileMapData smallEditCol         ; 98 bytes large
#define LFSRSeed TileMapData+98          ; 8 bytes large
#define enemy LFSRSeed+8                 ; 17 bytes large
#define reuben enemy+17                  ; 21 bytes large
#define textBuffer reuben+21             ; 6 bytes large
#define textCounter textBuffer+6         ; 2 bytes large
#define moveDirection textCounter+2      ; 1 byte large
#define moveCounter moveDirection+1      ; 1 byte large
#define walkableTiles moveCounter+1      ; 1 byte large
#define tmp1 walkableTiles+1             ; 1 byte large
#define tmp2 tmp1+1                      ; 1 byte large
#define battlePoison tmp2+1              ; 1 byte large
#define tmpTile battlePoison+1           ; 16 bytes large
#define tmpTile2 tmpTile+16              ; 8 bytes large
#define nextEnemyCounter tmpTile2+8      ; 1 byte large
#define tmpBottles nextEnemyCounter+1    ; 4 bytes large
#define quakeCounter tmpBottles+4        ; 1 byte large
#define quakeMins quakeCounter+1         ; 1 byte large
#define quakeSecs quakeMins+1            ; 1 byte large
#define tmp3 quakeSecs+1                 ; 1 byte large
#define GSCounter tmp3+1                 ; 1 byte large
#define GSContrast GSCounter+1           ; 1 byte large
#define interruptMask GSContrast+1       ; 1 byte large
#define interruptCounter interruptMask+1 ; 1 byte large
#define 5byteBackBuf interruptCounter+1  ; 5 byte large

#define enemy_id enemy
#define enemy_lvl enemy+1
#define enemy_hp enemy+2
#define enemy_exp enemy+4
#define enemy_sl1 enemy+6
#define enemy_sl2 enemy+7
#define enemy_sl3 enemy+8
#define enemy_sl4 enemy+9
#define enemy_sl5 enemy+10
#define enemy_tile1 enemy+11
#define enemy_tile2 enemy+12
#define enemy_tile3 enemy+13
#define enemy_tile4 enemy+14
#define enemy_xpos enemy+15
#define enemy_ypos enemy+16

#define reuben_lvl reuben
#define reuben_hp reuben+1
#define reuben_exp reuben+3
#define reuben_mp reuben+5
#define reuben_maxhp reuben+6
#define reuben_nextexp reuben+8
#define reuben_maxmp reuben+10
#define reuben_gold reuben+11
#define reuben_bottle1 reuben+13
#define reuben_bottle2 reuben+14
#define reuben_bottle3 reuben+15
#define reuben_bottle4 reuben+16
#define reuben_contrast reuben+17
#define reuben_map reuben+18
#define reuben_x reuben+19
#define reuben_y reuben+20



#define INTRPT_MASK %00001011
#define textShadPtrs $8588
#define keyToStr $9D76
#define basepage $8584

#define frontBuffer1 PlotSScreen
#define frontBuffer2 AppBackUpScreen
#define backBuffer1 SaveSScreen
#define backBuffer2 StatVars


.page 0
#define APPNAME "Reuben 2"
#define APPPAGES 3
#include header.asm
	jr Run
	.branch LoadTileMap
	.branch Text
	.branch NumText
	.branch PutSpriteXOR
	.branch PutBigSpriteXOR
	.branch Multiply
	.branch StartupProg
	.branch StopProg
	.branch GrayTuner
	.branch loadInterruptSettings
	.branch Sleep
Run:
	
	in a,(6) ; store basepage
	ld (basepage),a
	
	bcall(_memchk)
	or a
	ld de,37
	sbc hl,de
	jr nc,{+1@}
		ld hl,0
		ld (curRow),hl
		ld hl,notEnoughRam
		ld de,SaveSScreen
		ld bc,notEnoughRamLen
		ldir
		bcall(_delres)
		bcall(_ClrLCDFull)
		bcall(_HomeUP)
		ld hl,SaveSScreen
		bcall(_putS)
		bcall(_Newline)
		bcall(_putS)
		bcall(_getKey)
		bjump(_JForceCmdNoChar)
	@:
	
	bcall(_StartupProg)
	
	
	call RestoreScreenSettings
	
	ld a,$80
	ld i,a
	
	bcall(_loadInterruptSettings)
	
	call DisableInterrupts

	; load appvar
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	jr c,_Run_No_AppVar
	
	ld a,b
	or a
	jr nz,_Run_AppVar_in_Flash
	jr _Run_AppVar_in_RAM
_Run_No_AppVar:
	ld hl,AppVarName ; create the appvar
	rst rMov9ToOP1
	ld hl,23
	bcall(_CreateAppVar)
	inc de ; header
	inc de
	ld hl,ReubenDefaultData
	ld bc,23
	ldir
	
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	
_Run_AppVar_in_RAM:
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_Arc_Unarc)
	bcall(_ChkFindSym)
_Run_AppVar_in_Flash:
	; no need to ei etc as that does the Load
	call Load
	
	
	
	ld a,%10111110 ; listen to key groups
	out (1),a
	
	call MainMenu
	
	; this is when we exit
	call DisableInterrupts
	bcall(_StopProg)
	bjump(_JForceCmdNoChar)		 ; Exit


StartActualGame:
	call SetBattleCounter
	
	
	ld a,0 ; set up ram stuff
	ld (moveCounter),a
	ld (moveDirection),a
	ld a,(reuben_bottle1)
	and %01000000
	jr z,{+1@}
		ld a,8
		ld (walkableTiles),a
	jr {+2@}
	@:
		ld a,1
		ld (walkableTiles),a
	@:
	
	ld hl,TileMapData
	ld a,(reuben_map)
	ld (hl),a
	cp $08    ; start map, we need the intro
	jr nz,{+1@}
		call Intro
		ld a,$08
		ld (TileMapData),a
	@:
	
	ld a,(reuben_x)
	ld b,a
	ld a,(reuben_y)
	ld c,a
	
	call GameLoop
	
	ret
GameLoop:
	push bc
	
	call ClrBackBuffers
	bcall(_LoadTileMap)
	call TileMap
	
	pop bc
	call Move
	cp 0
	jr z,GameLoop
	ret

RestoreScreenSettings:
	@:
		in a,($10)
		bit 7,a
		jr nz,{-1@}
	ld    a,$07
	out   ($10),a		     ; set LCD to increase mode
	@:
		in a,($10)
		bit 7,a
		jr nz,{-1@}
	ld a,$01
	out ($10),a ; set to 8 bit mode
	ret

Load:
	call DisableInterrupts
	ld hl,AppVarName                         ; load appvar into reuben
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	ex de,hl
	
	ld a,1+2+7+AppVarNameLen+2
	@:
		bcall(_LoadDEIndPaged)
		dec a
		jr nz,{-1@}
	ld a,b
	
	ld bc,23
	ld de,reuben
	bcall(_FlashToRAM)
	
	
	
	call RestoreScreenSettings
	call RestoreInterrupts
	call SetBattleCounter
	ret

Halt:
	push hl
		ld hl,interruptMask
		res 7,(hl)
		@:
			bit 7,(hl)
			jr z,{-1@}
		res 7,(hl)
	pop hl
	ret

Sleep:
; a - number
	push bc
		ld b,a
		in a,(2)
		bit 7,a
		jr nz,_Sleep_loop
		srl b
		jr nz,_Sleep_loop
		inc b
		_Sleep_loop:
			call Halt
		djnz _Sleep_loop
	pop bc
	ret

Save:
	ld hl,PlotSScreen
	call ClrBuffer
	ld hl,AppBackUpScreen
	call ClrBuffer
	call Halt ; make sure screend is cleared
	call DisableInterrupts

		ld iy,flags
		
		
		ld hl,AppVarName     ; appvar is in ram now
		rst rMov9ToOP1
		bcall(_Arc_Unarc)
		
		inc de  ; header
		inc de
		ld hl,reuben
		ld bc,23
		ldir
		
		ld hl,AppVarName     ; appvar is in archive now
		rst rMov9ToOP1
		bcall(_Arc_Unarc)
		
		
		ld hl, $8000
		ld de, $8001
		ld (hl), $85
		ld bc, 257
		ldir
		
		ld a,(reuben_map)   ; somehow the tilemap gets destroyed
		ld (TileMapData),a
		bcall(_LoadTileMap)
	call Update
	call RestoreInterrupts
	ld a,%10111110 ; listen to key groups
	out (1),a
	call Update
	ret

SetBattleCounter:
	ld b,180
	call random
	add a,80-4 ; bitrange!
	ld (nextEnemyCounter),a
	ret

Wait_Key_Input:
	in a,(1) ; get keypress
	cp $FF
	jr nc,Wait_Key_Input
	ret
Wait_Key_Release:
	push af
@:
	in a,(1) ; get keypress
	cp $FF
	jr c,{-1@}
	pop af
	ret

Devide:
; 16 bit devide (u/v)
;INPUT: hl = u
;;bc = v
;Output: de
;Destroys: a
	xor a
	ld d,a
	ld e,a
	inc de
	sbc hl,bc
	jr nc,$-3
	dec de
	ret

Multiply:
; 16 bit multiply
;INPUT: hl = factor 1
;;b = factor 2
;Output: hl
;Destroys: de,a
	ld a,b ; check if we mulitply by 0
	cp 0
	jr z,{+1@}
	
	ld d,h
	ld e,l
	add hl,de
	djnz $-1
	xor a ; reset carry else we can't subtract
	sbc hl,de
	ret
@:
	ld h,0
	ld l,0
	ret

ReubenDefaultData: ; note to self: little endian
	.db $01 ; lvl
	.db $02,$01 ; hp
	.db $00,$00 ; exp
	.db $17 ; mp
	.db $02,$01 ; max hp
	.db $0A,$00 ; next exp
	.db $17 ; max mp
	.db $00,$00 ; gold
	.db %00001000,%00000000,%00000000,%00000000 ; bottles and events
	.db $00 ; conrast: 00 is invalid, thus fetching from OS
	.db $08 ; map
	.db $30 ; x-pos
	.db $28 ; y-pos
	.db $00,$00 ; cur exp

notEnoughRam:
	.asc "Not enough RAM",0
	.asc "*Press any key*",0
notEnoughRamLen = $ - notEnoughRam

AppVarName:
	.db AppVarObj,"R2Sav",0
AppVarNameLen = $ - AppVarName - 2

#include "sprites-remap.asm"
#include "graphics.asm"
#include "move.asm"
#include "gray.asm"
#include "battle.asm"
#include "random.asm"
#include "chars.asm"
#include "speech.asm"
#include "stats.asm"
#include "animations.asm"
#include "menu.asm"

.echoln "bytes in use on page ",#,": ",$-$4000
.page 1
	#include "maps-remap.asm"
	
	
.echoln "bytes in use on page ",#,": ",$-$4000
.page 2
	#include "enemysprites.asm"
	
	#include "text.asm"
	#include "strings.asm"
	
	#include "saveload.asm"
.echoln "bytes in use on page ",#,": ",$-$4000
.end
