Earthquake_no_time:
	push bc
		ld hl,quakeCounter
		inc (hl)
		ld a,(hl)
		and %00000100
		jr z,{+1@}
			ld a,$7C
			jr {+2@}
		@:
			ld a,$40
		@:
		out ($10),a
	pop bc
	push bc
		call _Move_Draw_Character
	pop bc
	ret
Earthquake:
	push bc
		ld hl,quakeCounter
		inc (hl)
		ld a,(hl)
		and %00000100
		jr z,{+1@}
			ld a,$7C
			jr {+2@}
		@:
			ld a,$40
		@:
		out ($10),a
		ld a,(textShadPtrs)
		cpl
		cp 0
		jr nz,{+1@}
			pop bc
			push bc
			call _Move_Draw_Character
		@:
		ld a,(quakeMins)
		ld hl,$0840
		call _Quake_Draw_Number
		ld a,(quakeSecs)
		ld hl,$0850
		call _Quake_Draw_two_digit_Number
		
		ld a,(quakeCounter)
		and %00011111
		jr nz,_Skip_Update_quake_time
			ld hl,quakeSecs
			dec (hl)
			ld a,(hl)
			cp $FF
			jr nz,{+1@}
				ld a,59
				ld (hl),a
				ld hl,quakeMins
				dec (hl)
				ld a,(hl)
				cp $FF
				jr z,_Quake_Die
			@:
		_Skip_Update_quake_time:
	pop bc
	xor a
	ret
_Quake_Die:
	pop bc
	ld a,1
	ret
_Quake_Draw_two_digit_Number:
	push af
		push hl
			ld de,_Quake_LUT
			ld h,0
			ld l,a
			add hl,de
			ld a,(hl)
		pop hl
		push hl
			call _Quake_Draw_Number
		pop hl
		ld a,6
		add a,l
		ld l,a
	pop af
	push hl
		ld de,_Quake_LUT_2
		ld h,0
		ld l,a
		add hl,de
		ld a,(hl)
	pop hl
	call _Quake_Draw_Number
	ret
_Quake_LUT:
	.db 0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1
	.db 2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3
	.db 4,4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5
_Quake_LUT_2:
	.db 0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9
	.db 0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9
	.db 0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9
_Quake_Draw_Number:
	push hl
		ld b,a
		add a,a
		add a,b
		add a,a
		add a,b
		
		ld h,0
		ld l,a
		ld de,Chars
		add hl,de
		push hl
		pop ix
	pop hl
	ld a,l
	ld de,PlotSScreen
	push af
	push hl
	push ix
		ld b,7
		call PutSpriteXOR
	pop ix
	pop hl
	pop af
	ld de,AppBackUpScreen
	ld b,7
	call PutSpriteXOR
	
	ret


_Move_Battle_Enemies:
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; natoria
	.db $01,$00,$01,$00,$01,$00,$01,$00,$01,$00 ; east forest
	.db $02,$03,$02,$02,$03,$02,$03,$02,$02,$02 ; kyle cave
	.db $04,$05,$04,$05,$04,$05,$04,$05,$04,$04 ; golem ruins
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; rosa
	.db $07,$08,$0A,$08,$0A,$08,$0A,$07,$08,$0A ; beach
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; dwarf cave
	.db $0B,$0D,$0B,$0D,$0B,$0D,$0B,$0D,$0B,$0E ; other world
	.db $10,$11,$10,$11,$10,$11,$10,$11,$10,$11 ; west forest
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; other world (no enemies)
Move:
; move engine
;INPUT: b = xPos
;; c = yPos
;Destroys: ALL
	call _Move_Draw_Character
	ld a,%10111110 ; listen to key groups
	out (1),a
	ld a,(reuben_bottle1) ; reset tmp flag
	and %11101111
	ld (reuben_bottle1),a
	
	ld a,(reuben_bottle3)
	and %00010000
	jp z,_MoveKeyLoop ; init earthquake time!
	
	ld a,(TileMapData)
	cp $05
	jr nz,{+1@}
		
		ld a,$40     ; done with THE GAME!!!
		out ($10),a
		
		call Outro
		
		ld a,1
		ret
	@:
	push bc
		ld ix,PlotSScreen+(12-4)
		ld iy,AppBackUpScreen+(12-4)
		ld de,12-4
		xor a
		ld b,16
		@:
			push bc
				ld b,4
				@:
					push bc
						ld (ix),a
						ld (iy),a
						inc ix
						inc iy
					pop bc
					djnz {-1@}
				add ix,de
				add iy,de
			pop bc
			djnz {-2@}
		ld bc,$4000
		ld hl,time
		xor a
		bcall(_Text)
		ld bc,$4808
		ld hl,colon
		xor a
		bcall(_Text)
		
		ld ix,PlotSScreen+(12-4)
		ld iy,SaveSScreen+(12-4)
		ld de,12-4
		ld b,16
		@:
			push bc
				ld b,4
				@:
					push bc
						ld a,(ix)
						ld (iy),a
						inc ix
						inc iy
					pop bc
					djnz {-1@}
				add ix,de
				add iy,de
			pop bc
			djnz {-2@}
		
		ld ix,AppBackUpScreen+(12-4)
		ld iy,StatVars+(12-4)
		ld de,12-4
		ld b,16
		@:
			push bc
				ld b,4
				@:
					push bc
						ld a,(ix)
						ld (iy),a
						inc ix
						inc iy
					pop bc
					djnz {-1@}
				add ix,de
				add iy,de
			pop bc
			djnz {-2@}
	pop bc
	ld a,(TileMapData)
	cp $4F
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle4)
	and %10000000
	jp nz,_MoveKeyLoop
	; time to let the bridge collapse
	
	ld a,(reuben_bottle4)
	or %10000000
	ld (reuben_bottle4),a
	ld e,5*8
	ld a,$FF
	ld (textShadPtrs),a ; we late the earthquake routine think we hit no key and thus update the screen
	@:
		inc b
		push de
			call Earthquake
		pop de
		cp 0
		jp nz,_MoveDie
		dec e
		ld a,e
		cp 0
		jr nz,{-1@}
		
	ld d,b
	ld e,c
	push bc
		ld hl,tmpTile2 ; make sure our temp tile is 0
		ld b,8
		@:
			ld (hl),0
			inc hl
			djnz {-1@}
		
		ld b,5
		@:
			push bc
				push de
					ld a,5
					sub b
					add a,a
					add a,a
					add a,a
					ld b,4
					@:
						push bc
							push af
								ld a,4
								sub b
								add a,a
								add a,a
								add a,a
								add a,3*8
								ld h,a
							pop af
							push af
							push hl
								ld b,8
								ld ix,tmpTile2
								ld de,SaveSScreen
								call PutSpriteAND
							pop hl
							pop af
							push af
							push hl
								ld b,8
								ld ix,tmpTile2
								ld de,StatVars
								call PutSpriteAND
							pop hl
							pop af
							push af
								ld b,8
								ld ix,sprites+(16*$23)
								call GraySpriteXOR
							pop af
						pop bc
						djnz {-1@}
				pop de
				ld b,8
				@:
					push bc
					push de
						ld b,d
						ld c,e
						call Earthquake
					pop de
					pop bc
					djnz {-1@}
			pop bc
			djnz {-3@}
	pop bc
	
	ld a,$23
	ld (TileMapData+2+(4*12)+4),a
_MoveKeyLoop:
	ld a,(reuben_bottle3)
	and %00010000
	jr z,{+1@} ; earthquake time!
		call Earthquake
		cp 0
		jp nz,_MoveDie
	@:
	
	in a,(1) ; get keypress
	ld (textShadPtrs),a
	cp %01111111 ; del key
	jp z,_MoveExit_Dialog
	cpl
	and $0F
	jr nz,_Move_Arrowpress ; actual moving
	
_Move_After_Arrowpresses:
	ld a,(textShadPtrs)
	and %00100000 ; 2ND key
	jp z,_MoveAction
	
	ld a,(textShadPtrs)
	and %01000000
	jr nz,_MoveKeyLoop
	
_MoveStats:
	push bc
		call StatsMenu
	pop bc
	call _Move_Draw_Character
	jr _MoveKeyLoop
_Move_Arrowpress:
	ld a,(textShadPtrs)
	and %00000001
	jp z,_Move_Down
_Move_After_Down:
	ld a,(textShadPtrs)
	and %00000010
	jp z,_Move_Left
_Move_After_Left:
	ld a,(textShadPtrs)
	and %00000100
	jp z,_Move_Right
_Move_After_Right:
	ld a,(textShadPtrs)
	and %00001000
	jp z,_Move_Up
_Move_After_Up:
	ld a,2
	call Sleep
	call _Move_Draw_Character
	ld hl,nextEnemyCounter
	dec (hl)
	ld a,(hl)
	cp 0
	jp nz,_MoveKeyLoop
	
	ld a,(reuben_bottle3)  ; no battle engine on earthquake
	and %00010000
	jp nz,_MoveKeyLoop
	
	push bc
		ld a,(TileMapData+1)
		and $0F                ; this is now the area id
		cp 0                   ; natoria
		jr z,_Move_Cont_Pop_BC
		cp 4                   ; rosa
		jr z,_Move_Cont_Pop_BC
		cp 6                   ; dwarf cave
		jr z,_Move_Cont_Pop_BC
		cp 9                   ; other world without enemies
		jr z,_Move_Cont_Pop_BC
		
		ld b,a
		add a,a
		add a,a
		add a,b
		add a,a
		
		ld d,0
		ld e,a
		ld hl,_Move_Battle_Enemies
		add hl,de
		ld b,10
		call random
		ld e,a
		add hl,de
		ld a,(hl)
		
		call BattleEngine
		cp 1
		jr z,_Move_Player_Dead
		call SetBattleCounter
		
		call ClrBackBuffers    ; re-draw the world
		call TileMap
	pop bc
	push bc
		call _Move_Draw_Character
		
	pop bc
	jp _MoveKeyLoop
_Move_Player_Dead:
	pop bc
	ld a,1
	ret
_Move_Cont_Pop_BC:
	pop bc
	jp _MoveKeyLoop


_Move_Down:
	ld a,2
	ld (moveDirection),a
	
	ld a,c
	cp 56 ; at bottom of screen
	jp z,_MoveExit_Down
	
	; collision check
	ld de,$0008 ; 0,8 ; lower left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Down_Align_Right
	
	ld de,$0708 ; 7,8 lower right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Down_Align_Left
	
	inc c
	jp _Move_After_Down
_Move_Down_Align_Right:
	ld a,(textShadPtrs)
	rrca
	rrca
	jp nc,_Move_After_Down ; we want to move left!
	rrca
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Down ; may not be alligned
	
	ld de,$0800 ; 8,0 ; tile to the right
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	ld de,$0808 ; 8,8 tile to the right down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	inc b
	
	jp _Move_After_Up ; that's it folks!
_Move_Down_Align_Left:
	ld a,(textShadPtrs)
	rrca
	rrca
	rrca
	jp nc,_Move_After_Down ; we want to move right!
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Down ; may not be alligned
	
	ld de,$FF00 ; -1,0 ; tile to the left
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	ld de,$FF08 ; -1,8 tile to the left down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	dec b
	
	jp _Move_After_Up ; that's it folks!
_Move_Left:
	ld a,3
	ld (moveDirection),a
	
	ld a,b
	cp 0
	jp z,_MoveExit_Left ; at left
	
	; collision check
	ld de,$FF00 ; 0,0 ; upper left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Left_Align_Down
	
	ld de,$FF07 ; lower left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Left_Align_Up
	
	dec b
	jp _Move_After_Left
_Move_Left_Align_Down:
	ld a,(textShadPtrs)
	rrca
	jp nc,_Move_After_Left ; already moved down
	rrca
	rrca
	rrca
	jp nc,_Move_After_Left ; we want to move up!
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Left ; may not be alligned
	
	ld de,$0008 ; 0,8 ; tile to the down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	ld de,$FF08 ; -1,8 tile to the left down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	inc c
	
	jp _Move_After_Up ; that's it folks!
_Move_Left_Align_Up:
	ld a,(textShadPtrs)
	rrca
	jp nc,_Move_After_Left ; we want to move up!
	rrca
	rrca
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Left ; may not be alligned
	
	ld de,$0001 ; 0,1 ; tile to the up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	ld de,$FF01 ; -1,1 tile to the left up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	dec c
	
	jp _Move_After_Up ; that's it folks!
_Move_Right:
	ld a,1
	ld (moveDirection),a
	
	ld a,b
	cp 88 ; at right of screen
	jp z,_MoveExit_Right
	
	; collision check
	ld de,$0800 ; 8,0 ; upper right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Right_Align_Down
	
	ld de,$0807 ; lower right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Right_Align_Up
	
	inc b
	jp _Move_After_Right
_Move_Right_Align_Down:
	ld a,(textShadPtrs)
	rrca
	jp nc,_Move_After_Right ; already moved down
	rrca
	rrca
	rrca
	jp nc,_Move_After_Right ; wanting to move up!
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Right ; may not be alligned
	
	ld de,$0008 ; 0,8 ; tile to the down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	ld de,$0808 ; -1,8 tile to the right down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	inc c
	
	jp _Move_After_Up ; that's it folks!
_Move_Right_Align_Up:
	ld a,(textShadPtrs)
	rrca
	jp z,_Move_After_Right ; we want to move down!
	rrca
	rrca
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Right ; may not be alligned
	
	ld de,$00FF ; 0,-1 ; tile to the up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	ld de,$08FF ; 8,-1 tile to the right up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	dec c
	
	jp _Move_After_Up ; that's it folks!
_Move_Up:
	xor a
	ld (moveDirection),a
	
	ld a,c
	cp 0 ; at top
	jp z,_MoveExit_Up
	
	; collision check
	ld de,$00FF ; 0,-1 ; upper left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Up_Align_Right
	
	ld de,$07FF ; 7,-1 upper right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Up_Align_Left
	
	dec c
	jp _Move_After_Up
_Move_Up_Align_Right:
	ld a,(textShadPtrs)
	rrca
	rrca
	jp nc,_Move_After_Up ; we want to move left!
	rrca
	jp nc,_Move_After_Up ; already moved right
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Up ; may not be alligned
	
	ld de,$0800 ; 8,0 ; tile to the right
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	ld de,$08FF ; 8,-1 tile to the right up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	inc b
	
	jp _Move_After_Up ; that's it folks!
_Move_Up_Align_Left:
	ld a,(textShadPtrs)
	rrca
	rrca
	jp nc,_Move_After_Up ; already moved left
	rrca
	jp nc,_Move_After_Up ; we want to move right!
	rrca
	rrca
	rrca
	jp nc,_Move_After_Arrowpresses ; we hit 2ND

	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Up ; may not be alligned
	
	ld de,$FF00 ; -1,0 ; tile to the left
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	ld de,$FFFF ; -1,-1 tile to the left up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	dec b
	
	jp _Move_After_Up ; that's it folks!
_Move_Draw_Character_only_back:
	push bc
		ld a,(moveDirection) ; load direction and multiply with 32
		add a,a
		add a,a
		add a,a
		add a,a
		add a,a
		ld e,a
		ld d,0
		
		
		ld hl,moveCounter
		ld a,(hl)
		and %00000100
		jr z,{+1@}
		ld a,e
		add a,16
		ld e,a
	@:
		
		ld hl,ReubenSprites
		add hl,de
		push hl
		pop ix
		
		ld a,b
		ld h,c
		ld b,8
		call GraySpriteXOR
	pop bc ; restore and save position
	ret
_Move_Draw_Character:
	push bc
		ld de,$0404
		call _Move_Grab_Tile
	pop bc
	cp 0
	jp z,_Move_Draw_Character_Normal
	
	
	; here is the drawing stuff if you are on water
	
	push bc
		ld hl,tmpTile2 ; make sure our temp tile is 0
		ld b,8
		@:
			ld (hl),0
			inc hl
			djnz {-1@}
	pop bc
	
	push bc ; save front buffer
		ld de,SaveSScreen
		ld l,c
		ld c,b
		ld ix,tmpTile
		call GetSprite
	pop bc
	push bc ; save back buffer
		ld de,StatVars
		ld l,c
		ld c,b
		ld ix,tmpTile+8
		call GetSprite
	pop bc
	
	push bc ; draw the mask
		ld a,(moveDirection) ; load direction and multiply with 16
		add a,a
		add a,a
		add a,a
		add a,a
		ld e,a
		ld d,0
		
		ld hl,moveCounter
		inc (hl)
		ld a,(hl)
		and %00000100
		jr z,_Move_Draw_Character_swim_skip_1
		ld a,e
		add a,8
		ld e,a
	_Move_Draw_Character_swim_skip_1:
		push de
			ld hl,ReubenMasks
			add hl,de
			push hl
			pop ix
			
			push bc
			push ix
				ld h,c
				ld a,b
				ld b,8
				ld de,SaveSScreen
				call PutSpriteAND
			pop ix
			pop bc
			ld h,c
			ld a,b
			ld b,8
			ld de,StatVars
			call PutSpriteAND
		pop de
	pop bc
	push bc ; draw the reuben
		ld h,d
		ld l,e
		add hl,hl
		ld d,h
		ld e,l
		ld hl,ReubenSpritesSwim
		add hl,de
		push hl
		pop ix
		
		
		ld a,b
		ld h,c
		ld b,8
		call GraySpriteXOR
		
		call Update
	pop bc
	
	push bc   ; erase where we were
		ld ix,tmpTile2
		ld h,c
		ld a,b
		ld b,8
		ld de,SaveSScreen
		call PutSpriteAND
	pop bc
	push bc
		ld ix,tmpTile2
		ld h,c
		ld a,b
		ld b,8
		ld de,StatVars
		call PutSpriteAND
	pop bc
	push bc
		ld ix,tmpTile
		ld h,c
		ld a,b
		push af
		push hl
			ld b,8
			ld de,SaveSScreen
			call PutSpriteXOR
		pop hl
		pop af
		ld b,8
		ld de,StatVars
		call PutSpriteXOR
	pop bc
	ret

_Move_Draw_Character_Normal:
	ld a,(moveDirection) ; load direction and multiply with 32
	add a,a
	add a,a
	add a,a
	add a,a
	add a,a
	ld e,a
	ld d,0
	
	
	ld hl,moveCounter
	inc (hl)
	ld a,(hl)
	and %00000100
	jr z,_Move_Draw_Character_skip_1
	ld a,e
	add a,16
	ld e,a
_Move_Draw_Character_skip_1:
	
	ld hl,ReubenSprites
	add hl,de
	push hl
	pop ix
	
	push bc
		ld a,b
		ld h,c
		ld b,8
		call GraySpriteXOR
		call Update
	pop bc
	
	
	ld a,(moveDirection) ; load direction and multiply with 32
	add a,a
	add a,a
	add a,a
	add a,a
	add a,a
	ld e,a
	ld d,0
	
	ld a,(moveCounter)
	and %00000100
	jr z,_Move_Draw_Character_skip_2
	ld a,e
	add a,16
	ld e,a
_Move_Draw_Character_skip_2:
	
	ld hl,ReubenSprites
	add hl,de
	
	push hl
	pop ix
	
	push bc
		ld a,b
		ld h,c
		ld b,8
		call GraySpriteXOR
	pop bc
	ret

;up - 0
;right - 1
;down - 2
;left - 3
_MoveAction:
	ld a,(moveDirection)
	
	;grab tiles
	cp 0
	jr z,_MoveAction_Up
	
	cp 1
	jr z,_MoveAction_Right
	
	cp 2
	jp z,_MoveAction_Down
	
	cp 3
	jp z,_MoveAction_Left
	
_MoveAction_AfterGrabTile:
	cp $08 ; no action tiles so far down, will break our areas
	jp c,_MoveKeyLoop
	
	cp $14 ; water
	jp c,_Move_Action_Water
	
	cp $17 ; door
	jp c,_Move_Action_Door
	
	cp $18 ; save point
	jp z,_Move_Action_Save
	
	cp $1F ; house exit, we jump to the door action
	jp z,_Move_Action_Door
	
	cp $19 ; person
	jp z,_Move_Action_Person
	
	cp $1B
	jp z,_Move_Action_Switch
	
	cp $1C ; shrub
	jr z,_Move_Action_Shrub
	
	cp $1E ; stone
	jp z,_Move_Action_Stone
	
	cp $1D ; move block thingy
	jp z,_Move_Action_Block
	
	cp $52 ; boss
	jp z,_Move_Action_Boss
	
	cp $80 ; bottle
	jp z,_Move_Action_Bottle
	
	cp $86 ; mirror
	jp z,_Move_Action_Mirror
	
	cp $8B ; bone
	jp z,_Move_Action_Bone
	
	cp $8C ; dog
	jr nz,{+1@}
	ld hl,dogPage14
	xor a
	call Speech
	jp _MoveKeyLoop
@:
	jp _MoveKeyLoop

_MoveAction_Up:
	ld a,c
	cp 7
	jp c,_MoveKeyLoop ; too far to the top
	and 7 ; modulus 8
	jp nz,_MoveKeyLoop ; need to be aligned
	
	ld de,$04F8 ; 4,-8
	call _Move_Grab_Tile
	
	jr _MoveAction_AfterGrabTile
_MoveAction_Right:
	ld a,b
	cp 87
	jp nc,_MoveKeyLoop ; too far to the right
	and 7 ; modulus 8
	jp nz,_MoveKeyLoop ; need to be aligned
	
	ld de,$0804 ; 8,4
	call _Move_Grab_Tile
	
	jr _MoveAction_AfterGrabTile
_MoveAction_Down:
	ld a,c
	cp 55
	jp nc,_MoveKeyLoop ; too far down
	and 7 ; modulus 8
	jp nz,_MoveKeyLoop ; need to be aligned
	
	ld de,$0408 ; 4,8
	call _Move_Grab_Tile
	
	jp _MoveAction_AfterGrabTile
_MoveAction_Left:
	ld a,b
	cp 7
	jp c,_MoveKeyLoop ; too far left
	and 7 ; modulus 8
	jp nz,_MoveKeyLoop ; need to be aligned
	
	ld de,$F804 ; -8,4
	call _Move_Grab_Tile
	
	jp _MoveAction_AfterGrabTile

_Move_Action_Shrub:
	ld a,(TileMapData)
	cp $14
	jr nz,{+1@}
	; garden
	ld a,(reuben_bottle1)
	and %00010000
	jr nz,{+1@}
	ld hl,gardenPage14
	ld a,1
	call Speech
	jp _MoveKeyLoop
@:
	push bc ; save positions
	
	ld (hl),0 ; remove it
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld ix,sprites+($1C*16)
	ld b,8
	call GraySpriteXOR
	pop bc
	
	call _Move_Draw_Character ; update screen and make sure we don't delete our reuben!
	
	jp _MoveKeyLoop
_Move_Action_Bottle:
	push bc ; save positions
		
		ld (hl),0 ; remove it
		
		call _Move_Grab_Tile_To_Sprite_Positions
		
		ld ix,sprites+($80*16)
		ld b,8
		call GraySpriteXOR
	pop bc
	call _Move_Draw_Character
	
	ld hl,bottleDialog
	ld a,1
	call Speech
	
	ld a,(TileMapData)
	cp $14 ; garden
	jr nz,{+1@}
	ld a,(reuben_bottle2)
	or %00001000
	ld (reuben_bottle2),a
	jp _MoveKeyLoop
@:
	
	cp $21 ; swimming
	jr nz,{+1@}
	ld a,(reuben_bottle3)
	or %00001000
	ld (reuben_bottle3),a
	jp _MoveKeyLoop
@:
	
	cp $49 ; house
	jr nz,{+1@}
	ld a,(reuben_bottle4)
	or %00001000
	ld (reuben_bottle4),a
	jp _MoveKeyLoop
@:
	jp _MoveKeyLoop
_Move_Action_Bone:
	call _Move_Draw_Character_only_back
	push bc
		
		ld b,16 ; bone
		ld h,16
		ld a,24
		@:
			push bc
				ld ix,sprites+($8B*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				pop hl
				pop af
				
				dec h ; we move up
				dec a ; and we move left
				ld ix,sprites+($8B*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				
				ld b,0
				nop
				djnz $-1
				call Update
				
				pop hl
				pop af
			pop bc
			djnz {-1@}
		
		ld ix,sprites+($8B*16)
		ld b,8
		call GraySpriteXOR
		call Update
		
		ld b,32 ; dog
		ld h,16
		ld a,32
		@:
			push bc
				ld ix,sprites+($8C*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				pop hl
				pop af
				
				dec a ; we move left
				ld ix,sprites+($8C*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				
				ld b,0
				nop
				djnz $-1
				call Update
				
				pop hl
				pop af
			pop bc
			djnz {-1@}
		
		ld ix,sprites+($8C*16)
		ld b,8
		call GraySpriteXOR
		call Update
	pop bc
	
	call _Move_Draw_Character_only_back
	ld hl,manCallRexPage14
	xor a
	call Speech
	call _Move_Draw_Character_only_back
	push bc
		ld b,6*8 ; man
		ld h,8
		ld a,6*8
		@:
			push bc
				ld ix,sprites+($19*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				pop hl
				pop af
				
				dec a ; we move left
				ld ix,sprites+($19*16)
				ld b,8
				
				push af
				push hl
				call GraySpriteXOR
				
				ld b,0
				nop
				djnz $-1
				call Update
				
				pop hl
				pop af
			pop bc
			djnz {-1@}
		
		ld ix,sprites+($19*16)
		ld b,8
		call GraySpriteXOR
		call Update
	pop bc
	call _Move_Draw_Character_only_back
	ld a,(reuben_bottle1)
	or %00010000
	ld (reuben_bottle1),a
	xor a
	ld (TileMapData+2+12+6),a
	ld (TileMapData+2+24+3),a
	ld (TileMapData+2+24+4),a
	
	jp _MoveKeyLoop
_Move_Action_Save:
	ld a,(reuben_bottle3)
	and %00010000
	jp nz,_MoveKeyLoop ; no time for this!
	push bc
		ld hl,PlotSScreen
		call ClrBuffer
		ld hl,AppBackUpScreen
		call ClrBuffer
	pop bc
	ld hl,(reuben_maxhp)
	ld (reuben_hp),hl
	ld a,(reuben_maxmp)
	ld (reuben_mp),a
	ld a,b
	ld (reuben_x),a
	ld a,c
	ld (reuben_y),a
	ld a,(TileMapData)
	ld (reuben_map),a
	push bc
		call _Battle_Pause_Med
		call Update
		call Save
	pop bc
	call _Move_Draw_Character
	ld hl,saveDialog
	ld a,1
	call Speech
	jp _MoveKeyLoop
_Move_Action_Stone:
	ld a,(reuben_bottle1)
	and %00100000
	jr nz,{+1@}
	ld hl,rockDialog
	ld a,1
	call Speech
	jp _MoveKeyLoop
@:
	push bc ; save positions
	
	ld (hl),0 ; remove it
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld ix,sprites+($1E*16)
	ld b,8
	call GraySpriteXOR
	pop bc
	
	call _Move_Draw_Character ; update screen and make sure we don't delete our reuben!
	
	jp _MoveKeyLoop
_Move_Action_Block:
	ld a,(reuben_bottle1)
	and %10000000
	jp nz,{+1@}
		ld hl,blockTooHeavyDialog
		xor a
		call Speech
		jp _MoveKeyLoop
	@:
	call _Move_Draw_Character_only_back
	push bc
	
	;; actual action block start
	ld a,(moveDirection)
	
	cp 0
	jr z,_Move_Action_Block_Up_Check
	cp 1
	jr z,_Move_Action_Block_Right_Check
	cp 2
	jr z,_Move_Action_Block_Down_Check
	cp 3
	jr z,_Move_Action_Block_Left_Check
	
_Move_Action_Block_Up_Check:
	ld a,c
	cp 15
	jp c,_Move_Action_Block_Cleanup ; too far up
	ld de,$04F0 ; 4,-16
	call _Move_Grab_Tile
	
	jr _Move_Action_Block_After_Check
_Move_Action_Block_Right_Check:
	ld a,b
	cp 79
	jp nc,_Move_Action_Block_Cleanup ; too far right
	ld de,$1004 ; 16,4
	call _Move_Grab_Tile
	
	jr _Move_Action_Block_After_Check
_Move_Action_Block_Down_Check:
	ld a,c
	cp 47
	jp nc,_Move_Action_Block_Cleanup ; too far down
	ld de,$0410 ; 4,16
	call _Move_Grab_Tile
	
	jr _Move_Action_Block_After_Check
_Move_Action_Block_Left_Check:
	ld a,b
	cp 15
	jp c,_Move_Action_Block_Cleanup ; too far left
	ld de,$F004 ; -16,4
	call _Move_Grab_Tile
	
	jr _Move_Action_Block_After_Check

_Move_Action_Block_After_Check:
	
	cp $00 ; we can move the block here!
	jp nz,_Move_Action_Block_Cleanup
	ld a,(moveDirection)
	
	
	
	
	cp 0
	jr z,_Move_Action_Block_Up_Move
	cp 1
	jr z,_Move_Action_Block_Right_Move
	cp 2
	jp z,_Move_Action_Block_Down_Move
	cp 3
	jp z,_Move_Action_Block_Left_Move
	
_Move_Action_Block_Up_Move:
	ld de,$04F8 ; 4,-8
	call _Move_Grab_Tile
	push de
	ld (hl),0 ; remove it
	ld d,$FF
	ld e,$F4
	add hl,de
	ld (hl),$1D
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld b,8
@:
	push bc
	
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	pop hl
	pop af
	
	dec h ; we move up
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	
	ld b,0
	nop
	djnz $-1
	call Update
	
	pop hl
	pop af
	
	pop bc
	djnz {-1@}
	
	jp _Move_Action_Block_Cleanup
_Move_Action_Block_Right_Move:
	ld de,$0804 ; 8,4
	call _Move_Grab_Tile
	push de
	ld (hl),0 ; remove it
	ld d,$00
	ld e,$01
	add hl,de
	ld (hl),$1D
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld b,8
@:
	push bc
	
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	pop hl
	pop af
	
	inc a ; we move right
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	
	ld b,0
	nop
	djnz $-1
	call Update
	
	pop hl
	pop af
	
	pop bc
	djnz {-1@}
	
	jp _Move_Action_Block_Cleanup
_Move_Action_Block_Down_Move:
	ld de,$0408 ; 4,8
	call _Move_Grab_Tile
	push de
	ld (hl),0 ; remove it
	ld d,$00
	ld e,$0C
	add hl,de
	ld (hl),$1D
	
	pop de
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld b,8
@:
	push bc
	
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	pop hl
	pop af
	
	inc h ; we move down
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	
	ld b,0
	nop
	djnz $-1
	call Update
	
	pop hl
	pop af
	
	pop bc
	djnz {-1@}
	
	jr _Move_Action_Block_Cleanup
_Move_Action_Block_Left_Move:
	ld de,$F804 ; -8,4
	call _Move_Grab_Tile
	push de
	ld (hl),0 ; remove it
	ld d,$FF
	ld e,$FF
	add hl,de
	ld (hl),$1D
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	
	ld b,8
@:
	push bc
	
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	pop hl
	pop af
	
	dec a ; we move left
	ld ix,sprites+($1D*16)
	ld b,8
	
	push af
	push hl
	call GraySpriteXOR
	
	ld b,0
	nop
	djnz $-1
	call Update
	
	pop hl
	pop af
	
	pop bc
	djnz {-1@}
	
	jr _Move_Action_Block_Cleanup
_Move_Action_Block_Cleanup:
	pop bc
	call _Move_Draw_Character_only_back
	
	call _Move_Draw_Character ; update screen and make sure we don't delete our reuben!
	
	jp _MoveKeyLoop

_Move_Action_Water:
	ld a,(TileMapData+1)
	and $0F
	cp 7     ; other world
	jr z,{+1@}
	cp 9
	jr z,{+1@}
	
	ld a,1
	ld hl,selectWaterMsg
	push bc
		call Speech
		call PickItem
	pop bc
	push hl
	push af
		call _Move_Draw_Character
	pop af
	pop hl
	cp 4
	jp z,_MoveKeyLoop ; we hit the del key
	ld a,(hl)
	and %11111000
	or 1
	ld (hl),a
	jp _MoveKeyLoop
@:
	xor a
	ld hl,poisonWater
	call Speech
	jp _MoveKeyLoop
_Move_Action_Door:
	ld a,(TileMapData) ; get current map in a
	
	cp $52       ; Entrance to Golem Ruins
	jr nz,{+2@}
	ld a,(reuben_bottle2)
	and %10000000
	jr nz,{+1@}
	ld a,1
	ld hl,doorWontOpen
	call Speech
	jp _MoveKeyLoop
@:
	ld a,$19
	ld (TileMapData),a
	ld b,5*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $19       ; Exit from Golem Ruins
	jr nz,{+1@}
	ld a,$52
	ld (TileMapData),a
	ld b,4*8
	ld c,5*8
	xor a
	ret
@:
	
	cp $54       ; Entrance to Kyle Cave
	jr nz,{+1@}
	ld a,$16
	ld (TileMapData),a
	ld b,4*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $16       ; Exit from Kyle Cave
	jr nz,{+1@}
	ld a,$54
	ld (TileMapData),a
	ld b,7*8
	ld c,5*8
	xor a
	ret
@:
	
	cp $45       ; Entrance to Golem Ruins
	jr nz,{+2@}
	ld a,(reuben_bottle2)
	and %00010000
	jr nz,{+1@}
	xor a
	ld hl,doorWontOpen
	call Speech
	jp _MoveKeyLoop
@:
	ld a,$41
	ld (TileMapData),a
	ld b,8*8
	ld c,5*8
	xor a
	ret
@:
	
	cp $41       ; exit from dwarf cave
	jr nz,{+1@}
	ld a,$45
	ld (TileMapData),a
	ld b,9*8
	ld c,2*8
	xor a
	ret
@:
	
	cp $61       ; entrance to inner dwarf cave
	jr nz,{+1@}
	ld a,$99
	ld (TileMapData),a
	ld b,7*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $99       ; exit from inner dwarf cave
	jr nz,{+1@}
	ld a,$61
	ld (TileMapData),a
	ld b,2*8
	ld c,5*8
	xor a
	ret
@:
	
	cp $43       ; entrance to other world
	jr nz,{+1@}
	ld a,$5B
	ld (TileMapData),a
	ld b,5*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $59      ; exit from other world
	jr nz,{+1@}
	ld a,$05
	ld (TileMapData),a
	ld b,5*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $3A      ; other world house entrance
	jr nz,{+1@}
	ld a,$0C
	ld (TileMapData),a
	ld b,6*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $0C     ; other world house exit
	jr nz,{+1@}
	ld a,$63
	ld (TileMapData),a
	ld b,1*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $63     ; other world back house entrance
	jr nz,{+1@}
	ld a,$48
	ld (TileMapData),a
	ld b,6*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $48     ; other world back house exit
	jr nz,{+1@}
	ld a,$3A
	ld (TileMapData),a
	ld b,3*8
	ld c,5*8
	xor a
	ret
@:
	
	cp $14     ; garden
	jr nz,{+1@}
	ld hl,housePage14
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $13     ; natoria lower house
	jr nz,{+2@}
	ld a,c
	cp 2*8
	jr z,{+1@}
	ld hl,housePage13
	call HouseSpeech
	jp _MoveKeyLoop
@:
	ld iy,_Shop_Bottles_Natoria
	call Shop
	jp _MoveKeyLoop
@:
	
	cp $23
	jr nz,{+1@}
	ld iy,_Shop_Bottles_Rosa
	call Shop
	jp _MoveKeyLoop
@:
	
	cp $22 ; other village left house
	jr nz,{+1@}
	ld hl,housePage22
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $24 ; other village right up house
	jr nz,{+1@}
	ld hl,housePage24
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $09     ; natoria upper house
	jr nz,{+1@}
	ld hl,housePage09
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $1F     ; natoria lower right house
	jr nz,{+1@}
	ld b,8*8     ; else we can appear inside of the shrub!
	ld hl,housePage1F
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $2F     ; opus' house
	jr nz,{+2@}
	ld a,(reuben_bottle1)
	and %01000000
	jr nz,{+1@}
	
	ld hl,housePage2F
	call HouseSpeech
	ld a,(reuben_bottle1)
	or %01000000
	ld (reuben_bottle1),a
	
	ld a,8
	ld (walkableTiles),a
	jp _MoveKeyLoop
@:
	ld hl,housePage2Fpost
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $83      ; dwarf village lower right
	jr nz,{+2@}
	ld a,c
	cp 2*8
	jr z,{+1@}
	ld hl,housePage83left
	call HouseSpeech
	jp _MoveKeyLoop
@:
	ld hl,housePage83right
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $81      ; dwarf village lower left
	jr nz,{+1@}
	ld hl,housePage81
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $78      ; dwarf king
	jr nz,{+2@}
	ld a,(reuben_bottle1)
	and %00100000
	jr nz,{+1@}
	ld hl,housePage78
	call HouseSpeech
	ld a,(reuben_bottle1)
	or %00100000
	ld (reuben_bottle1),a
	ld a,$33
	ld (TileMapData),a
	xor a
	ret
@:
	ld hl,housePage78post
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	cp $33      ; alt dwarf king
	jr nz,{+1@}
	ld hl,housePage33
	call HouseSpeech
	jp _MoveKeyLoop
@:
	
	jp _MoveKeyLoop

_Move_Action_Mirror:
	ld a,(TileMapData)
	
	cp $05       ; entrance to other world
	jr nz,{+1@}
	ld a,$43
	ld (TileMapData),a
	ld b,6*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $5B       ; exit from other world
	jr nz,{+1@}
	ld a,$59
	ld (TileMapData),a
	ld b,6*8
	ld c,6*8
	xor a
	ret
@:
	
	cp $BC       ; other world shift entrance
	jr nz,{+1@}
	ld a,$3A
	ld (TileMapData),a
	call Wait_Key_Release
	ld b,10*8
	ld c,3*8
	xor a
	ret
@:
	
	cp $3A       ; other world shift exit
	jr nz,{+1@}
	ld a,$BC
	ld (TileMapData),a
	call Wait_Key_Release
	ld b,5*8
	ld c,4*8
	xor a
	ret
@:
	
	cp $3D       ; alt dwarf trap
	jr nz,{+1@}
	
	ld a,1
	ld hl,mirrorPage3D
	call Speech
	ld a,$0C
	call BattleEngine
	cp 0
	jp nz,_MoveDie
	call ClrAllBuffers
	ld a,1
	ld hl,mirrorPage3Dpost
	call Speech
	ld b,5*8
	ld c,4*8
	ld a,$82
	ld (TileMapData),a
	xor a
	ret
@:
	
	cp $37      ; final, real, mirror
	jr nz,{+1@}
	ld a,(reuben_bottle3)
	and %00010000
	jp nz,_MoveKeyLoop ; NO TIME FOR THIS!!!!!
	
	ld a,$0B
	ld (TileMapData),a
	call ClrBackBuffers
	bcall(_LoadTileMap)
	call TileMap
	ld b,5*8
	ld c,6*8
	call _Move_Draw_Character
	
	call _Battle_Pause
	call _Battle_Pause
	
	ld hl,mirrorSpeechPre
	ld a,1
	call Speech
	ld a,$0F
	call BattleEngine
	cp 0
	jp nz,_MoveDie
	
	call ClrBackBuffers
	call TileMap
	ld b,5*8
	ld c,6*8
	call _Move_Draw_Character
	
	ld a,1
	ld hl,mirrorSpeachPost
	call Speech
	
	push bc
		ld d,b
		ld e,c
		ld b,64
		@:
			push bc
				ld b,d
				ld c,e
				call Earthquake_no_time
			pop bc
			djnz {-1@}
	pop bc
	
	ld a,1                 ; we can't swim anymore
	ld (walkableTiles),a
	ld a,2
	ld (quakeMins),a
	xor a
	ld (quakeSecs),a
	ld a,(reuben_bottle3)
	or %00010000
	ld (reuben_bottle3),a
	ld a,$37
	ld (TileMapData),a
	ld b,5*8
	ld c,4*8
	xor a
	ret
@:
	jp _MoveKeyLoop
_Move_Action_Person
	ld a,(TileMapData)
	
	cp $08      ; start screen
	jr nz,{+1@}
	ld a,1
	ld hl,lafPage08
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $14      ; garden
	jr nz,{+1@}
	xor a
	ld hl,manPage14
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $1E      ; forest entry
	jr nz,{+1@}
	xor a
	ld hl,manPage1E
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $38      ; other village entry
	jr nz,{+1@}
	xor a
	ld hl,manPage38
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $23      ; other village center
	jr nz,{+1@}
	ld a,1
	ld hl,manPage23
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $83      ; dwarf village lower right
	jr nz,{+1@}
	ld a,1
	ld hl,manPage83
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $76      ; dwarf village upper left
	jr nz,{+1@}
	ld a,1
	ld hl,manPage76
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $28      ; alt dwarf
	jr nz,{+1@}
	xor a
	ld hl,manPage28
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $3D      ; alt dwarf mass
	jr nz,{+1@}
	ld a,1
	ld hl,manPage3D
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $01      ; other world house
	jr nz,{+1@}
	xor a
	ld hl,manPage01
	call Speech
	jp _MoveKeyLoop
@:
	jp _MoveKeyLoop
_Move_Action_Switch:
	ld a,(TileMapData)
	
	cp $17      ; kyle cave
	jr nz,{+1@}
	ld a,(reuben_bottle2)
	and %10000000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle2)
	or %10000000
	ld (reuben_bottle2),a
	xor a
	ld hl,switchInside
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $03      ; golem ruins
	jr nz,{+2@}
	ld a,b
	cp 3*8
	jr nz,{+1@}
	
	ld a,(reuben_bottle2)
	and %01000000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle2)
	or %01000000
	ld (reuben_bottle2),a
	ld a,1
	ld hl,switchInside
	call Speech
	call _Move_Golem_Ruins_Remove_Tile
	jp _MoveKeyLoop
@:
	ld a,(reuben_bottle2)
	and %00100000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle2)
	or %00100000
	ld (reuben_bottle2),a
	ld a,1
	ld hl,switchInside
	call Speech
	call _Move_Golem_Ruins_Remove_Tile
	jp _MoveKeyLoop
@:
	
	cp $4B     ; dwarf cave
	jr nz,{+1@}
	ld a,(reuben_bottle3)
	and %10000000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle3)
	or %10000000
	ld (reuben_bottle3),a
	xor a
	ld hl,switchInside
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $62     ; more cave
	jr nz,{+1@}
	ld a,(reuben_bottle3)
	and %01000000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle3)
	or %01000000
	ld (reuben_bottle3),a
	xor a
	ld hl,switchInside
	call Speech
	jp _MoveKeyLoop
@:
	
	cp $5E     ; other world
	jr nz,{+1@}
	ld a,(reuben_bottle3)
	and %00100000
	jp nz,_MoveKeyLoop
	ld a,(reuben_bottle3)
	or %00100000
	ld (reuben_bottle3),a
	xor a
	ld hl,switchInside
	call Speech
	jp _MoveKeyLoop
@:
	
	jp _MoveKeyLoop
_Move_Action_Boss:
	push bc ; save positions
		
		ld (hl),0 ; remove it
		
		call _Move_Grab_Tile_To_Sprite_Positions
		
		ld ix,sprites+($52*16)
		ld b,8
		call GraySpriteXOR
	pop bc
	
	ld a,(TileMapData)
	
	cp $0E ; golem ruins
	jr nz,{+1@}
	ld a,(reuben_bottle1)
	and %10000000
	jp nz,_MoveKeyLoop
	xor a
	ld hl,bossPage0E
	call Speech
	ld a,$06
	push bc
		call BattleEngine
		push af
			call ClrBackBuffers    ; re-draw the world
			call TileMap
		pop af
	pop bc
	cp 0
	jp nz,_MoveDie
	call _Move_Draw_Character
	xor a
	ld hl,bosswinPage0E
	call Speech
	ld a,(reuben_bottle1)
	or %10000000
	ld (reuben_bottle1),a
	jp _MoveKeyLoop
@:
	
	cp $2A ; beach
	jr nz,{+1@}
	ld a,(reuben_bottle2)
	and %00010000
	jp nz,_MoveKeyLoop
	xor a
	ld hl,bossPage2A
	call Speech
	ld a,$09
	push bc
		call BattleEngine
		push af
			call ClrBackBuffers    ; re-draw the world
			call TileMap
		pop af
	pop bc
	cp 0
	jp nz,_MoveDie
	call _Move_Draw_Character
	ld a,(reuben_bottle2)
	or %00010000
	ld (reuben_bottle2),a
	jp _MoveKeyLoop
@:
	jp _MoveKeyLoop
_Move_Golem_Ruins_Remove_Tile:
	ld a,(reuben_bottle2)
	and %01100000
	cp %01100000
	ret nz
	push bc
		ld a,5*8
		ld h,6*8
		ld b,8
		ld ix,sprites+($10*16)
		call GraySpriteXOR
	pop bc
	call _Move_Draw_Character
	ret



_Move_Is_Tile_Walkable:
;if carry is set then tile is walkable
;INPUT: a - tile
	ld hl,(walkableTiles)
	cp l
	ret
_Move_Grab_Tile_To_Sprite_Positions:
	ld a,e ; load the tilemap position
	
	ld h,$FF ; devide by 12 and store in h
	ld b,12
	inc h
	sub b
	jr nc,$-2
	
	add a,b ; xpos, mod 12
	add a,a
	add a,a
	add a,a
	ld b,a
	
	ld a,h
	add a,a
	add a,a
	add a,a
	ld h,a
	
	ld a,b
	ret
_Move_Grab_Tile:
;INPUT: d = x offset
;; e = y offset
;; bc = positions
;Returns: a = tile
;; de = tile in map
;; hl = tile pointer
	;push hl
	
	ld h,b
	ld l,c
	
	ld a,d ; calc x offset
	add a,h ; add current xpos
	ld b,3 ; devide by 8
	call ShiftR
	ld d,a ; save back
	
	
	ld a,e ; calc y offset
	add a,l ; add current ypos
	ld b,3 ; devide by 8
	call ShiftR
	ld e,a ; save back (needed for multiplying with 12)
	add a,a ; times 12
	add a,e
	add a,a
	add a,a
	
	add a,d ; add the x offset
	
	ld e,a ; load into de
	ld d,0
	
	
	ld b,h ; restore bc
	ld c,l
	
	ld hl,TileMapData+2 ; header offset
	add hl,de ; add the offset
	
	
	ld a,(hl) ; load the tile
	;pop hl
	ret

_MoveExit_Down:
	ld hl,TileMapData ; load new map
	ld a,(hl)
	ld c,11 ; we need to set c to 0 anyways
	add a,c
	ld (hl),a
	
	ld c,0 ; set c again
	xor a
	ret
_MoveExit_Left:
	ld hl,TileMapData ; load new map
	dec (hl)
	
	ld b,88 ; set b again
	xor a
	ret
_MoveExit_Right:
	ld hl,TileMapData ; load new map
	inc (hl)
	
	ld b,0 ; set b again
	xor a
	ret
_MoveExit_Up:
	ld hl,TileMapData ; load new map
	ld a,(hl)
	ld c,11 ; we need to set c to 0 anyways
	sub c
	ld (hl),a
	
	ld c,56 ; set c again
	xor a
	ret


_MoveExit_Dialog:
	push bc
		ld a,$40     ; make sure screen isn't rotated
		out ($10),a
		
		call Wait_Key_Release
		ld ix,PlotSScreen+(24*12)+4
		ld iy,AppBackUpScreen+(24*12)+4
		ld de,12-4+1
		ld a,%01111111
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		ld a,$FF
		ld b,2
		@:
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			djnz {-1@}
		ld a,%11111110
		ld (ix),a
		ld (iy),a
		add ix,de
		add iy,de
		
		ld b,14
		@:
			push bc
				ld a,%10000000
				ld (ix),a
				ld (iy),a
				inc ix
				inc iy
				xor a
				
				ld b,2
				@:
					ld (ix),a
					ld (iy),a
					inc ix
					inc iy
					djnz {-1@}
				
				ld a,%00000001
				ld (ix),a
				ld (iy),a
				add ix,de
				add iy,de
			pop bc
			djnz {-2@}
		
		ld a,%01111111
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		ld a,$FF
		ld b,2
		@:
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			djnz {-1@}
		ld a,%11111110
		ld (ix),a
		ld (iy),a
		
		ld b,39
		ld c,26
		ld hl,exitDialog
		ld a,1
		bcall(_Text)
		
		ld b,38
		ld c,33
		ld hl,exitYN
		ld a,1
		bcall(_Text)
		
		ld b,0
		_MoveExit_Loop:
			push bc
				ld a,b
				add a,a
				add a,b
				add a,a
				add a,a
				ld b,35
				add a,b
				
				ld h,34
				ld ix,_MoveExit_Cursor
				ld de,PlotSScreen
				ld b,3
				call PutSpriteXOR
				call Wait_Key_Input
				call Wait_Key_Release
			pop bc
			ld c,a
			push bc
				ld a,b
				add a,a
				add a,b
				add a,a
				add a,a
				ld b,35
				add a,b
				
				ld h,34
				ld ix,_MoveExit_Cursor
				ld de,PlotSScreen
				ld b,3
				call PutSpriteXOR
			pop bc
			
			ld a,c
			and %00000100 ; right
			jp nz,{+1@}
				ld a,1
				xor b
				ld b,a
			@:
			ld a,c
			and %00000010 ; left
			jp nz,{+1@}
				ld a,1
				xor b
				ld b,a
			@:
			ld a,c
			and %00100000 ; 2nd
			jp nz,_MoveExit_Loop
			ld a,b
	pop bc
	cp 0
	jr nz,_MoveExit
	
	call _Move_Draw_Character
	jp _MoveKeyLoop

_MoveExit_Cursor:
	.db %11000000,%11000000,%11000000

_MoveDie:
_MoveExit:
	ld a,$40     ; make sure screen isn't rotated
	out ($10),a
	
	ld a,1
	ret



ReubenSprites:
	.db $38,$7C,$FE,$FE,$7C,$7E,$FD,$E6, $38,$44,$82,$82,$6C,$56,$81,$FE
	.db $1C,$3E,$7F,$7F,$3E,$7E,$BF,$67, $1C,$22,$41,$41,$36,$6A,$81,$7F
	.db $3C,$7E,$FF,$FA,$69,$FA,$F4,$E4, $3C,$42,$8F,$BA,$69,$D2,$94,$FC
	.db $3C,$7E,$FF,$FA,$69,$F2,$EC,$C8, $3C,$42,$8F,$BA,$69,$D2,$AC,$F8
	.db $1C,$3E,$7F,$77,$55,$63,$BD,$E7, $1C,$22,$5D,$77,$55,$22,$A1,$FF
	.db $38,$7C,$FE,$EE,$AA,$C6,$BD,$E7, $38,$44,$BA,$EE,$AA,$44,$85,$FF
	.db $3C,$7E,$FF,$5F,$96,$4F,$37,$13, $3C,$42,$F1,$5D,$96,$4B,$35,$1F
	.db $3C,$7E,$FF,$5F,$96,$5F,$2F,$27, $3C,$42,$F1,$5D,$96,$4B,$29,$3F
ReubenSpritesSwim:
	.db $38,$7C,$FE,$FE,$7C,$10,$00,$00, $38,$44,$82,$82,$6C,$10,$00,$00
	.db $1C,$3E,$7F,$7F,$3E,$08,$00,$00, $1C,$22,$41,$41,$36,$08,$00,$00
	.db $00,$3C,$7E,$FF,$FA,$69,$1A,$00, $00,$3C,$42,$8F,$BA,$69,$12,$00
	.db $3C,$7E,$FF,$FA,$69,$12,$00,$00, $3C,$42,$8F,$BA,$69,$12,$00,$00
	.db $1C,$3E,$7F,$77,$55,$00,$00,$00, $1C,$22,$5D,$77,$55,$00,$00,$00
	.db $38,$7C,$FE,$EE,$AA,$00,$00,$00, $38,$44,$BA,$EE,$AA,$00,$00,$00
	.db $00,$3C,$7E,$FF,$5F,$96,$48,$00, $00,$3C,$42,$F1,$5D,$96,$48,$00
	.db $3C,$7E,$FF,$5F,$96,$48,$00,$00, $3C,$42,$F1,$5D,$96,$48,$00,$00
	
ReubenMasks:
	.db $C7,$83,$01,$01,$83,$EF,$FF,$FF
	.db $E3,$C1,$80,$80,$C1,$F7,$FF,$FF
	.db $FF,$C3,$81,$00,$01,$80,$E1,$FF
	.db $C3,$81,$00,$01,$80,$E1,$FF,$FF
	.db $E3,$C1,$80,$80,$80,$C1,$FF,$FF
	.db $C7,$83,$01,$01,$01,$83,$FF,$FF
	.db $FF,$C3,$81,$00,$80,$01,$87,$FF
	.db $C3,$81,$00,$80,$01,$87,$FF,$FF
