HouseSpeech:
	push bc
		ld de,(TileMapData)
		push de
			push hl
				xor a
				ld (TileMapData),a
				bcall(_LoadTileMap)
				call ClrBackBuffers
				call TileMap
				ld b,6*8
				ld c,6*8
				call _Move_Draw_Character
			pop hl
			ld a,1
			call Speech
		pop de
		ld (TileMapData),de
		bcall(_LoadTileMap)
		call ClrBackBuffers
		call TileMap
	pop bc
	ld a,(reuben_bottle1) ; reset tmp flag
	and %11101111
	ld (reuben_bottle1),a
	call _Move_Draw_Character
	ret
Speech:
; hl - speech pointer
; a - 1:top, 0:bottom ; 2nd bit: 0:reuben or 1:update?
	push bc
	push af
		ld a,$40     ; make sure screen isn't rotated
		out ($10),a
		call Wait_Key_Release
	_Speech_Loop:
	pop af
	push af
		and %00000001
		jr nz,{+1@} ; we want bottom
			ld ix,PlotSScreen+(12*(64-24))
			ld iy,AppBackUpScreen+(12*(64-24))
		jr {+2@}
		@:
			ld ix,PlotSScreen
			ld iy,AppBackUpScreen
		@:
		ld bc,12*24
		@:
			xor a
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			dec bc
			xor a
			or b
			or c
			jr nz,{-1@}
		
	pop af
	push af
		and %00000001
		jr nz,{+1@} ; we only need to change stuff on bottom
			ld ix,PlotSScreen+(12*(64-25))
			ld iy,AppBackUpScreen+(12*(64-25))
		@:
		ld b,12
		ld a,$FF
		@:
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			djnz {-1@}
		
	pop af
	push af
		and %00000001
		jr nz,{+1@}
			ld bc,$0029
		jr {+2@}
		@:
			ld bc,$0000
		@:
		ld a,2
		bcall(_Text)
		cp 0
		jr z,_Speech_Exit
		ld b,a
	pop af
	push af
		and %00000001
		jr nz,{+1@}
			ld ix,PlotSScreen+(60*12)+11
		jr {+2@}
		@:
			ld ix,PlotSScreen+(20*12)+11
		@:
		ld a,b
		ld de,12
		cp $fe
		jr nz,{+1@} ;  \r, arrow down
			ld a,(ix)
			or %01111110
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00111100
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00011000
			ld (ix),a
		jr {+2@}
		@:          ; \b, quit thingy
			ld a,(ix)
			or %00111100
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %01111110
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00111100
			ld (ix),a
		@:
		
		call Wait_Key_Release
		call Wait_Key_Input
		call Wait_Key_Release
		
		jp _Speech_Loop
_Speech_Exit:
	pop af
	and %00000010
	jr nz,{+1@}
	pop bc
	call _Move_Draw_Character
	ret
	@:
	call Update
	pop bc
	ret