Shop:
	push bc
		call Wait_Key_Release
	_Shop_Draw:
		ld hl,PlotSScreen
		call ClrBuffer
		ld hl,AppBackUpScreen
		call ClrBuffer
		
		ld hl,reuben_bottle1
		ld de,tmpBottles
		ld bc,4
		ldir
		
		push iy
		pop hl
		ld de,reuben_bottle1
		ld bc,4
		ldir
		
		ld bc,$2C1B
		ld h,0
		ld l,(iy+4)
		ld a,1
		push iy
			bcall(_NumText)
		pop iy
		
		ld bc,$2C21
		ld h,0
		ld l,(iy+5)
		ld a,1
		push iy
			bcall(_NumText)
		pop iy
		
		ld bc,$2C27
		ld h,0
		ld l,(iy+6)
		ld a,1
		push iy
			bcall(_NumText)
		pop iy
		
		ld bc,$2C2D
		ld h,0
		ld l,(iy+7)
		ld a,1
		push iy
			bcall(_NumText)
		pop iy
		
		push iy
			ld bc,$00
			xor a
			ld hl,shopDialog
			bcall(_Text)
			
			ld bc,$0435          ; gold
			ld hl,GoldColon
			ld a,1
			bcall(_Text)
			ld bc,$1835
			ld hl,(reuben_gold)
			ld a,1
			bcall(_NumText)
			
			call PickItem
		
		pop iy
		push bc
			ld hl,tmpBottles
			ld de,reuben_bottle1
			ld bc,4
			ldir
		pop bc
		cp 4
		jr z,_Shop_Bye_No_Buying
		
		ld e,(iy+7)
		cp 0
		jr nz,{+1@}
			ld e,(iy+4)
		@:
		cp 1
		jr nz,{+1@}
			ld e,(iy+5)
		@:
		cp 2
		jr nz,{+1@}
			ld e,(iy+6)
		@:
		; we don't have to check for the last one as we set 15 as default b
		ld hl,(reuben_gold)
		ld d,0
		or a
		sbc hl,de
		jr c,_Shop_Not_Enough_Money
		push bc
		push iy
			ld (reuben_gold),hl
			
			@:
				ld hl,PlotSScreen
				call ClrBuffer
				ld hl,AppBackUpScreen
				call ClrBuffer
				
				ld bc,$0000
				ld hl,shopPickBottle
				xor a
				bcall(_Text)
				
				call PickItem
				cp 4
				jr z,{-1@} ; we /need/ a bottle in this case
			
			ld a,(hl)
		pop iy
		pop bc
		and %11111000
		or c
		ld (hl),a
		ld hl,shopBuy
		ld a,3
		push iy
			call Speech
		pop iy
		jp _Shop_Draw
_Shop_Bye_No_Buying:
		ld a,3
		ld hl,shopBye
		call Speech
	pop bc
	call _Move_Draw_Character
	ret
_Shop_Not_Enough_Money:
	ld a,3
	ld hl,shopNotEnoughMoney
	push iy
		call Speech
	pop iy
	jp _Shop_Draw
_Shop_Bottles_Natoria:
	.db %00001010,%00001100,%00001110,%00001111
_Shop_Prices_Natoria:
	.db 10,50,25,15
_Shop_Bottles_Rosa:
	.db %00001011,%00001100,%00001101,%00001111
_Shop_Prices_Rosa:
	.db 20,50,150,15

PickItem:
; returns : a - bottle num (4 on del key)
;           b - bottle content
;          hl - bottle pointer
	ld ix,PlotSScreen+(25*12)+7 ; draw the outer box
	ld iy,AppBackUpScreen+(25*12)+7
	xor a        ; top line
	or $3F
	ld (ix),a
	ld (iy),a
	inc ix
	inc iy
	ld b,3
	@:
		or $FF
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	xor a
	or $FE
	ld (ix),a
	ld (iy),a
	
	               ; side lines
	ld de,08
	add ix,de
	add iy,de
	ld b,26
	@:
		push bc
			ld a,$40
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			ld b,3
			@:
				xor a
				ld (ix),a
				ld (iy),a
				inc ix
				inc iy
				djnz {-1@}
		pop bc
		ld a,$01
		ld (ix),a
		ld (iy),a
		add ix,de
		add iy,de
		djnz {-2@}
	
	xor a        ; bottom line
	or $3F
	ld (ix),a
	ld (iy),a
	inc ix
	inc iy
	ld b,3
	@:
		xor a
		or $FF
		ld (ix),a 
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	xor a
	or $FE
	ld (ix),a
	ld (iy),a
	
	
	ld b,4 ; 4 bottles
	@:
		push bc
		
		ld hl,reuben_bottle1 - 1   ; -1 as b is always one "too high"
		ld d,0
		ld e,b
		add hl,de
		ld a,(hl)
		ld c,a
		and %00001000
		jr z,{+2@}                 ; do we have the bottle at all?
			ld a,c
			and %00000111
			push af
				xor a
				@:
					add a,6
					djnz {-1@}     ; b is already set from the other djnz
				sub 6
				add a,$1B
				ld c,a
			pop af
			
			ld h,0
			ld l,a
			ld b,8
			call Multiply
			ld de,Item0
			add hl,de
			
			ld b,$43
			ld a,1
			bcall(_Text)
		@:
		
		pop bc
		djnz {-3@}
	ld b,0                          ; default bottle is 0
	_PickItem_Loop:  ; hand loop
		push bc
			ld a,b                  ; draw hand
			add a,a  ; b (cur pos) times 6
			add a,b
			add a,a
			add a,$1B ; add initial thingy
			ld h,a
			ld a,$3B
			ld b,5
			ld ix,Hand_Sprite
			ld de,PlotSScreen
			call PutSpriteXOR
			
			call Wait_Key_Input
			call Wait_Key_Release
		pop bc
		ld c,a
		push bc
			ld a,b                  ; erase hand
			add a,a  ; b (cur pos) times 6
			add a,b
			add a,a
			add a,$1B ; add initial thingy
			ld h,a
			ld a,$3B
			ld b,5
			ld ix,Hand_Sprite
			ld de,PlotSScreen
			call PutSpriteXOR
		pop bc
		ld d,0 ; we are in the normal menu, in the case of an exit
		ld a,c
		and %10000000             ; exit
		jp z,_PickItem_Exit
		
		ld a,c
		and %00000001             ; down
		jp nz,{+1@}
		inc b
	@:
		
		ld a,c
		and %00001000             ; up
		jr nz,{+1@}
		dec b
	@:
		
		; get b correctly
		ld a,b
		cp $FF
		jr nz,{+1@}
		inc b
	@:
		cp $04
		jr nz,{+1@}
		dec b
	@:
		
		ld a,c
		and %00100000            ; 2nd key
		jr z,{+1@}
		jr _PickItem_Loop
@:                 ; pick bottle, offset is in b
	ld hl,reuben_bottle1 ; this time b is offsetted correctly
	ld d,0
	ld e,b
	add hl,de
	ld a,(hl)
	
	ld c,a
	and %00001000 ; we don't have the bottle
	jr z,_PickItem_Loop
	ld a,c
	and %00000111
	ld c,a
	ld a,b
	ld b,c
	ret
_PickItem_Exit:
	ld a,4 ; bottle doesn't exist
	ret

StatsMenu:
	ld a,$40     ; make sure screen isn't rotated
	out ($10),a
	
	ld hl,PlotSScreen
	call ClrBuffer
	ld hl,AppBackUpScreen
	call ClrBuffer
	
	ld ix,PlotSScreen
	ld iy,AppBackUpScreen
	
	ld a,%01111111
	ld (ix),a
	ld (iy),a
	inc ix
	inc iy
	ld b,10
	ld a,$FF
	@:
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	ld a,%11111110
	ld (ix),a
	ld (iy),a
	inc ix
	inc iy
	ld de,11
	ld b,64-2
	@:
		ld a,%10000000
		ld (ix),a
		ld (iy),a
		add ix,de
		add iy,de
		ld a,%00000001
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	
	ld a,%01111111
	ld (ix),a
	ld (iy),a
	inc ix
	inc iy
	ld b,10
	ld a,$FF
	@:
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	ld a,%11111110
	ld (ix),a
	ld (iy),a
	
	ld ix,PlotSScreen+(26*12)
	ld iy,AppBackUpScreen+(26*12)
	ld b,7
	@:
		ld a,(ix)
		cpl
		ld (ix),a
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	
	
	ld bc,$0402
	ld hl,locationColon
	ld a,1
	bcall(_Text)
	
	ld b,12
	ld a,(TileMapData+1)
	and $0F
	ld h,0
	ld l,a
	call Multiply
	ld de,Area0
	add hl,de
	ld bc,$1402
	ld a,1
	bcall(_Text)
	
	
	ld a,(reuben_bottle1)
	and %10000000
	jr z,{+1@}
		ld bc,$0408
		ld hl,powerGlove
		ld a,1
		bcall(_Text)
	@:
	ld a,(reuben_bottle1)
	and %01000000
	jr z,{+1@}
		ld bc,$040E
		ld hl,swimSuit
		ld a,1
		bcall(_Text)
	@:
	ld a,(reuben_bottle1)
	and %00100000
	jr z,{+1@}
		ld bc,$0414
		ld hl,hammer
		ld a,1
		bcall(_Text)
	@:
	
	
	ld bc,$041C         ; level
	ld hl,LevelColon
	ld a,1
	bcall(_Text)
	ld bc,$1C1C
	ld hl,(reuben_lvl)
	ld h,0
	ld a,1
	bcall(_NumText)
	
	ld bc,$0423         ; hp
	ld hl,HPColon
	ld a,1
	bcall(_Text)
	ld bc,$1023
	ld hl,(reuben_hp)
	ld a,1
	bcall(_NumText)
	ld bc,$1C23
	ld hl,Slash
	ld a,1
	bcall(_Text)
	ld bc,$2023
	ld hl,(reuben_maxhp)
	ld a,1
	bcall(_NumText)
	
	ld bc,$042A         ; mp
	ld hl,MPColon
	ld a,1
	bcall(_Text)
	ld bc,$102A
	ld hl,(reuben_mp)
	ld h,0
	ld a,1
	bcall(_NumText)
	ld bc,$1C2A
	ld hl,Slash
	ld a,1
	bcall(_Text)
	ld bc,$202A
	ld hl,(reuben_maxmp)
	ld h,0
	ld a,1
	bcall(_NumText)
	
	ld bc,$0431          ; gold
	ld hl,GoldColon
	ld a,1
	bcall(_Text)
	ld bc,$1831
	ld hl,(reuben_gold)
	ld a,1
	bcall(_NumText)
	
	ld bc,$0438          ; next
	ld hl,NextColon
	ld a,1
	bcall(_Text)
	ld bc,$1838
	ld a,(reuben_lvl)
	cp 20
	jr z,{+1@}
		ld hl,(reuben_nextexp)
		ld de,(reuben_exp)
		or a
		sbc hl,de
		ld a,1
		bcall(_NumText)
		jr {+2@}
	@:
		ld hl,minusminus
		ld a,1
		bcall(_Text)
	@:
	ld a,$12
	ld bc,$4B05
	ld e,0
	bcall(_PutBigSpriteXOR)
	call PickItem
	cp 4
	jr z,_StatsMenu_Exit
	
	ld a,(hl)
	and %11111000
	ld (hl),a
	ld a,c
	cp 1        ; water
	jr nz,{+1@}
	ld hl,300
	call _Battle_Player_Add_Hp
	jp StatsMenu
@:
	cp 2        ; herb
	jr nz,{+1@}
	ld hl,600
	call _Battle_Player_Add_Hp
	jp StatsMenu
@:
	cp 3        ; potion
	jr nz,{+1@}
	ld hl,999
	call _Battle_Player_Add_Hp
	jp StatsMenu
@:
	cp 4        ; gigseng
	jr nz,{+1@}
	ld b,50
	call _Battle_Player_Add_Mp
	jp StatsMenu
@:
	cp 5        ; elixir
	jr nz,{+1@}
	ld hl,(reuben_maxhp)
	ld (reuben_hp),hl
	ld a,(reuben_maxmp)
	ld (reuben_mp),a
	jp StatsMenu
@:
	; if you use fire you just wasted your item
	; if you used pure you just wasted your item
	jp StatsMenu
_StatsMenu_Exit:
	ret